//------------------------------------------------------------------
//
// Keyboard  键盘管理
//
//------------------------------------------------------------------
var KeyboardMgr = cc.Layer.extend({
    ctor: function () {
        this._super();
        this.init();
    },

    init: function () {
        this._super();
        console.log("KEYBOARD init");

        if ('keyboard' in cc.sys.capabilities) {
            cc.eventManager.addListener(
                {
                    event: cc.EventListener.KEYBOARD,
                    onKeyPressed: function (keycode, event) {
                        console.log("KEYBOARD onKeyPressed:" + keycode);

                        var ret = KeyboardMgr.getMe().onKeyPressed(keycode);
                        if (ret == false) {
                            uiMgr.getMe().onKeyPressed(keycode);
                        }
                    },
                    onKeyReleased: function (keycode, event) {
                        console.log("KEYBOARD onKeyReleased:" + keycode);
                        uiMgr.getMe().onKeyReleased(keycode);
                    }
                }, this);
        } else {
            console.log("KEYBOARD Not supported");
        }


    },

    onKeyPressed: function (keycode) {


        switch (keycode) {
            case cc.KEY.f2:
                if(fileMgr.getMe().m_xiangsu_info["root"]["pcfabu"]){
                    return false;
                }
                uiMgr.getMe().show_ui_selectScene(true);
                return true;
                break;

            default:
                break;
        }

        return false;
    },

    onKeyReleased: function (keycode) {
        return false;
    },

    subtitle: function () {
        return "Keyboard test. Press keyboard and see console";
    },


    loop: function (t) {
    }


});


KeyboardMgr.getMe = function () {
    return KeyboardMgr.create();
};

KeyboardMgr.create = function () {
    if (KeyboardMgr.g_KeyboardMgr == null) {
        KeyboardMgr.g_KeyboardMgr = new KeyboardMgr();
        return KeyboardMgr.g_KeyboardMgr;
    }
    else {
        return KeyboardMgr.g_KeyboardMgr;
    }

};

