/**
 * Created by cy1234 on 2016/6/3.
 */

//怪物攻击波次管理  维护者 ： 魏

//怪物攻击状态类型
g_monsterAttType =
{

    e_Type_att: 1, //怪物攻击状态
    e_Type_fangshou: 0//防守状态
}

var monsterAttMgr = cc.Class.extend({
    m_first_boci: true, //第一次怪物攻击会弹窗
    ctor: function () {

    },

    //一回合结束重置分支战斗次数
    reset_fight_count: function () {
        //更新
        var sceneslist = DataMgr.getMe().getPlayDoc()["scenes"];
        for (var p in sceneslist) {
            var scene_child = sceneslist[p];
            for (var pchild in scene_child) {
                var fight_count = scene_child[pchild]["fight_count"];
                if (fight_count) {
                    scene_child[pchild]["fight_count"] = 0;
                }
            }
        }

    },

    //ref 是否刷新
    initMap: function (ref) {
        var mapFight_type = fileMgr.getMe().m_play_doc["mapFight"]["mapFight_type"];
        var monster_boci = fileMgr.getMe().m_play_doc["mapFight"]["monster_boci"]; //怪物波次

        if (mapFight_type == 1) {
            if (monster_boci > 0) {
                return;
            }
        }

        if (mapFight_type == 0) {
            if (this.playCanAtt() == true) {
                return;
            }
        }

        this.initMapEx(ref);

        mapFight_type = fileMgr.getMe().m_play_doc["mapFight"]["mapFight_type"];
        if (mapFight_type == 1) {

            uiMgr.getMe().show_ui_MessageBox2(true, "您拥有的英雄没有出战点数了，现在进入敌方回合！", this.create_yindao, this);

        }

    },

    create_yindao: function () {
        //引导 -关卡地图怪物进攻提示
        if(!yindaoMgr.getMe().createyindaoByType(g_yindaoType.yindaoType_GUANKA2)){
            uiMgr.getMe().show_ui_difanghuihetexiao(true);
        }

    },

    initMapEx: function (ref) {
        var mapFight_type = fileMgr.getMe().m_play_doc["mapFight"]["mapFight_type"];
        var monster_boci = fileMgr.getMe().m_play_doc["mapFight"]["monster_boci"]; //怪物波次

        if (mapFight_type == 0) {
            this.resetMonsterData();//进入怪物攻击模式
            //this.m_first_boci = true;
        }
        else if (mapFight_type == 1) {
            this.resetPlayData();

            uiMgr.getMe().show_ui_zhanlingjiangli(true);
        }

        //刷新map
        if (ref == null) {
            ref = false;
        }

        if (ref == true) {
            if (ui_map.getMe() != null) {
                uiMgr.getMe().show_ui_map(false);
                uiMgr.getMe().show_ui_map(true);
            }
        }

    },

//0 玩家攻击状态 1 ：怪物攻击状态
    getMapFightType: function () {
        var _mapFight_type = fileMgr.getMe().m_play_doc["mapFight"]["mapFight_type"];


        return _mapFight_type;
    },

    getMonsterAttType: function () {
        var mapFight_type = fileMgr.getMe().m_play_doc["mapFight"]["mapFight_type"];
        if (mapFight_type == 1) {
            return g_monsterAttType.e_Type_att;
        }
        else if (mapFight_type == 0) {
            return g_monsterAttType.e_Type_fangshou;
        }
    },


//重置数据 怪物攻击 波次

    resetMonsterData: function () {

        var per_scene_1_2_config = DataMgr.getMe().getScenePer("scene_1_2_config");
        if (per_scene_1_2_config < 50)
        {

            uiMgr.getMe().show_ui_MessageBox2( true , "你太弱了，敌人都不忍心攻击你了！" );

            //

            this.resetPlayData();
            //uiMgr.getMe().
            return;
        }

        fileMgr.getMe().m_play_doc["mapFight"]["mapFight_type"] = 1;
        var par = DataMgr.getMe().getAllScenePer();
        fileMgr.getMe().m_play_doc["mapFight"]["monster_boci"] = g_sceneMonsterAtt[par]["monster_boci"];

    },

//重置数据 玩家攻击 波次
    resetPlayData: function () {

        fileMgr.getMe().m_play_doc["mapFight"]["mapFight_type"] = 0;
        var heros = fileMgr.getMe().m_play_doc["heros"];
        for (var p in heros) {
            heros[p]["jinggong_num"] = g_playhero[p]["jinggong_num"];
            heros[p]["fangshou_num"] = g_playhero[p]["fangshou_num"];
        }
        //
        this.reset_fight_count();
        //
    },

    getCurBoci: function () {
        return fileMgr.getMe().m_play_doc["mapFight"]["monster_boci"];
    },

    playCanAtt: function () {
        var heros = fileMgr.getMe().m_play_doc["heros"];
        var gongji_num_all = 0;
        for (var p in heros) {
            if (!DataMgr.getMe().getHeroIsLocked(p)) {
                gongji_num_all += heros[p]["jinggong_num"];
            }
        }
        if (gongji_num_all > 0) {
            return true;
        }

        return false;
    },


    creatBociScene: function (scenename) {

    },

    //扣除怪物波次
    addmonsterBoci: function (val) {
        var boci = fileMgr.getMe().m_play_doc["mapFight"]["monster_boci"];//
        boci = boci + val;
        if (boci < 0)
            boci = 0;

        fileMgr.getMe().m_play_doc["mapFight"]["monster_boci"] = boci;

    },


    //防守关卡 怪物赢了 扣除关卡占有度
    monsterAtt_Over: function (scenename, monsterwin) {
        this.addmonsterBoci(-1);
        if (monsterwin == true) {
            var val = fileMgr.getMe().m_play_doc["fangshou_dead_zhanling_per"];
            DataMgr.getMe().addScenePer(scenename, -val);
        }

        //if (this.getCurBoci() <= 0)
        //{
        //    this.initMap(true);
        //}

    }
    //
});

monsterAttMgr.getMe = function () {
    return monsterAttMgr.create();
};

monsterAttMgr.create = function () {
    if (monsterAttMgr.g_monsterAttMgr == null) {
        monsterAttMgr.g_monsterAttMgr = new monsterAttMgr();
        return monsterAttMgr.g_monsterAttMgr;
    }
    else {
        return monsterAttMgr.g_monsterAttMgr;
    }

};







