/**
 * Created by cy1234 on 2016/5/3.
 */

//
// 角色战斗cd计算
//

var MyAction_FightUI_MoveTo = cc.Class.extend({
    m_actionTo: null,
    m_obj: null,
    m_des_time: null,

    m_posmoveto: null,//结束位置
    m_posStart: null, //开始位置

    m_funcCallback: null,

    _curPosition: null, //当前位置

    m_speed: 0,
    m_len: 0,
    m_roleObj: null,

    ctor: function (roleObj) {
        this.m_roleObj = roleObj;
        this._curPosition = cc.p(0, 0);
    },

    oninit: function (node, t, posStart, posmoveto, funcCallback) {
        this.m_obj = node;
        this.m_obj.loadTexture(this.m_roleObj.getMoveHeadIcon());

        this.m_posmoveto = posmoveto;
        this.m_posStart = posStart;

        this.m_posmoveto.y = this.m_posStart.y = 0;
        this.m_funcCallback = funcCallback;

        this._curPosition.x =  this.m_posStart.x;
        this._curPosition.y =  this.m_posStart.y;

        this.len = this.m_posmoveto.x - this.m_posStart.x;

        this.updateSpeed();
    },

    updateSpeed: function () {
        this.m_des_time = this.m_roleObj.getOutCd();
        this.m_speed = this.len /this.m_des_time;
        return this.m_speed;
    },


    callback: function () {
        this.m_funcCallback.execute();
        this.oninit(this.m_obj, this.m_roleObj.getOutCd(), this.m_posStart, this.m_posmoveto, this.m_funcCallback);
    },

    loop: function (t) //暂停
    {
        if(roleMgr.getMe().isFight())
        {
            return;
        }

        if (rootScene.getMe()._zanting_fightcd == true)
            return;


        if (rootScene.getMe().iszanting())
            return;
        this.update(t);
    },

    dead: function () {
        if (this.m_roleObj.isdead()) {
            this.m_obj.setVisible(false);
        }
        else {
            this.m_obj.setVisible(true);
        }
    },

    update_icon: function () {
        if ( this.m_obj )
        {
            if ( this.m_roleObj.isCDFull() )
            {
                var _yidong_uitexiao = ccui.helper.seekWidgetByName( this.m_obj, "uitexiao" );
                _yidong_uitexiao.setVisible( true );
            }
            else
            {
                var _yidong_uitexiao = ccui.helper.seekWidgetByName( this.m_obj, "uitexiao" );
                _yidong_uitexiao.setVisible(false);
            }
        }
    },
    update: function (dt) {

        if (roleMgr.getMe().isMonsterAllDead()) {
            return;
        }

        if (roleMgr.getMe().isPlayerAllDead()) {
            return;
        }

        if(this.m_roleObj.getCurStateType() == AiType.AiType_bishaji)
        {
            return;
        }

        if (MyAction_FightUI_MoveTo.g_zhanting == false) {
            return;
        }

        if ( this.m_roleObj.isXuanYun() == true ) {
            return;
        }



        this.updateSpeed();

        if ( this.m_obj )
        {

            if ( cc.pDistance( this._curPosition , this.m_posmoveto) < 1 )
            {
                this.callback();
                return;
            }

            this._curPosition.x = this._curPosition.x +  this.m_speed * dt;

            if(this.m_posmoveto.x <  this._curPosition.x)
            {
                this._curPosition.x = this.m_posmoveto.x;
            }

            var y = this.m_obj.getPosition().y;//
//设置位置
            this.m_obj.setPosition(this._curPosition.x , y);

        }
    }

});

MyAction_FightUI_MoveTo.setzhanting = function (flag) {
    MyAction_FightUI_MoveTo.g_zhanting = falg;//全局的
};


MyAction_FightUI_MoveTo.create = function () {
    MyAction_FightUI_MoveTo.g_zhanting = false;
    return new MyAction_FightUI_MoveTo();
};


