/**
* Created by cy1234 on 2016/5/3.
*/

//我们的回掉管理类】

MyCallback = cc.Class.extend({
    _selectorTarget: null,
    _function: null,
    _data: null,


    ctor: function (selector, selectorTarget, data) {
        //cc.FiniteTimeAction.prototype.ctor.call(this);
        this.initWithFunction(selector, selectorTarget, data);
    },


    initWithFunction: function (selector, selectorTarget, data) {
        if (selector) {
            this._function = selector;
        }
        if (selectorTarget) {
            this._selectorTarget = selectorTarget;
        }
        if (data !== undefined) {
            this._data = data;
        }
        return true;
    },

    /**
     * execute the function.
     */
    execute: function ()
    {
        if (this._function)
        {
            this._function.call(this._selectorTarget, this.target, this._data);
        }
    },

});

MyCallback.create = function (selector, selectorTarget, data) {
    return new MyCallback(selector, selectorTarget, data);
};


