/**
 * Created by cy1234 on 2016/4/30.
 */

//buff sys

var baseBuff = cc.Class.extend({
    m_data: null,
    m_buffdata: null,
    m_type: null,
    _isStop: false,
    m_buffMgr: null,
    m_Owner_roleBase: null, //释放buff 的role
    m_Owner_roleBase_Skill: null,//buff 释放者技能info
    m_target: null, //目标
    m_per: 0, //百分比

    ctor: function (_Owner, receiver, buffObj, type, buffmgr, killMonsterNum) {

        if (_Owner == null) {
            console.error("baseBuff _Owner");
        }
        if (receiver == null) {
            console.error("baseBuff receiver");
        }
        if (buffObj == null) {
            console.error("baseBuff buffObj");
        }
        if (type == null) {
            console.error("baseBuff type");
        }
        if (buffmgr == null) {
            console.error("baseBuff buffmgr");
        }
        this.m_Owner_roleBase = _Owner;//释放buff 的role
        this.m_Owner_roleBase_Skill = cc.clone(_Owner.getCurSkill()); //
        this.m_type = type; //
        this.m_buffMgr = buffmgr; //
        this.m_buffdata = cc.clone(buffObj); //复制object
        this.m_target = receiver; //接受buff 的role
        if (killMonsterNum <= 1) {
            this.m_data = this.m_buffdata["single"]; //
        }
        else {
            this.m_data = this.m_buffdata["attAll"]; //
        }

        this.m_per = this.getDataVal2();
        this.init();

        if (this.m_type == g_buffType.buffType_xuanyunBuff
            || this.m_type == g_buffType.buffType_xuanyunBuff2
            || this.m_type == g_buffType.buffType_addhpBuff
            || this.m_type == g_buffType.buffType_addhpBuff_time
        ) {

        }
        else {
            this.addHuihe();
        }


    },

    init: function () {
        if (this.m_buffdata.buffTexiao != "") {
            spineMgr.getMe().createSpineOncePlay("texiao", this.m_buffdata.buffTexiao, this.getTarget(), null, this.getTarget().getLocalZOrder() + 23);
        }
    },

    //释放buff 的role
    getOwner: function () {
        return this.m_Owner_roleBase;
    },

    getOwnerSkillLevel: function () {
        if (this.m_Owner_roleBase.m_baseRoleType == g_baseRoleType.type_play) {
            if (this.m_Owner_roleBase_Skill["level"] == null) {
                if (this.m_Owner_roleBase_Skill["bufflevel"] == null) {
                    return 1;
                }
                else {
                    return this.m_Owner_roleBase_Skill["bufflevel"];
                }
            }
            return this.m_Owner_roleBase_Skill.level;

        }
        else if (this.m_Owner_roleBase.m_baseRoleType == g_baseRoleType.type_monster) {
            if (sceneMgr.getMe().getCurSceneInfo().sceneLevel > 6) {
                uiMgr.getMe().show_ui_MessageBox(true, "场景等级不能超过6等级");
                return 6;
            }

            return sceneMgr.getMe().getCurSceneInfo().sceneLevel;
        }
    },

    // 回合数
    getDataHuihe: function () {

        var ret = this.m_data["level"][this.getOwnerSkillLevel()];

        if (ret == null) {
            return 0;
        }
        return this.m_data["level"][this.getOwnerSkillLevel()].val1;

    },
    addHuihe: function () {
        if (this.m_data["level"][this.getOwnerSkillLevel()].val1 == null) {
            return;
        }
        this.m_data["level"][this.getOwnerSkillLevel()].val1 = this.getDataHuihe() + 1;
    },
    removeHuihe: function () {
        if (this.m_data["level"][this.getOwnerSkillLevel()].val1 == null) {
            return;
        }
        this.m_data["level"][this.getOwnerSkillLevel()].val1 = this.getDataHuihe() - 1;
    },

    // 加的数值 ， 或者*的数值
    getDataVal2: function () {
        if (this.m_data["level"][this.getOwnerSkillLevel()] == null) {
            uiMgr.getMe().show_ui_MessageBox("buff 表填错！");
            return 0;
        }

        if (this.m_data["level"][this.getOwnerSkillLevel()].val2 == null) {
            uiMgr.getMe().show_ui_MessageBox("buff 表填错！val2 没有");
            return 0;
        }


        return this.m_data["level"][this.getOwnerSkillLevel()].val2;
    },

    getDataVal3: function () {
        return this.m_data["level"][this.getOwnerSkillLevel()].val3;
    },

    //被释放者
    getTarget: function () {
        //return this.m_buffMgr.m_hero_obj;
        return this.m_target;
    },

    loop: function (t) {
        return this.isStop();
    },

    shutdown: function () {
        //this.skillStart();

    },

    isStop: function () {
        if (this.getDataHuihe() <= 0)
            return true;
        return false;
    },

    getVal: function () //获得增加的数值
    {

    },

    skillStart: function () //技能的开始的时刻被调用
    {
        this.removeHuihe();
    },

    skillEnd: function () //技能的结束的时刻被调用
    {
    },

});

//恢复生命
var addhpBuff = baseBuff.extend({

        m_baddhp: false,
        ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
            this._super(_Owner, receiver, buffObj, g_buffType.buffType_addhpBuff, buffmgr, killMonsterNum);
        }
        ,
        init: function () {

            //this.getTarget().addHp(this.getVal());
            this._super();

            this.skillStart();
        }
        ,
        loop: function (t) {
            return this._super(t);
        }
        ,
        getVal: function () //获得增加的数值
        {
            return this.getOwner().getOutAtt() * this.m_per;
        }
        ,

        skillStart: function () //技能的开始的时刻被调用
        {
            if (this.m_baddhp == true) {
                return;
            }
            this.m_baddhp = true;
            this.getTarget().addHp(this.getVal());
            this._super();
        }
        ,

    })
    ;

var addhpBuff_time = baseBuff.extend({

    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_addhpBuff_time, buffmgr, killMonsterNum);
    },

    addHp: function () //获得增加的数值
    {
        var ret = this.getVal();
        this.getTarget().addHp(ret);
    },
    getVal: function () //获得增加的数值
    {
        if (this.m_Owner_roleBase.getType() == g_baseRoleType.type_play) {
            return this.getOwner().getBaseAtt() * this.m_per;
        }
        else {
            var attper = sceneMgr.getMe().getCurSceneInfo().attper;
            return this.getOwner().getBaseAtt() * attper * this.m_per;
        }

        return 0;

    },

    skillStart: function () //技能的开始的时刻被调用
    {
        this._super();
        this.addHp();
    },
});


//眩晕敌人
var xuanyunBuff = baseBuff.extend({
    m_xunyuntime: 0,
    m_spineControl_texiao: null,
    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_xuanyunBuff, buffmgr, killMonsterNum);
    },

    init: function () {
        if (this.m_buffdata.buffTexiao != "") {
            this.m_spineControl_texiao = spineMgr.getMe().createSpineControl("texiao", this.m_buffdata.buffTexiao, this.getTarget(), null, this.getTarget().getLocalZOrder() + 23);
        }

        this.getTarget().setxunyun(true);

        this.m_xunyuntime = this.getDataHuihe() * this.getTarget().getOutCd() * 1;
    },

    loop: function (t) {

        if (roleMgr.getMe().isFight()) {
            return;
        }
        this.m_xunyuntime -= t;
        if (this.m_xunyuntime < 0) {
            this.removeHuihe();
        }
        return this.isStop();
    },

    shutdown: function () {
        if (this.m_spineControl_texiao) {
            this.m_spineControl_texiao.shutdown();
        }
        this.getTarget().setxunyun(false);
    },
    skillStart: function () //技能的开始的时刻被调用
    {

    },

});

var xuanyunBuff2 = baseBuff.extend({

    m_xunyuntime: 0,
    m_spineControl_texiao: null,
    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_xuanyunBuff2, buffmgr, killMonsterNum);
    },

    init: function () {
        var xunranperran = cc.random0To1() * 100;
        if (xunranperran > this.m_per) {
            this._isStop = true;
            return;
        }

        if (this.m_buffdata.buffTexiao != "") {
            this.m_spineControl_texiao = spineMgr.getMe().createSpineControl("texiao", this.m_buffdata.buffTexiao, this.getTarget(), null, this.getTarget().getLocalZOrder() + 23);
        }
        this.getTarget().setxunyun(true);
        this.m_xunyuntime = this.getDataHuihe() * this.getTarget().getOutCd() * 1;
    },


    loop: function (t) {

        if (roleMgr.getMe().isFight()) {
            return;
        }

        if (this._isStop == true) {
            return true;
        }

        this.m_xunyuntime -= t;
        if (this.m_xunyuntime < 0) {
            this.removeHuihe();
        }
        return this.isStop();
    },

    shutdown: function () {
        if (this.m_spineControl_texiao) {
            this.m_spineControl_texiao.shutdown();
        }
        this.getTarget().setxunyun(false);
    },
    skillStart: function () //技能的开始的时刻被调用
    {

    },

});


var fuhuo = baseBuff.extend({

    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_fuhuo, buffmgr, killMonsterNum);
    },

    init: function () {
        this._super();
        //复活队友
        var teammap = this.m_Owner_roleBase.getTeam_dead();
        teammap.each(function (k, data) {
            data.fuhuo();
        }, this);
    }

});


//全队增加攻击与闪避

//闪避增加
var addMissBuff = baseBuff.extend({

    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_addMissBuff, buffmgr, killMonsterNum);
    },
    init: function () {
        this._super();

    },
    shutdown: function () {
        this._super();
    },


    getVal: function () {
        return this.m_per * 100;
    },

    shutdown: function () {
        this.m_per = 0;
    },


});

//减敌人速 (释放给敌人的)
var removeSpeedBuff = baseBuff.extend({
    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_removeSpeedBuff, buffmgr, killMonsterNum);
    },
    init: function () {
        this._super();
        spineMgr.getMe().createSpineOncePlay("texiao", "jiansu", this.getTarget(), null, this.getTarget().getLocalZOrder() + 23);

    },


    getVal: function () {
        return this.m_per;
    },

    shutdown: function () {
        this.m_per = 0;
    },


});
//加自己速
var addSpeedBuff = baseBuff.extend({

    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_addSpeedBuff, buffmgr, killMonsterNum);
    },
    init: function () {
        this._super();
    },

    getVal: function () {
        return this.m_per;
    },

    shutdown: function () {
        this.m_per = 0;
    },


});


//减敌人防御 (释放给敌人的)
var removeDefenseBuff = baseBuff.extend({

    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_removeDefenseBuff, buffmgr, killMonsterNum);
    },

    init: function () {
        this._super();
    },

    loop: function (t) {
        return this.isStop();
    },

    getVal: function () {
        return this.m_per;
    },

    shutdown: function () {
        this.m_per = 0;
    },


});

//增加自己防御
var addDefenseBuff = baseBuff.extend({

    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_addDefenseBuff, buffmgr, killMonsterNum);
    },

    init: function () {
        return this._super();
    },

    getVal: function () {
        return this.m_per;
    },

    shutdown: function () {
        this.m_per = 0;
    },


});

//增加自己攻击
var addAttBuff = baseBuff.extend({

    ctor: function (_Owner, receiver, buffObj, buffmgr, killMonsterNum) {
        this._super(_Owner, receiver, buffObj, g_buffType.buffType_addAttBuff, buffmgr, killMonsterNum);
    },

    init: function () {
        this._super();
    },

    getVal: function () {
        return this.m_per;
    },

    shutdown: function () {
        this.m_per = 0;
    },


});


var playBuffMgr = cc.Class.extend({
    m_buff_map: null,
    m_hero_obj: null,
    ctor: function (heroobj) {
        if (heroobj == null) {
            console.error("playBuffMgr ctor");
            return;
        }
        this.m_hero_obj = heroobj;
        this.init();
    },

    init: function () {
        this.m_buff_map = new ArrayEx(); // buff 可以重叠
    },

    shutdown: function () {
        for (var i = 0; i < this.m_buff_map.size(); ++i) {
            var obj = this.m_buff_map.getData(i);
            obj.shutdown();
        }

        this.m_buff_map.clear();
        if (ui_fight.getMe()) {
            ui_fight.getMe().updateBuff();
        }


    },
    getBuffNum: function () {
        return this.m_buff_map.size();
    },

    hasBuff: function (type) {
        var ret = false;
        this.m_buff_map.each(function (obj) {
            if (obj.m_type == type) {
                ret = true;
            }
        }, this);//
        return ret;
    },


    //enemylist 敌人列表   duiyoulist 队友列表 _Owner buff发起者  receiver 接受者
    createBuffById: function (_Owner, receiver, type, enemylist, duiyoulist, target, killMonsterNum) {

        if (type == null) {
            uiMgr.getMe().show_ui_MessageBox(true, "error createBuffById type == null");
            return;
        }

        if (type != g_buffType.buffType_xuanyunBuff2) {
            this.removeBuffById(type);
        }


        var bufflist = null;
        if (_Owner.m_baseRoleType == g_baseRoleType.type_play) {
            bufflist = fileMgr.getMe().m_player_buff.buff;
        } else {
            bufflist = fileMgr.getMe().m_monster_buff.buff;
        }
        //var bufflist = fileMgr.getMe().m_player_buff.buff;
        for (var i = 0; i < bufflist.length; ++i) {
            if (type == bufflist[i].buffType) {
                var buffobj = bufflist[i];

                if (type == g_buffType.buffType_addhpBuff) {
                    var obj = new addhpBuff(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_addhpBuff_time) {
                    var obj = new addhpBuff_time(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }

                else if (type == g_buffType.buffType_xuanyunBuff) {
                    var obj = new xuanyunBuff(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_xuanyunBuff2) {
                    var obj = new xuanyunBuff2(_Owner, receiver, buffobj, this, killMonsterNum)
                    if (obj._isStop == true) {
                        return null;
                    }
                    this.removeBuffById(type);
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_fuhuo) {
                    var obj = new fuhuo(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_addMissBuff) {
                    var obj = new addMissBuff(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_removeSpeedBuff) {
                    var obj = new removeSpeedBuff(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_addSpeedBuff) {
                    var obj = new addSpeedBuff(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_removeDefenseBuff) {
                    var obj = new removeDefenseBuff(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_addDefenseBuff) {
                    var obj = new addDefenseBuff(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else if (type == g_buffType.buffType_addAttBuff) {
                    var obj = new addAttBuff(_Owner, receiver, buffobj, this, killMonsterNum)
                    this.m_buff_map.put(obj);
                    return obj;
                }
                else {
                    console.error("createBuffById");
                    return null;
                }
            }
        }
    },

    removeBuffById: function (type) {
        if (type == null) {
            console.error("removeBuffById");
        }

        for (var i = 0; i < this.m_buff_map.size(); ++i) {
            var obj = this.m_buff_map.getData(i);
            if (obj == null) {
                this.m_buff_map.remove(obj);
                return;
            }

            if (obj.m_type == type) {
                obj.shutdown();
                this.m_buff_map.remove(obj);
                if (ui_fight.getMe()) {
                    ui_fight.getMe().updateBuff();
                }
                return;
            }

        }


    },

    update: function (t) {
        var len = this.m_buff_map.getSize();//  length;
        for (var i = 0; i < len; i++) {
            var k = this.m_buff_map.keys[i];
            var ret = k.loop(t);
            if (ret == true) {
                k.shutdown();
                this.m_buff_map.remove(k);

                if (ui_fight.getMe()) {
                    ui_fight.getMe().updateBuff();
                }
                k = null;
                return;
            }
        }
    },

    clear: function () {
    },

    isXuanYun: function () {
        var istrue = false;
        this.m_buff_map.each(function (obj) {
            if (obj.m_type == g_buffType.buffType_xuanyunBuff) {
                istrue = true;
            }
            if (obj.m_type == g_buffType.buffType_xuanyunBuff2) {
                istrue = true;
            }
        }, this);//
        return istrue;
    },

    getBuffSpeed: function () {
        var l_Speed = 0;
        this.m_buff_map.each(function (obj) {
            if (obj.m_type == g_buffType.buffType_addSpeedBuff) {
                l_Speed -= obj.getVal();
            }
            if (obj.m_type == g_buffType.buffType_removeSpeedBuff) {
                l_Speed += obj.getVal();
            }

        }, this);//
        return l_Speed;
    },

    getBuffMiss: function () {
        var l_Miss = 0;
        this.m_buff_map.each(function (obj) {
            if (obj.m_type == g_buffType.buffType_addMissBuff) {
                l_Miss += obj.getVal();
            }
        }, this);//
        return l_Miss;
    },

//buff 防御
    getBuffdefense: function () {
        var l_defense = 0;
        this.m_buff_map.each(function (obj) {
            if (obj.m_type == g_buffType.buffType_addDefenseBuff) {
                l_defense += obj.getVal();
            }
            if (obj.m_type == g_buffType.buffType_removeDefenseBuff) {
                l_defense -= obj.getVal();
            }

        }, this);
        return l_defense;
    },

//buff 附加att
    getBuffAtt: function () {
        var l_att = 0;
        this.m_buff_map.each(function (obj) {
            if (obj.m_type == g_buffType.buffType_addAttBuff) {
                if (obj.getVal() > l_att) {
                    l_att = obj.getVal();
                }

            }

        }, this);//

        return l_att;
    },
    skillStart: function () //技能的开始的时刻被调用
    {
        this.m_buff_map.each(function (obj) {
            obj.skillStart();
        }, this);//
    },
    skillEnd: function () //技能的结束的时刻被调用
    {
        this.m_buff_map.each(function (obj) {
            obj.skillEnd();
        }, this);//
    },
    //removeCd: function () //技能的结束的时刻被调用
    //{
    //    this.m_buff_map.each(function (obj) {
    //        obj.removeCd();
    //    }, this);//
    //}
});

playBuffMgr.create = function (heroobj) {
    var l_playBuffMgr = new playBuffMgr(heroobj);
    return l_playBuffMgr;
};

//静态函数
playBuffMgr.createBuffById_staitc = function (_Owner, type, enemylist, duiyoulist, target, killMonsterNum) {

    killMonsterNum = parseInt(killMonsterNum);

    if (type == g_buffType.buffType_addhpBuff || type == g_buffType.buffType_addhpBuff_time)  //谁血少给谁释放
    {
        if (target == "self") {
            target = "selfHp";
        }
    }


    if (target == "selfMe") // //释放给自己
    {
        _Owner.m_roleBuffMgr.createBuffById(_Owner, _Owner, type, enemylist, duiyoulist, target, killMonsterNum);
    }
    else if (target == "self") {
        //释放给队友
        _Owner.m_roleBuffMgr.createBuffById(_Owner, _Owner, type, enemylist, duiyoulist, target, killMonsterNum);

    }
    else if (target == "enemy" || target == "enemyAll") {//释放给敌人


        if (enemylist.size() == 0) {
            enemylist = _Owner.initEnemy(target);
        }

        enemylist.each(function (key, data) {
            data.m_roleBuffMgr.createBuffById(_Owner, data, type, enemylist, duiyoulist, target, killMonsterNum);
        }, this);

    } else if (target == "selfAll") { //释放给队友

        duiyoulist.each(function (key, data) {
            data.m_roleBuffMgr.createBuffById(_Owner, data, type, enemylist, duiyoulist, target, killMonsterNum);
        }, this);

    } else if (target == "selfHp") { //自己队友谁血少给谁加
        var minhp = 100;
        var duiyou = null;
        for (var i = 0; i < duiyoulist.size(); ++i) {
            var data = duiyoulist.getData(i);
            if (data.gethpPer() < minhp) {
                minhp = data.gethpPer();
                duiyou = data;
            }
        }

        if (duiyou) {
            duiyou.m_roleBuffMgr.createBuffById(_Owner, duiyou, type, enemylist, duiyoulist, target, killMonsterNum);
        }
    }
}







