var monster = baseRole.extend({
    m_Ai_map: null,
    m_cur_monsterState: null,
    m_monsterInfo: null,
    m_skill_info: null,
    m_cur_skill: null,
    m_monsterMaxHp: 1,

    ctor: function () {
        this._super();
        this.m_baseRoleType = g_baseRoleType.type_monster;
        this.m_roledir = 1;
    },

    getRoleName: function () {
        return this.m_monsterInfo["name"];
    },
    getmaxhp: function () //最大血量血
    {
        return this.m_monsterMaxHp;
    },
    setmaxhp: function (hp) //最大血量血
    {
        if (hp <= 1) {
            hp = 1;
        }
        this.m_monsterMaxHp = hp;
    },

    sethp: function (val) //当前血
    {
        this.m_curHp = parseInt(val);
        if (this.m_curHp < 0) {
            this.m_curHp = 0;
        }
        //updata
        if (ui_fight.getMe()) {
            ui_fight.getMe().updateMpHp(this.getMpPer(), this.getCurMp(), this.getcurhp(), this.gethpPer(), this.getRolePosType());
        }
    },
    addHp: function (val) //当前血
    {
        if (val < 0)
            return;
        var buff = this.getcurhp() + val;
        if (buff > this.getmaxhp()) {
            buff = this.getmaxhp();
        }
        this.sethp(buff);// = buff;
        dropHpMgr.getMe().addHp(roleMgr.getMe(), val, this.getBoneWroldPosition("head"));
    },
    removeHp: function (val) //当前血
    {
        val = parseInt(val);
        if (val < 0)
            return false;

        var buff = this.getcurhp() - val;
        buff = parseInt(buff);
        if (buff < 0) {
            this.sethp(0);// = 0;
        }

        this.sethp(buff);// = buff;

        dropHpMgr.getMe().removeHp(roleMgr.getMe(), val, this.getBoneWroldPosition("head"));

        return true;
    },

    getTeam_dead: function () {
        return roleMgr.getMe().getMonsterdead();
        //return null;
    },

    fuhuo: function () {
        parMgr.getMe().createListAnimation_playOnce("xingjieyuanqiyongzhe/big/pre/chusheng.plist", this, cc.p(0, 0));
        this.sethp(this.getmaxhp());
        this.chanageState_Ex(AiType.AiType_Idle);

        ui_fight.getMe().initTouxiang();
    },

    getBasemiss: function () {
        return this.m_monsterInfo.miss;
    },

    getBasesdefense: function () {
        //return this.m_monsterInfo.defence;
        var defense = this.m_monsterInfo.defence * 0.0005
        return defense / (1 + defense);
    },
    getBaseAtt: function () {
        return this.m_monsterInfo.baseatt;
    },
    getSkillAtt: function () {
        return this.getBaseAtt() * this.getCurSkill().shanghai_per;
    },
    //其实基础cd
    getBasecd: function () {
        return this.m_monsterInfo.basecd;
    },

    //获得总的输出伤害没有buff
    getOutAttNoBuff: function () {
        var attper = sceneMgr.getMe().getCurSceneInfo().attper;
        return (this.getBaseAtt() * this.getCurSkill().shanghai_per * attper);
    },

    //获得总的输出伤害
    getOutAtt: function () {
        var NoBuff = this.getOutAttNoBuff();
        var att = NoBuff * (1 + this.m_roleBuffMgr.getBuffAtt());
        return att;
    },

    getOutMiss: function () {
        //var missPer = sceneMgr.getMe().getCurSceneInfo().missper;
       // if( missPer )

        var out = this.getBasemiss() + this.m_roleBuffMgr.getBuffMiss();
        out =  out;

        if (out < 0) {
            out = 0;
        }
        return out;
    },
    getOutCd: function () {
        var buffcd = this.m_roleBuffMgr.getBuffSpeed();
        var Basecd = this.getBasecd();
        var out = Basecd + buffcd;
        if (out < 0) {
            out = 0.01;
        }
        return out;
    },

    // 总的输出防御
    getOutDefense: function () {
        var fangyuper = sceneMgr.getMe().getCurSceneInfo().fangyuper;

        if( fangyuper == null)
        {
            fangyuper = 0;
        }


        var out = this.getBasesdefense() + this.m_roleBuffMgr.getBuffdefense() + fangyuper;
        //out = out * fangyuper;

        if (out < 0) {
            out = 0;
        }
        return out;
    },

    setSelected: function (flag) //选中状态 层级加高
    {
        //if (flag) {
        //    var buffz = this.m_defaultZ;
        //    this.setLocalZOrder(1000);
        //    this.m_defaultZ = buffz;
        //}
        //else {
        //
        //     this.setLocalZOrder(this.m_defaultZ);
        //}
    },

    setLocalZOrder: function (z) {
        this.m_defaultZ = z;
        this._super(z);
    },
    getHeadIcon1: function () // 头像图片
    {
        return this.m_monsterInfo.fight_Head_icon1;

    },
    getHeadIcon2: function () // 头像图片
    {
        return this.m_monsterInfo.fight_Head_icon2;
    },
    getHeadIcon3: function () // 头像图片
    {
        return this.m_monsterInfo.fight_Head_icon3;
    },

    getMoveHeadIcon: function () // 头像图片
    {
        return this.m_monsterInfo.move_fight_Head_icon;
    },

    //注 有些怪物没有绝招
    getskilljuezhao: function () {
        var juezhao = this.m_skill_info["skilljuezhao"]; //
        if (juezhao == null) {
            //console.log("怪物 "+ this.getRoleName()+ " 没有绝招");
            // uiMgr.getMe().show_ui_MessageBox( true , "怪物 "+ this.getRoleName()+ " 没有绝招" );
        }

        return juezhao;

    },

    initFightSkill_MoveToUI: function (node) {
        node.setVisible(true);
        this.m_MyAction_FightUI_MoveTo = new MyAction_FightUI_MoveTo(this);
        var callback_func = MyCallback.create(this.FightSkill_MoveToUI_callbackFunc, this, null);
        this.m_MyAction_FightUI_MoveTo.oninit(node, null, ui_fight.getMe().m_pos_ui_start, ui_fight.getMe().m_pos_ui_end, callback_func);
    },

    //怪物ai 函数
    FightSkill_MoveToUI_callbackFunc: function () {
        this.randSkill();
        //this.m_roleBuffMgr.removeCd();
        this.m_cdFull = true;
        //触发Ai
    },

    setCurSkill: function (skill) {
        this.m_cur_skill = skill;//
    },
    randSkill: function () {

        var skill = this.randSkillEx();
        this.setCurSkill(skill);
        this.dealskill();

    },
    //释放技能
    dealskill: function ( name , data ) {

        if( this.m_cur_skill == null )
        {
            log.error( "dealskill: function: " + name );
            return;
        }

        if ( this.m_cur_skill.typeState == null )
        {
            log.error("dealskill: function: " + name);
            return;
        }

        if ("bishaji" == this.m_cur_skill.typeState )
        {
            uiMgr.getMe().show_ui_MessageBox( true , "怪物 没有必杀技 ，表填错" + this.getRoleName());
            return;
        }
        this.initEnemyList();

        if (this.m_cur_skill["des"] == "juezhao") {
            this.m_cur_skill["skillStopNum"] = g_playmonsterSkill_Ai_randnum.skilljuezhao.juezhao_bifang_num;
        }

        //
        this.chanageState( this.m_cur_skill.typeState, this.m_cur_skill );

        //修改层级

        roleMgr.getMe().update_Z_oder( 0 );


    },
    //是否战斗状态
    isFight: function ()
    {
        if ( this.isCDFull() ) {
            return true;
        }

        if (this.getCurStateType() == AiType.AiType_none) {
            return true;
        }
        else if (this.getCurStateType() == AiType.AiType_single) {
            return true;
        }
        else  if (this.getCurStateType() == AiType.AiType_double) {
            return true;
        }
        else if (this.getCurStateType() == AiType.AiType_bishaji) {
            return true;
        }

        return false;
    },

    //是否是加血buff
    isAddHpSkill: function (obj) {
        if (obj["buff1"]["type"] == g_buffType.buffType_addhpBuff ||
            obj["buff2"]["type"] == g_buffType.buffType_addhpBuff ||
            obj["buff3"]["type"] == g_buffType.buffType_addhpBuff) {
            return true;
        }
        if (obj["buff1"]["type"] == g_buffType.buffType_addhpBuff_time ||
            obj["buff2"]["type"] == g_buffType.buffType_addhpBuff_time ||
            obj["buff3"]["type"] == g_buffType.buffType_addhpBuff_time) {
            return true;
        }
        return false;
    },

    //返回队伍最低血量
    getTeamMinHpPer: function (obj)
    {
        var ret = this.getTeam();
        var minhpper = 100;
        for( var i = 0; i < ret.size(); ++i )
        {
            var date = ret.getData(i);
            if( date != null )
            {
                var l_retnum = date.gethpPer();
                if (l_retnum < minhpper) {
                    minhpper = l_retnum;
                }
            }
        }
        return minhpper;
    },


    skillHasBuff: function (obj) {
        if (obj["buff1"]["type"] != null ||
            obj["buff2"]["type"] != null ||
            obj["buff3"]["type"] != null) {
            return true;
        }

        return false;
    },

    //team hasbuff

    isTeamHasbuff: function () {
        var ret = this.getTeam();
        for( var i = 0; i < ret.size(); ++i )
        {
            var date= ret.getData(i);
            if(date)
            {
                var l_retnum  = date.getBuffNum();
                if (l_retnum > 0) {
                    return true;
                }
            }

        }
        return false;
    },

    initSkillRand: function () {

        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            obj["skillRand"] = g_playmonsterSkill_Ai_randnum[p]["base_shifang_rand"];

            var hashpbuff = this.isAddHpSkill(obj);



            if (hashpbuff && this.getTeamMinHpPer() < 50) {
                obj["skillRand"] += g_playmonsterSkill_Ai_randnum.hpper_addhp;
            }
            else if ( hashpbuff && this.getTeamMinHpPer() < 90 ) {
                obj["skillRand"] += g_playmonsterSkill_Ai_randnum[p]["base_buff_addhp_rand"];
            }

            if( !this.isTeamHasbuff() ) //队友身上没有buff的情况
            {
                obj["skillRand"] += g_playmonsterSkill_Ai_randnum[p]["base_buff_rand"]
            }

            if(hashpbuff == true)
            {
                if(this.getTeamMinHpPer() > 90)
                {
                    obj["skillRand"] = 0;
                }
            }
        }

        var skilljuezhao = this.getskilljuezhao(); //绝招放了3个回合后 不在放

        if(skilljuezhao)
        {
            if (skilljuezhao["skillStopNum"] == null)
            {
                skilljuezhao["skillStopNum"] = g_playmonsterSkill_Ai_randnum.skilljuezhao.juezhao_bifang_num;
            }

            if (skilljuezhao != null) {
                skilljuezhao["skillStopNum"] = skilljuezhao["skillStopNum"] - 1;
                if (skilljuezhao["skillStopNum"] <= 0) {
                    skilljuezhao["skillRand"] = g_playmonsterSkill_Ai_randnum.skilljuezhao.juezhao_bifang_rand;
                }

            }
        }


    },


    getskillnormal: function ()
    {
        return this.m_skill_info["skillnormal"];
    },


    getskilljueji2: function ()
    {
        return this.m_skill_info["skilljueji2"];
    },

    getskilljueji3: function ()
    {
        return this.m_skill_info["skilljueji3"];
    },


    randSkillEx: function () {


        // var skill = this.getskillnormal();
        // return skill;
        //

        if( this.getRoleName() == "mowang" ) //判断是魔王
        {
            var gameMap = roleMgr.getMe().getMonsterdead();
            if (  gameMap.size() > 0 )
            {
                var skill = this.getskilljueji3();
                return skill;
            }
        }


        this.initSkillRand();
        //
        this.initrandSkill_Check_mp();

        var allrand = 0;

        if( this.getRoleName() == "mowang" ) //判断是魔王
        {
            this.m_skill_info["skilljueji3"]["skillRand"] = 0;
        }


        for (var p in this.m_skill_info)
        {
            var obj = this.m_skill_info[p];
            obj["startskillRand"] = allrand;
            allrand += obj["skillRand"];
            obj["endskillRand"] = allrand;
        }

        var outrand = cc.random0To1() * allrand;
        var endrand = 0;
        for ( var p in this.m_skill_info )
        {
            var obj = this.m_skill_info[p];
            var startrand = obj["startskillRand"] ;
            var endrand = obj["endskillRand"] ;
            if (outrand >= startrand && outrand <= endrand)
            {
                return obj;
            }
        }

        console.log( "monster randSkillEx!!!" );
        return null;

       // var skill = this.getskillnormal();
       // return skill;

    },
    //返回队友
    getTeam: function () {
        return roleMgr.getMe().getMonsterAlive();
    },


    hasBuff_inskill: function (type) {
        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            if (obj["buff1"]["type"] == type ||
                obj["buff2"]["type"] == type ||
                obj["buff3"]["type"] == type) {
                return true;
            }
        }
        return false;
    },




// 初始化技能 随机数  检查mp 数值是否足够
    initrandSkill_Check_mp: function () {

        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            if (obj["xiaohao_mp"] > this.getCurMp()) {
                obj["skillRand"] = 0;
            }
        }

    },


    addRandByBuffType: function (type, addrand) {

        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            if (obj["buff1"]["type"] == type ||
                obj["buff2"]["type"] == type ||
                obj["buff3"]["type"] == type) {
                obj["skillRand"] = obj["skillRand"] + addrand;
            }
        }
    },


    //返回当前技能
    getCurSkill: function () {
        return this.m_cur_skill;
    },

    getskill_enemyCount: function () {
        return this.m_cur_skill.killMonsterNum;
    },
    initEnemyList: function () {

        var playlist = cc.clone(roleMgr.getMe().getPlayerAlive());
        var len = playlist.getSize();
        if (len <= 0) {
            return;
        }
        var randnum = cc.random0To1() * playlist.getSize();
        this.clearenemy();

        //优先攻击谁
        if (this.m_cur_skill.typeState == "single") {

            for (var i = 0; i < len; i++) {
                var k = playlist.keys[i];
                var data = playlist.data[k];
                if (randnum >= i && randnum <= (i + 1)) {
                    this.addenemy(data);
                    break;
                }
            }


        }
        else if (this.m_cur_skill.typeState == "double") {

            while (playlist.getSize() >= 3) {
                for (var i = 0; i < playlist.getSize(); i++) {
                    var k = playlist.keys[i];
                    var data = playlist.data[k];
                    if (randnum >= i && randnum <= (i + 1)) {
                        playlist.remove(k);
                        break;
                    }
                }
            }


            for (var i = 0; i < playlist.getSize(); i++) {
                var k = playlist.keys[i];
                var data = playlist.data[k];
                this.addenemy(data);
            }

        }
        else if (this.m_cur_skill.typeState == "attall") {
            for (var i = 0; i < len; i++) {
                var k = playlist.keys[i];
                var data = playlist.data[k];
                this.addenemy(data);
            }

        }
    },


    //被伤害
    dealShanghai: function (atthp, enemy, shoujitexiao, shoujitexiao_spine) {

        atthp = atthp * g_player.debugAttPer;
//miss
        var rend = cc.random0To1() * 100;
        if (rend <= this.getOutMiss()) {
            dropHpMgr.getMe().addmiss(roleMgr.getMe(), "", this.getBoneWroldPosition("head"));
            return;
        }
//defense

        atthp = atthp - atthp * this.getOutDefense();

        if (atthp <= 1) {
            atthp = 1;
        }

        if (this.isdead()) {
            return;
        }

        var ret = this.removeHp(atthp);
        if (ret == true)
        {
            //  dropHpMgr.getMe().dropHp(roleMgr.getMe(), atthp, this.getBoneWroldPosition("head"));
        }
        else
        {
            return;
        }

        this.playPlistAnimation_Once(shoujitexiao);
        if (shoujitexiao_spine != null) {
            spineMgr.getMe().createSpineOncePlay(shoujitexiao_spine.spineName, shoujitexiao_spine.animationName, this, null, this.getLocalZOrder() + 23);
        }
        if (this.getcurhp() <= 0) {
            this.chanageState(AiType.AiType_Dead);
        }
        else {
            this.chanageState(AiType.AiType_beiji);
        }

    },

    init: function (name) {

        this.loadres(name);

        var hpper = sceneMgr.getMe().getCurSceneInfo().hpper;

        this.setmaxhp(this.m_monsterInfo.hp * hpper);

        this.sethp(this.getmaxhp());

        this.initAi();
    },

    initAi: function () {
        this.m_Ai_map = new MapGame();
        this.m_cur_monsterState = new monsterAi_idle(this);
        this.m_cur_monsterState.InternalEvent();
        this.addState(this.m_cur_monsterState);
        this.addState(new monsterAi_dead(this));
        this.addState(new monsterAi_yun(this));
        this.addState(new monsterAi_single(this));
        this.addState(new monsterAi_att_double(this));
        this.addState(new monsterAi_att_All(this));
        this.addState(new monsterAi_att_bishaji(this));//怪物必杀技
        this.addState(new monsterAi_beiji(this));

        this.addState(new monsterAi_none(this));

    },
    addState: function (data) {
        this.m_Ai_map.put(data.m_AiType, data);
    },
    dealbuff: function () {


        if (this.getCurSkill().buff1["type"] != null) {
            if (this.getCurSkill().buff1["type"] != "") {
                var target = this.getCurSkill().buff1["target"];
                playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff1["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
            }
        }
        if (this.getCurSkill().buff2["type"] != null) {
            if (this.getCurSkill().buff2["type"] != "") {
                var target = this.getCurSkill().buff2["target"];
                playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff2["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
            }
        }
        if (this.getCurSkill().buff3["type"] != null) {
            if (this.getCurSkill().buff3["type"] != "") {
                var target = this.getCurSkill().buff3["target"];
                playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff3["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
            }
        }


        this.m_roleBuffMgr.skillStart();
        //更新buff ui
        ui_fight.getMe().updateBuff();
    },

    isdead: function () {
        if (this.getcurhp() <= 0) {
            return true;
        }

        if (this.getCurStateType() == AiType.AiType_Dead) {
            return true;
        }
        return false;
    },
    getCurStateType: function () {
        return this.m_cur_monsterState.m_AiType;
    },

    //强制切换状态
    chanageState_Ex: function (key, data) {
        this.m_cur_monsterState.ExternalEvent(key);
        var buffai = this.m_Ai_map.getDataByKey(key);
        if (buffai == null) {
            return true;
        }
        if (buffai.InternalEvent(key, data)) {
            this.m_cur_monsterState = buffai;
            return true;
        }
    },

    chanageState: function (key, data) //切换状态
    {
        if (!this.m_cur_monsterState.ExternalEvent(key, data))
            return false;
        var buffai = this.m_Ai_map.getDataByKey(key, data);

        if (buffai == null) {
            console.log("monster chanageState 没有这个状态" + key);
            return false;
        }

        if (buffai.InternalEvent()) {
            this.m_cur_monsterState = buffai;
            return true;
        }
        else {
            this.m_cur_monsterState.InternalEvent();
        }
    },

    loadres: function (name) //加载资源
    {
        if (fileMgr.getMe().m_monster[name] == null) {
            console.error("loadres" + name);
        }

        this.m_monsterInfo = cc.clone(fileMgr.getMe().m_monster[name]);

        this.m_skill_info = g_monster_Ai[name];// this.m_monsterInfo.name;

        this._super(this.m_monsterInfo.spine_res);

        this.m_SpineNode.setScale(this.m_monsterInfo.scale);

        this.setRoleDir(this.m_roledir);
    },

    setxunyun: function (flag) {
        if (flag) {
            this.chanageState(AiType.AiType_yun);
        }
        else {
            this.chanageState(AiType.AiType_Idle);
        }
    },

    update: function (dt) {
        this._super(dt);
        this.m_cur_monsterState.update(dt);
    },

    onFrameEvent: function (type, event) {
        this.m_cur_monsterState.onFrameEvent(type, event);
        this._super(type, event);
    },
});


monster.create = function () {
    return new monster();
};
