/**
 * Created by xieli on 2016/4/24.
 */


var monsterAi_idle = aiBase.extend({

    ctor: function (role) {
        this.m_AiType = AiType.AiType_Idle;
        this._super(role);
    },
    ExternalEvent: function (data) {
        //
        this._super(data);
        return true;
    },
    InternalEvent: function (data) {
        this.m_object_role.playAnimation("daiji");
        this._super(data);
        return true;
    },

    update: function (t) {
        this._super(t);
        return true;
    },


});

var monsterAi_dead = aiBase.extend({

    ctor: function (role) {
        this.m_AiType = AiType.AiType_Dead;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        return false;
    },
    InternalEvent: function (data) {

       this.m_object_role.m_roleBuffMgr.shutdown();
        ui_fight.getMe().initTouxiang();
        //更新buff ui
        ui_fight.getMe().updateBuff();

        this.m_object_role.playAnimation("siwang", false);
        this._super(data);
        if (roleMgr.getMe().isMonsterAllDead()) {
            rootScene.getMe().zanting_fightcd();
        }
        //删除buff

        return true;
    },

    update: function (t) {
        if (roleMgr.getMe().isMonsterAllDead()) {
            rootScene.getMe().zanting_fightcd();
        }
        this._super(t);
        return true;
    },
    onFrameEvent: function (type, event) {
        this._super(type, event);
        return true;
    },
    Complete: function () {
        //弹出
        if (roleMgr.getMe().isMonsterAllDead()) {
            sceneMgr.getMe().getCurScene().gameOver(true);
            // uiMgr.getMe().show_ui_shibai_shengli(true,true);
        }
        return true;
    },
});


//眩晕
var monsterAi_yun = aiBase.extend({

    ctor: function (role) {
        this.m_AiType = AiType.AiType_yun;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        //
        this._super(key, data);
        return true;
    },
    InternalEvent: function (key, data) {
        this.m_object_role.playAnimation("yun", true);
        this._super(key, data);
        return true;
    },
    update: function (t) {
        this._super(t);
        return true;
    },
    onFrameEvent: function (type, event) {
        this._super(type, event);
        return true;
    }
});



var monsterAi_none = aiBase.extend({
    _skillinfo: null,
    ctor: function (role) {
        this.m_AiType = AiType.AiType_none;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = this.m_object_role.getCurSkill();
        this.m_object_role.playAnimation(this._skillinfo.animation, false);
        this._super(key, data);
        //敌人列表

        //触发buff
        this.m_object_role.dealbuff();
        return true;
    },
    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {
        return true;
    },

});

//单体攻击
var monsterAi_single = aiBase.extend({
    _skillinfo: null,
    ctor: function (role) {
        this.m_AiType = AiType.AiType_single;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = this.m_object_role.getCurSkill();
        this.m_object_role.playAnimation(this._skillinfo.animation, false);
        this._super(key, data);

        //触发buff
        this.m_object_role.dealbuff();

        return true;
    },
    update: function (t) {

        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {
        var name = event.data.name;
        if (name.indexOf("shanghai") > -1) {

            var enemylist = this.m_object_role.getenemy();
            enemylist.each(function (key, data) {

                var lianjiNum = this._skillinfo.lianjiNum;
                if(lianjiNum == null)
                {
                    lianjiNum = 1;
                }

                data.dealShanghai(this.m_object_role.getOutAtt()/lianjiNum, this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);

            }, this);
        }
        // jizhong_texiao
        return true;
    },


});

// 攻击2个
var monsterAi_att_double = aiBase.extend({
    _skillinfo: null,
    ctor: function (role) {

        this.m_AiType = AiType.AiType_double;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = this.m_object_role.getCurSkill();
        this.m_object_role.playAnimation(this._skillinfo.animation, false);
        this._super(key, data);
        //触发buff
        this.m_object_role.dealbuff();
        return true;
    },
    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {
        var name = event.data.name;
        if (name.indexOf("shanghai") > -1)
        {
            var enemylist = this.m_object_role.getenemy();
            enemylist.each(function (key, data)
            {
                data.dealShanghai( this.m_object_role.getOutAtt() / this._skillinfo.killMonsterNum , this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);
            }, this);

        }
        // jizhong_texiao
        return true;
    },

});

//
var monsterAi_att_All = aiBase.extend({
    _skillinfo: null,
    ctor: function (role) {

        this.m_AiType = AiType.AiType_attall;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = this.m_object_role.getCurSkill();
        this.m_object_role.playAnimation(this._skillinfo.animation, false);
        this._super(key, data);
        //触发buff
        this.m_object_role.dealbuff();
        return true;
    },

    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {
        var name = event.data.name;
        if (name.indexOf("shanghai") > -1) {
            var enemylist = this.m_object_role.getenemy();
            enemylist.each(function (key, data) {
                data.dealShanghai(this.m_object_role.getOutAtt() / this._skillinfo.killMonsterNum, this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);

            }, this);

        }
        // jizhong_texiao
        return true;
    },
});

var monsterAi_att_bishaji = aiBase.extend({

    _skillinfo: null,
    ctor: function (role) {
        this.m_AiType = AiType.AiType_bishaji;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_roleBuffMgr.skillEnd();
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        this._state = 0;
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = this.m_object_role.getCurSkill();
        this.m_object_role.zanting(true);
        this._super(key, data);
        this.m_object_role.dealbuff(this._skillinfo);
        return true;
    },
    //播放mp4
    PlayMp4: function () {

        if( fileMgr.getMe().m_xiangsu_info["root"]["vedio"] >0 )
        {
            rootScene.getMe().zanting_fightcd(true);
            console.log(this._skillinfo.nameMp4);
            uiMgr.getMe().show_MoviePlayerMgr(true, this._skillinfo.nameMp4, function ()
            {
                rootScene.getMe().zanting_fightcd(false);
                this.m_object_role.zanting(false);
                this.CompleteEx();
            }, this);
        }
        else
        {
            this.m_object_role.zanting( false );
            this.m_object_role.playAnimation("jineng5");
        }

        return true;
    },
    update: function (t) {
        if (this._state == 0) {
            this.PlayMp4();
            this._state = 1;
        }

        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {

        var name = event.data.name;
        if (name.indexOf("shanghai") > -1)
        {
            var enemylist = this.m_object_role.getenemy();
            enemylist.each(function (key, data)
            {
                data.dealShanghai(this.m_object_role.getOutAtt(), this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);
            }, this);
        }
        // jizhong_texiao
        return true;
    },
    CompleteEx: function ()
    {
        var enemylist = this.m_object_role.getenemy();
        enemylist.each(function (key, data)
        {
            data.dealShanghai(this.m_object_role.getOutAtt(), this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);
        }, this);

        return  this.Complete();

    },
    Complete: function ()
    {

        if( fileMgr.getMe().m_xiangsu_info["root"]["vedio"] >0 )
        {
            return;
        }
        return this._super();

    },

});



//
var monsterAi_beiji = aiBase.extend({
    _skillinfo: null,
    ctor: function (role) {

        this.m_AiType = AiType.AiType_beiji;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        return true;
    },
    InternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(true);
        this.m_object_role.playAnimation("shouji1", false);
        this._super(key, data);
        //触发buff
        return true;
    },

    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Complete: function () {
        this._super();
        return true;
    },


});
