//竞技场玩家逻辑处理
//hbwei 维护


var player_jingjichang = player.extend({

    m_SelfType: true, //我方 还是敌方（被挑战者）
    m_skillMap: null,
    m_playmonsterSkill_Ai_randnum: null,
    m_player_jingjichang_data: null, // 格式如下{"name":"liefeng","level":"1","equiplevel":"1","skilljueji1level":"1","skilljueji2level":"1","skilljueji3level":"1","skilljuezhaolevel":"1"}

    ctor: function () {
        this._super();
        this.m_baseRoleType = g_baseRoleType.type_play;
        this.m_skillMap = new MapGame();
        this.m_playmonsterSkill_Ai_randnum = cc.clone(g_playmonsterSkill_Ai_randnum);
    },

    loadres: function (res) {
        this._super(res);
    },

    update_Z_oder: function ()
    {
        if(this.m_SelfType == false)
        {
            roleMgr_jingjichang.getMe().update_Z_oder(0);
        }
        else
        {
            roleMgr_jingjichang.getMe().update_Z_oder(1);
        }

    },

    loadLevelInfoPoint: function (heroname) {
        if (this.m_player_jingjichang_data) {
            this.m_levelInfoPoint = DataMgr.getMe().getLevelInfoPoint(heroname, this.m_player_jingjichang_data["level"]);
        }
        else {
            this._super(heroname);
        }
    },

    loadEquipPoint: function (heroname) {
        if (this.m_player_jingjichang_data) {
            this.m_equipPoint = DataMgr.getMe().getEquipPoint(heroname, this.m_player_jingjichang_data["equiplevel"]);
        }
        else {
            this._super(heroname);
        }
    },


//最大血量血

    getSkillLevel: function (skillType) {
        if (this.m_player_jingjichang_data) {
            var ret = this.m_player_jingjichang_data[skillType + "level"];
            if (ret == null) {
                return 1;
            }
            return parseInt(ret);
        }

        else {
            return this._super(skillType);
        }
    },

    //返回队友
    getTeam: function () {
        if (this.m_SelfType == true) {
            return roleMgr_jingjichang.getMe().getPlayerAlive();
        }
        else {
            return roleMgr_jingjichang.getMe().getMonsterAlive();
        }
    },

    getAliveEnemy: function () {
        if (this.m_SelfType == true) {
            return roleMgr_jingjichang.getMe().getMonsterAlive();
        }
        else {
            return roleMgr_jingjichang.getMe().getPlayerAlive();
        }
    },

    getMoveHeadIcon: function () // 头像图片
    {
        if (this.m_SelfType == true) {
            return this.PlayheroInfo.move_fight_Head_icon;
        }
        else {
            return this.PlayheroInfo.move_fight_Head_icon_down;
        }
    },

    FightSkill_MoveToUI_callbackFunc: function () //可以释放技能了
    {
        this.randSkill();
    },

    initEnemyList: function () {
        console.log("initEnemyList Begin--------------");
        var playlist = this.getAliveEnemy();
        var len = playlist.getSize();
        if (len <= 0) {
            return;
        }
        var randnum = cc.random0To1() * playlist.getSize();
        this.clearenemy();

        //优先攻击谁
        if (this.getCurSkill().typeState == "single" ||this.getCurSkill().killMonsterNum == 1) {


            for (var i = 0; i < len; i++) {
                var k = playlist.keys[i];
                var data = playlist.data[k];
                if (randnum >= i && randnum <= (i + 1)) {
                    this.addenemy(data);
                    break;
                }
            }


        }
        else if (this.getCurSkill().typeState == "double" || this.getCurSkill().killMonsterNum == 2) {

            while (playlist.getSize() >= 3) {
                for (var i = 0; i < playlist.getSize(); i++) {
                    var k = playlist.keys[i];
                    var data = playlist.data[k];
                    if (randnum >= i && randnum <= (i + 1)) {
                        playlist.remove(k);
                        break;
                    }
                }
            }


            for (var i = 0; i < playlist.getSize(); i++) {
                var k = playlist.keys[i];
                var data = playlist.data[k];
                this.addenemy(data);
            }

        }
        else if (this.getCurSkill().typeState == "attall" || this.getCurSkill().killMonsterNum == 3) {
            for (var i = 0; i < len; i++) {
                var k = playlist.keys[i];
                var data = playlist.data[k];
                this.addenemy(data);
            }

        }
    },

    //初始化释放技能目标列表
    initEnemy: function (type) {
        console.log("initEnemy Begin--------------");
        this.clearenemy();
        var enemylist = null;

        if (type == "enemyAll" || type == 3 || type == "3") {

            enemylist = this.getAliveEnemy();

            for (var i = 0; i < enemylist.size(); ++i) {
                this.addenemy(enemylist.getData(i));
            }
        }
        else if (type == "enemy" || type == 1 ) {
            enemylist = this.getAliveEnemy();

            var retGameMap = funcMgr.getMe().randFormGameMap(enemylist, 1);

            for (var i = 0; i < retGameMap.size(); ++i) {
                this.addenemy(retGameMap.getData(i));
            }
        }

        return this.getenemy();

    },

    initSkillRand: function () {

        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            obj["skillRand"] = 100;
        }

        var skilljuezhao = this.getskilljuezhao(); //绝招放了3个回合后 不在放

        skilljuezhao["skillRand"] = 100;

        if (skilljuezhao["skillStopNum"] == null) {
            skilljuezhao["skillStopNum"] = 0;
        }
        else {
            skilljuezhao["skillStopNum"] = skilljuezhao["skillStopNum"] - 1;
            if (skilljuezhao["skillStopNum"] <= 0) {
                skilljuezhao["skillRand"] = 100;
            }
            else {
                skilljuezhao["skillRand"] = 0;
            }
        }



    },

    //
    randSkillEx: function () {
        this.initSkillRand();

        this.initrandSkill_Check_addhp();
        //
        this.initrandSkill_Check_mp();

        var allrand = 0;
        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            allrand += obj["skillRand"];
        }

        var outrand = cc.random0To1() * allrand;
        var endrand = 0;
        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            var startrand = endrand;
            endrand += obj["skillRand"];
            if (outrand >= startrand && outrand <= endrand) {
                return obj;
            }
        }
        var skill = this.getskillnormal();
        return skill;

    },

    //3.加血类技能：当全队有角色血量低于50%的时候，加血类技能释放概率提升30%。
    initrandSkill_Check_addhp: function () {
        var teamlist = this.getTeam();
        var hasaddhp = false;
        var hasaddmiss = false;
        var hasaddDefense = false;
        var hasaddAtt = false;
        var hpPer = 100;

        teamlist.each(function (k, data) {
            if (data.gethpPer() < hpPer) {
                hpPer = data.gethpPer();
            }

            if (data.hasBuff(g_buffType.buffType_addhpBuff_time)) {
                hasaddhp = true;
            }
            if (data.hasBuff(g_buffType.buffType_addMissBuff)) {
                hasaddmiss = true;
            }
            if (data.hasBuff(g_buffType.buffType_addDefenseBuff)) {
                hasaddDefense = true;
            }
            if (data.hasBuff(g_buffType.buffType_addAttBuff)) {
                hasaddAtt = true;
            }

        }, this);

        if (hpPer < 50 && hasaddhp == false) {
            this.addRandByBuffType(g_buffType.buffType_addhpBuff_time, 0.3);
        }
    },


// 初始化技能 随机数  检查mp 数值是否足够
    initrandSkill_Check_mp: function () {

        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            if (obj.skillPoint["xiaohao_mp"] && obj.skillPoint["xiaohao_mp"] > this.getCurMp()) {
                obj["skillRand"] = 0;
            }
        }

    },


    addRandByBuffType: function (type, addrandPer) {

        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            if (obj.skillPoint["buff1"] == type ||
                obj.skillPoint["buff2"] == type ||
                obj.skillPoint["buff3"] == type) {
                obj["skillRand"] = obj["skillRand"] + obj["skillRand"] * addrandPer;
            }
        }
    },


    getenemy_jingjichang: function () {
        if (this.m_SelfType == true) {
            return roleMgr.getMe().m_monster_map;
        }
        else {
            return roleMgr.getMe().m_player_map;
        }
    },

    randSkill: function () {

        roleMgr.getMe().setcurRole(this);
        roleMgr.getMe().getcurRole().clearenemy();

        //var enemyMap = this.getAliveEnemy();

        var skill = this.randSkillEx();

        this.setCurSkill(skill);

        //this.clearenemy();

        //enemyMap.each(function (k, data) {
        //    this.addenemy(data);
        //
        //}, this);

        this.dealskill();

    },


    //释放技能
    dealskill: function (name, data) {

        if (this.getCurSkill().typeState == null) {
            uiMgr.getMe().show_ui_MessageBox(true, this.PlayheroInfo.name + " 的技能表出错  ，typeState这个字段没有填");
            return;
        }

        this.initEnemyList();

        this.chanageState_Ex(this.getCurSkill().typeState, this.getCurSkill());

        //删除mp
        this.removeMp(Math.round(this.getCurSkill().xiaohao_mp));

        this.update_Z_oder();

    },

    //
    //dealbuff: function () {
    //    //playBuffMgr.createBuffById_staitc( this , g_buffType.buffType_xuanyunBuff , this.getenemy() , this.getTeam() , "self" , 1 );
    //    //return;
    //
    //    if (this.getCurSkill() == null) {
    //        return;
    //    }
    //
    //    if (this.getCurSkill().buff1 != null) {
    //        if (this.getCurSkill().buff1["type"] != null) {
    //            if (this.getCurSkill().buff1["type"] != "") {
    //                var target = this.getCurSkill().buff1["target"];
    //                playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff1["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
    //            }
    //        }
    //    }
    //    if (this.getCurSkill().buff2 != null) {
    //        if (this.getCurSkill().buff2["type"] != null) {
    //            if (this.getCurSkill().buff2["type"] != "") {
    //                var target = this.getCurSkill().buff2["target"];
    //                playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff2["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
    //            }
    //        }
    //    }
    //    if (this.getCurSkill().buff3 != null) {
    //        if (this.getCurSkill().buff3["type"] != null) {
    //            if (this.getCurSkill().buff3["type"] != "") {
    //                var target = this.getCurSkill().buff3["target"];
    //                playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff3["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
    //            }
    //        }
    //    }
    //
    //    this.m_roleBuffMgr.skillStart();
    //
    //    //更新buff ui
    //    ui_fight.getMe().updateBuff();
    //
    //},

});


player_jingjichang.create = function () {
    var _player_jingjichang = new player_jingjichang();
    return _player_jingjichang;
};
