g_SceneType =
{
    SceneType_none: 'none', //无用
    SceneType_login: 'login', //登陆场景
    SceneType_fight: 'fight', //战斗场景
    SceneType_arena: 'arena', //竞技场
    SceneType_fangyu: 'fangyu', //
    SceneType_xiangdao: 'xiangdao', //向导
};


var baseScene = cc.Layer.extend({
    m_scenenode: null,
    m_qianjingnode: null,
    m_beijingnode: null,
    m_node_roleBase: null,
    m_node_roleMask: null, //选择技能界面的时候加一个遮罩
    m_node_baseui: null,
    m_SceneInfo: null, //不可以被修改
    m_roleMgr: null,
    m_SceneType: g_SceneType.SceneType_none,
    // m_roleMgr:null,
    m_scenename: "",
    m_scenename_zhuxian: "",
    m_scenename_zhixian: "",
    ctor: function () {
        this.m_SceneType = g_SceneType.SceneType_none;
        this._super();
    },

    init: function () {
        return true;
    },
    gameOver: function (winval, data) {

    },
    shutdown: function () {
        if (this.m_roleMgr != null) {
            this.m_roleMgr.shutdown();
        }
        fileMgr.getMe().savePlayInfo();
        return true;
    },
    getRoleMgr: function () {
        return this.m_roleMgr;
    },
    playBackMusic: function () {
        musicMgr.getMe().playbackmusic(this.m_SceneInfo["back_music"],true);
    },

    shipeiCenter: function (playout) {
        var winSize = cc.director.getWinSize();
        playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
        playout.setAnchorPoint(cc.p(0.5, 0.5));

        // if (winSize.width < 1280) {

        var widthper = winSize.width / 1280.0;
        var heightper = winSize.height / 768.0;
        if (widthper > heightper)
        {
            playout.setScale(heightper);
        }
        else
        {
            playout.setScale(widthper);
        }


    //}

        //else if (winSize.width > 1280) {
        //    var widthper = winSize.width / 1280.0;
        //    var heightper = winSize.height / 768.0;
        //
        //    if (widthper > heightper) {
        //        playout.setScale(heightper);
        //    }
        //    else {
        //        playout.setScale(widthper);
        //    }
        //}
    },

    //back_music
    loadscene: function (scenename) {
        this.m_scenename = scenename;
        rootScene.getMe().zanting(false);
        rootScene.getMe().zanting_fightcd(false);
        this.m_SceneInfo = cc.clone(fileMgr.getMe().getSceneInfo(scenename));
        if (this.m_SceneInfo == null) {
            return;
        }

        // cc.log("ccs.load : %s", this.m_SceneInfo.res_path);
        var json = null;
        if (cc.sys.isNative) {
            json = ccs.load("big/ui/" + this.m_SceneInfo.res_path);
        }
        else {
            json = ccs.load("xingjieyuanqiyongzhe/big/ui/" + this.m_SceneInfo.res_path);
        }


        this.m_scenenode = json.node;

        this.shipeiCenter(this.m_scenenode);

        this.m_qianjingnode = json.node.getChildByName("qianjing");
        this.m_beijingnode = json.node.getChildByName("beijing");//  ccui.helper.seekWidgetByName( json.node , "beijing");

        this.m_node_roleBase = new cc.Node();
        this.m_node_baseui = new cc.Node();

        this.m_node_roleMask = new cc.Node();
        this.m_scenenode.addChild(this.m_node_roleMask);


        this.m_scenenode.addChild(this.m_node_baseui);
        this.m_scenenode.addChild(this.m_node_roleBase);

        this.m_beijingnode.setLocalZOrder(0);

        this.m_node_roleMask.setLocalZOrder(90);
        this.m_node_baseui.setLocalZOrder(100);
        this.m_node_roleBase.setLocalZOrder(200);
        this.m_qianjingnode.setLocalZOrder(300);
        this.addChild(this.m_scenenode, 10000);

        if (this.m_SceneType == g_SceneType.SceneType_arena) {
            this.m_roleMgr = new roleMgr_jingjichang.create();
        }
        else if (this.m_SceneType == g_SceneType.SceneType_xiangdao) {
            this.m_roleMgr = new roleMgr_xiangdao.create();
        }
        else {
            this.m_roleMgr = new roleMgr.create();
        }

        this.m_node_roleBase.addChild(this.m_roleMgr);

        this.playBackMusic();

        this.init();

    },

    update: function (t) {

    }

});

