var fightscene = baseScene.extend({
    m_gameOver: false,
    m_win: null,
    ctor: function () {
        this._super();
        this.m_SceneType = g_SceneType.SceneType_fight;
    },

    init: function () {
        uiMgr.getMe().show_ui_xuanzechuzhan(false);
        uiMgr.getMe().show_ui_show_zuanshi_gold(false);
        uiMgr.getMe().show_ui_map(false);
        uiMgr.getMe().show_ui_fight(true);
        uiMgr.getMe().show_ui_fight_tips(true);
        uiMgr.getMe().show_ui_root(false);

        if (sceneMgr.getMe().getCurSceneInfo().sceneLevel > 6) {
            uiMgr.getMe().show_ui_MessageBox(true, "场景等级不能超过6等级");
        }
        return true;
    },

    startjuqing: function () {
        if (this.m_SceneInfo["juqing"]) {
            if (this.m_SceneInfo["juqing"]["startmessage"] != "") {
                uiMgr.getMe().show_ui_juqing(true, this.m_SceneInfo["juqing"]["startname"], this.m_SceneInfo["juqing"]["startmessage"], this.m_SceneInfo["juqing"]["startPng"]);
            }
        }
    },
    //结束剧情处理
    endjuqing: function () {

        if (this.m_SceneInfo["juqing"] == null
            || this.m_SceneInfo["juqing"]["winmessage"] == null
            || this.m_SceneInfo["juqing"]["winmessage"] == ""
            || this.m_SceneInfo["juqing"]["unwinmessage"] == ""
            || this.m_SceneInfo["juqing"]["unwinmessage"] == null) {
            this.ui_shengli_shibai();
            return;
        }

        if (this.m_win)
        {
            uiMgr.getMe().show_ui_juqing(true, this.m_SceneInfo["juqing"]["endname"], this.m_SceneInfo["juqing"]["winmessage"], this.m_SceneInfo["juqing"]["endPng"], this.ui_shengli_shibai, this);
        }
        else
        {
            uiMgr.getMe().show_ui_juqing(true, this.m_SceneInfo["juqing"]["endname"], this.m_SceneInfo["juqing"]["unwinmessage"], this.m_SceneInfo["juqing"]["endPng"], this.ui_shengli_shibai, this);
        }
    },

    ui_shengli_shibai: function () {
        if (this.m_win) {
            uiMgr.getMe().show_ui_shibai_shengli(true, true);
        }
        else {
            uiMgr.getMe().show_ui_shibai_shengli(true, false);
            pop_afterFailure.getMe().confirmLevelUp();
        }
    },

    gameOver: function (winval, data) {
        if (this.m_gameOver == true) {
            return;
        }
        this.m_win = winval;
        this.m_gameOver = true;
        this.endjuqing();
    },


    loadscene: function (scenename) {
        this._super(scenename);
        //弹出剧情
        this.m_roleMgr.initroleMgr(this.m_SceneInfo);
        this.startjuqing();
    },

    shutdown: function ()
    {
        this._super();
        uiMgr.getMe().show_ui_fight(false);
        uiMgr.getMe().show_ui_fight_tips(false);
        return true;
    },

});

fightscene.scene = function () {
    var layer = new fightscene();
    return layer;
};
