var rootScene = cc.Layer.extend({
    _ship: null,
    _zanting: false,
    _zanting_fightcd: false,
    m_autoDownload: true,
    m_isUpdate: false,
      m_isloadinit:false,
    ctor: function ()
    {
        rootScene.g_point = this;
        this._super();
    },
    sleep: function (numberMillis) {
        var now = new Date();
        var exitTime = now.getTime() + numberMillis;
        while (true) {
            now = new Date();
            if (now.getTime() > exitTime)
                return;
        }
    },

    onExit: function () {
        guajiMgr.getMe().startguaji();
        console.log("exit js");
        if ( cc.sys.isNative )
        {
            fileMgr.getMe().savePlayInfo();
            js_GameLogicMgr.getMe().exit();
        }

        if( g_player.testPlayDoc )
        {
        }
        else
        {
            this.sleep(2000);
        }

        console.log( "savePlayInfo js" );

        //shutdown
        ui_MoviePlayer_startGame.shutdownEx( );

        MoviePlayerMgr.ShowOrHide( false );

        this._super();
    },

    //只初始化一次
    init: function ()
    {
        console.log("rootScene init！！001");

        iapMgr.getMe().init();
        js_GameLogicMgr.getMe().init();
        console.log("js_GameLogicMgr init！！002");

        httpMgr.getMe().init();
        console.log("httpMgr init！！003");

        this.addChild(KeyboardMgr.getMe(), 10000);
        console.log("KeyboardMgr init！！004");

        this.addChild(uiMgr.getMe(), 1000);

        console.log("uiMgr init！！005");

        js_GameLogicMgr.getMe().tvsdk_login_shouui();

        if (this.m_autoDownload == true)
        {
            uiMgr.getMe().show_ui_autoDownload(true);
            autoDownloadMgr.getMe().init();


            if (this.m_isUpdate == false)
            {
                this.m_isUpdate = true;
                this.scheduleUpdate();
            }
        }
        else
        {
            this.initPlayData();
            console.log("uiMgr init！！006");

        }
        httpMgr.getMe().getServerTime();

        return true;
    },

    //获取玩家存档
    initPlayData: function () {
        console.log(" rootscene ： initPlayData");

        httpMgr.getMe().getPlayData();

    },


    init_1: function () {
        //
        console.log(" rootscene ： init_1");
        fileMgr.getMe().init();

        musicMgr.create();
        resMgr.getMe().loadTexutre();
        console.log(" rootscene ： init_1 end");
        return true;
    },

    initex: function () {

        this.addChild(parMgr.getMe(), 100);

        if (!DataMgr.getMe().isFinishxiangdao(g_yindaoType.yindaoType_FIGHT))
        {
            sceneMgr.getMe().selectScene(g_SceneType.SceneType_xiangdao, "scene_3_1_config");//向导场景
        }
        else
        {
            sceneMgr.getMe().selectScene(g_SceneType.SceneType_login);
        }

        if (this.m_isUpdate == false) {
            this.m_isUpdate = true;
            this.scheduleUpdate();
        }

        rewardMgr.getMe().init();
        this.m_isloadinit = true;
    },

    update_download: function (dt) {
        if (this.m_autoDownload == true) {
            if (autoDownloadMgr.getMe().m_state == 0) {
                autoDownloadMgr.getMe().update(dt);
                uiMgr.getMe().loop(dt);
                return true;
            }
        }
        return false;
    },

    update: function (dt) {

        if (cc.sys.isNative) {
            //var fps = cc.director.getFrameRate();
            //if (fps <= 1) {
            //    return;
            //}
            //dt = 1.0 / fps;
        }


        //网络协议
        httpMgr.getMe().loop(dt);

        if (this.update_download()) {
            return;
        }

        if(this.m_isloadinit == false)
        {
            return;
        }

        WebSocketManager.getMe().update(dt);


        spineMgr.getMe().update(dt);

        if (MoviePlayerMgr.getMe())
            MoviePlayerMgr.getMe().loop(dt);

        phyMgr.getMe().update(dt);

        if (roleMgr.getMe() != null) {
            roleMgr.getMe().update(dt);
        }

        js_GameLogicMgr.getMe().loop(dt);

        dropHpMgr.getMe().loop();

        yindaoMgr.getMe().loop();

        uiMgr.getMe().loop(dt);

        sceneMgr.getMe().update(dt);

        everyDayMgr.getMe().loop(dt);

        iapMgr.getMe().loop(dt);
    },
    iszanting: function () {
        return this._zanting;
    },
    //暂停动画 与 cd
    zanting: function (flag) {
        this._zanting = flag;
        if (roleMgr.getMe()) {
            roleMgr.getMe().zanting(flag)
        }
    },
    //暂停技能cd
    zanting_fightcd: function (flag) {
        this._zanting_fightcd = flag;
    },


    shutdown: function () {
        dropHpMgr.getMe().shutdown();
    }

});


rootScene.getMe = function () {
    return rootScene.g_point;
};


rootScene.scene = function () {
    var scene = new cc.Scene();
    var layer = new rootScene();
    layer.init();
    scene.addChild(layer);
    return scene;
};
