//
var sceneMgr = cc.Node.extend({
    m_curScene: null,
    ctor: function () {
        this._super();
        this.init();
    },

    init: function () {

    },
    getCurSceneName: function () {
        return this.m_curScene.m_scenename;
    },

    getCurSceneName_zhixian: function () {
        return this.m_curScene.m_scenename_zhixian;
    },
    getCurSceneName_zhuxian: function () {
        return this.m_curScene.m_scenename_zhuxian;
    },

    getCurSceneType: function () {

        if(this.m_curScene == null)
        {
            return g_SceneType.SceneType_login;
        }

        return this.m_curScene.m_SceneType;
    },
    //返回当前场景
    getCurScene: function () {
        return this.m_curScene;
    },
    //返回当前场景信息
    getCurSceneInfo: function () {
        return this.m_curScene.m_SceneInfo;
    },

    //读取scene xml
    readSceneInfo: function (sceneName) {
        var buf = sceneName;
        var ret = fileMgr.getMe().readSceneInfo(sceneName);
        if (ret == false) {
            cc.error(buf + "没有这个场景");
        }

        var it = fileMgr.getMe().hasSceneInfo(sceneName);
        if (it == false) {
            return false;
        }
        return true;
    },

    selectScene: function (type, sceneName) {


        if (type != g_SceneType.SceneType_login) {
            var ret = this.readSceneInfo(sceneName);
            if (ret == false) {
                return null;
            }
        }

        if (this.m_curScene != null) {
            this.m_curScene.shutdown();
            this.removeChild(this.m_curScene);
            this.m_curScene = null;

        }

        if (type == g_SceneType.SceneType_login) {
            this.m_curScene = loginscene.scene();
            this.addChild(this.m_curScene);

        }
        else if (type == g_SceneType.SceneType_fight) {
            //战斗背景
            this.m_curScene = fightscene.scene();
            this.m_curScene.loadscene(sceneName);
            this.addChild(this.m_curScene);
        }
        else if (type == g_SceneType.SceneType_arena) {
            //战斗背景
            this.m_curScene = arenaScene.scene();
            this.m_curScene.loadscene(sceneName);
            this.addChild(this.m_curScene);
        }
        else if (type == g_SceneType.SceneType_fangyu) {
            //
            this.m_curScene = fangyuScene.scene();
            this.m_curScene.loadscene(sceneName);
            this.addChild(this.m_curScene);
        }
        else if (type == g_SceneType.SceneType_xiangdao) {
            //
            this.m_curScene = xiangdaoScene.scene();
            this.m_curScene.loadscene(sceneName);
            this.addChild(this.m_curScene);
        }


        return this.m_curScene;
    },
    
    update: function (t)
    {
        if(this.m_curScene)
        {
            this.m_curScene.update(t);
        }
    }

});


sceneMgr.getMe = function () {
    return sceneMgr.create();
};

sceneMgr.create = function () {
    if (sceneMgr.g_sceneMgr == null)
    {
        console.log(" init sceneMgr.create ");
        sceneMgr.g_sceneMgr = new sceneMgr();
        rootScene.getMe().addChild( sceneMgr.g_sceneMgr, 1 );
        return sceneMgr.g_sceneMgr;
    }
    else {
        return sceneMgr.g_sceneMgr;
    }

};


