/**
 * Created by cy1234 on 2016/5/18.
 */

var playOnceSpine = cc.Node.extend({
    m_spine_Node: null,
    m_isShutDown: false,
    m_res:null,
    m_animationname:null,
    initex: function ( res , animationname )
    {
        this.m_res = res;
        this.m_animationname = animationname;

        this.m_spine_Node = spineMgr.getMe().loadSpine( res );
        this.addChild( this.m_spine_Node, 10 );
        this.m_spine_Node.setAnimation( 0 , animationname, false );

        this.m_spine_Node.setStartListener(

            function ( trackIndex )
            {
                this.getParent().onFrameEvent("Start");
            });

        this.m_spine_Node.setEndListener(
            function (traceIndex) {
                this.getParent().onFrameEvent("End");
            });

        this.m_spine_Node.setCompleteListener(function (traceIndex, loopCount) {
            this.getParent().onFrameEvent("Complete");
            //cc.log("%d complete: %d", traceIndex, loopCount);
        });

        this.m_spine_Node.setEventListener(
            function (traceIndex, event)
            {
                this.getParent().onFrameEvent("event", event);
                // this.clearenemy();
                // cc.log( traceIndex + " event: %s, %d, %f, %s",event.data.name, event.intValue, event.floatValue, event.stringValue);
            });
    },
    update: function(t)
    {
        return this.m_isShutDown;
    },
    onFrameEvent: function (type, event) {
        if (type == "End") {
            this.m_isShutDown = true;
        }
        else if (type == "Complete") {
            this.m_isShutDown = true;
        }
        else if (type == "event") {
            if (event.data.name.indexOf(".mp3") >= 0) {
                musicMgr.getMe().playeffect(event.data.name);
            }
        }


    },
    shutdown: function ()
    {
        this.getParent().removeChild(this, true);
    },

});


playOnceSpine.create = function (res, animationname, father, pos, z) {
    var fff = new playOnceSpine();
    fff.initex(res, animationname);
    if (pos != null) {
        fff.setPosition(pos);
    }

    if (z == null) {
        z = 1;
    }

    father.addChild(fff, z);
    return fff;
};

