//
var spineMgr = cc.Class.extend({

    m_playOnceSpineMap: null,
    ctor: function () {
        this.init();
        this.m_playOnceSpineMap = new ArrayEx();
    },
    init: function () {

    },


    update: function (t) {
        for (var i = 0; i < this.m_playOnceSpineMap.getSize(); ++i) {
            var data = this.m_playOnceSpineMap.keys[i];
            var ret = data.update(t);
            if (ret == true) {
                this.m_playOnceSpineMap.remove(data);
                data.shutdown();
                return;
            }
        }
    },

    //
    createSpineControl: function ( res, animationname, father, pos, z ) {

        if (res == null) {
            return null;
        }

        if (res == "") {
            return null;
        }

        if (animationname == null) {
            return null;
        }

        if (animationname == "") {
            return null;
        }

        var ret = spineControl.create( res , animationname , father , pos , z );
        return ret;
    },
    createSpineOncePlay: function (res, animationname, father, pos, z) {
        if (res == null) {
            return null;
        }
        if (res == "") {
            return null;
        }
        if (animationname == null) {
            return null;
        }
        if (animationname == "") {
            return null;
        }
        var ret = playOnceSpine.create(res, animationname, father, pos, z);
        this.m_playOnceSpineMap.put(ret);
        return ret;
    },
    loadSpine: function (res) {
        if (res == null)
        {
            console.error("loadSpine name :" + res);
            return;
        }


        //console.log("loadSpine name :" + res);
        var jsonname = "xingjieyuanqiyongzhe/big/spine/" + res + "/" + res + ".json";
        var atlasame = "xingjieyuanqiyongzhe/big/spine/" + res + "/" + res + ".atlas";
        var spineBoy = new sp.SkeletonAnimation(jsonname, atlasame);
        // spineBoy.SetShader_blur(1); //shader
        return spineBoy;
    }

});


spineMgr.getMe = function () {
    return spineMgr.create();
};

spineMgr.create = function () {
    if (spineMgr.g_spineMgr == null) {
        spineMgr.g_spineMgr = new spineMgr();
        return spineMgr.g_spineMgr;
    }
    else {
        return spineMgr.g_spineMgr;
    }

};


