//每日任务管理

var everyTaskMgr = cc.Class.extend({

    ctor: function () {

    },

    jingjichang_task: function () {
        if ((cc.sys.isNative && cc.sys.OS_WINDOWS == cc.sys.os) && fileMgr.getMe().m_xiangsu_info["root"]["winiap"]) {
            return;
        }
        this.addNum(g_taskType.taskType_JINGJICHANG);
    },

    zhixian_task: function () {
        if ((cc.sys.isNative && cc.sys.OS_WINDOWS == cc.sys.os) && fileMgr.getMe().m_xiangsu_info["root"]["winiap"]) {
            return;
        }
        this.addNum(g_taskType.taskType_ZHIXIAN);
    },

    yaoshui_task: function (name, num) {
        if ((cc.sys.isNative && cc.sys.OS_WINDOWS == cc.sys.os) && fileMgr.getMe().m_xiangsu_info["root"]["winiap"]) {
            return;
        }

        if (name == "smallPotion") {
            return this.addNum(g_taskType.taskType_XIAOYAOSHUI, num);
        } else if (name == "centerPotion") {
            return this.addNum(g_taskType.taskType_ZHONGYAOSHUI, num);
        } else if (name == "bigPotion") {
            return this.addNum(g_taskType.taskType_DAYAOSHUI, num);
        }

    },

    chongzhi_task: function () {
        if ((cc.sys.isNative && cc.sys.OS_WINDOWS == cc.sys.os) && fileMgr.getMe().m_xiangsu_info["root"]["winiap"]) {
            return;
        }
        this.addNum(g_taskType.taskType_CHONGZHI);
    },


    addNum: function (taskType, num) {
        if (num == undefined) {
            num = 1;
        }
        for (var i in g_player_task) {
            if (g_player_task[i]["type"] == taskType) {
                this.addTaskNumById(i, num);
            }
        }

    },

    addTaskNumById: function (id, num) {

        var over = fileMgr.getMe().m_play_doc["tasks"][id]["over"];
        if (over == null) {
            console.error("addTaskNumById");
            return;
        }

        if (over != 0) {
            return;
        }
        var curnum = parseInt(fileMgr.getMe().m_play_doc["tasks"][id]["curnum"]);
        if (curnum == null) {
            console.error("addTaskNumById");
            return;
        }

        fileMgr.getMe().m_play_doc["tasks"][id]["curnum"] = parseInt(curnum + num);

        curnum = parseInt(fileMgr.getMe().m_play_doc["tasks"][id]["curnum"]);

        var obj = g_player_task[id];
        var maxnum = obj["maxnum"];
        if (maxnum == null) {
            console.error("addTaskNumById");
            return;
        }
        if (curnum >= maxnum) {
            fileMgr.getMe().m_play_doc["tasks"][id]["curnum"] = maxnum;
            fileMgr.getMe().m_play_doc["tasks"][id]["over"] = 1; //已完成任务
            this.taskFinish(id);
        }
    },

    //领取积点并获取奖励
    taskFinish: function (id) {
        var oldjidian = DataMgr.getMe().getjidian(); //增加前
        var obj = g_player_task[id];
        if (obj) {
            DataMgr.getMe().addjidian(obj["jiangli_num"])
        }
        var newjidian = DataMgr.getMe().getjidian();

        for (var i = 1; i <= 4; i++) {
            var taskinfo = fileMgr.getMe().getTaskInfoItem_byid(i);
            if (taskinfo["jidian"] <= oldjidian) {
                continue;
            }
            if (taskinfo["jidian"] <= newjidian) {
                var jiangli_type = taskinfo["jiangli_type"];
                var jiangli_num = taskinfo["jiangli_num"];
                DataMgr.getMe().addItemByType(jiangli_type, jiangli_num);
                uiMgr.getMe().show_ui_MessageBox2(true, "今日累计" + newjidian + "积点,获取" + this.getItemStr(jiangli_type, jiangli_num) + "。");
            } else {
                break;
            }
        }
    },

    getItemStr: function (type, num) {
        if (type == "gold") {
            return num + "金币";
        } else if (type == "diamond") {
            return num + "勋章";
        } else if (type == "suipian") {
            return num + "个武魂碎片";
        } else if (type == "smallPotion") {
            return num + "瓶小瓶经验药水";
        } else if (type == "centerPotion") {
            return num + "瓶中瓶经验药水";
        } else if (type == "bigPotion") {
            return num + "瓶大瓶经验药水";
        }
    },
    //每日重置任务状态
    resetTaskState: function () {
        DataMgr.getMe().getPlayDoc().jidian = 0;
        var tasks = DataMgr.getMe().getPlayDoc().tasks;
        for (var p in tasks) {
            tasks[p]["curnum"] = 0;
            tasks[p]["over"] = 0;
        }
    }
});

everyTaskMgr.getMe = function () {
    return everyTaskMgr.create();
};

everyTaskMgr.create = function () {
    if (everyTaskMgr.g_everyTaskMgr == null) {
        everyTaskMgr.g_everyTaskMgr = new everyTaskMgr();
        return everyTaskMgr.g_everyTaskMgr;
    }
    else {
        return everyTaskMgr.g_everyTaskMgr;
    }

};







