/**
 * Created by Allen on 2016/7/15.
 */
//每日任务

var MyStruct_checkbox_pos = cc.Class.extend({
    pos: null,
    isused: false,
});


var ui_everytask = UiBase.extend({
    m_dailytask_Pos: null,
    m_task_checkboxMap: null,
    ctor: function () {
        this._super();
        this.m_des = "ui_everytask类";
        this.m_dailytask_Pos = new MapGame();
        this.m_task_checkboxMap = new MapGame();
    },

    oninit: function (data) {

        var root = this._parseUIFile("meiri.json", 0);
        this.EnterUI();
        this.addChild(root);
        this.shipeiCenter(root);


        for (var i = 1; i <= 10; i++) {
            var checkBox_task = ccui.helper.seekWidgetByName(root, "renwu" + i);
            this.m_task_checkboxMap.put(i, checkBox_task);
            var posInfo = new MyStruct_checkbox_pos();
            posInfo.pos = checkBox_task.getPosition();
            posInfo.isused = false;
            this.m_dailytask_Pos.put(i, posInfo);

        }

        this.updateUI();
    },

    updateUI: function () {
        this.updateTopUI();
        this.updateBottomUI();
    },

    updateTopUI: function () {
        var curjidian = DataMgr.getMe().getjidian();
        var last_jidian = 0; //上一级积点
        for (var i = 1; i <= 4; i++) {
            var taskinfo = fileMgr.getMe().getTaskInfoItem_byid(i);
            var jidian = taskinfo["jidian"];
            var taskzi = ccui.helper.seekWidgetByName(this.m_root, "vipzi" + i);
            taskzi.setString("获得" + jidian + "积点");
            var jindutiao = ccui.helper.seekWidgetByName(this.m_root, "LoadingBar_" + i);
            jindutiao.setPercent(0);

            if (curjidian >= jidian) {
                jindutiao.setPercent(100);

            } else {
                curjidian =  curjidian - last_jidian;
                jindutiao.setPercent((curjidian / (jidian - last_jidian)) * 100);
            }

            last_jidian = jidian;//
            var jiangping = ccui.helper.seekWidgetByName(this.m_root, "jiangping" + i);
            jiangping.setString(taskinfo["jiangli_num"]);

            var jltb = ccui.helper.seekWidgetByName(this.m_root, "jptb" + i);
            jltb.loadTexture(taskinfo["jiangli_icon"]);
        }

    },

    getUnUserPos: function () {
        for (var i = 1; i <= this.m_dailytask_Pos.getSize(); i++) {
            var posInfo = this.m_dailytask_Pos.getDataByKey(i);
            if (posInfo.isused == false) {
                posInfo.isused = true;
                return posInfo.pos;
            }
        }
    },

    updateBottomUI: function () {
        for (var i = 1; i <= this.m_dailytask_Pos.getSize(); i++) {
            var posInfo = this.m_dailytask_Pos.getDataByKey(i);
            posInfo.isused = false;
        }


        for (var i = 1; i <= this.m_task_checkboxMap.getSize(); i++) {
            var checkBox_task = this.m_task_checkboxMap.getDataByKey(i);
            var obj = g_player_task[i];


            var task_des = ccui.helper.seekWidgetByName(checkBox_task, "Text_2");
            var jiangli_num = ccui.helper.seekWidgetByName(checkBox_task, "Text_1");

            task_des.setText(obj["des"]);
            jiangli_num.setText(obj["jiangli_num"]);


            var ImageView_weiwancheng = ccui.helper.seekWidgetByName(checkBox_task, "weiwancheng");
            var ImageView_yilingqu = ccui.helper.seekWidgetByName(checkBox_task, "yilingqu");

            var cInfo = DataMgr.getMe().getTaskInfoById(i);
            if (cInfo["over"] == 0) {
                checkBox_task.setEnabled(false);
                checkBox_task.setBright(true);
                ImageView_weiwancheng.setVisible(true);
                ImageView_yilingqu.setVisible(false);

            } else if (cInfo["over"] == 1) {
                checkBox_task.setEnabled(false);
                checkBox_task.setBright(true);
                ImageView_weiwancheng.setVisible(false);
                ImageView_yilingqu.setVisible(true);
            }
        }

        for (var i = 1; i <= this.m_task_checkboxMap.getSize(); i++) {
            var checkBox_task = this.m_task_checkboxMap.getDataByKey(i);
            var cInfo = DataMgr.getMe().getTaskInfoById(i);
            if (cInfo["over"] == 0) {
                checkBox_task.setPosition(this.getUnUserPos());
            }
        }

        for (var i = 1; i <= this.m_task_checkboxMap.getSize(); i++) {
            var checkBox_task = this.m_task_checkboxMap.getDataByKey(i);
            var cInfo = DataMgr.getMe().getTaskInfoById(i);
            if (cInfo["over"] == 1) {
                checkBox_task.setPosition(this.getUnUserPos());
            }
        }

    },


    onBack: function () {
        this.endLayout(function () {
            uiMgr.getMe().show_ui_root(true);
            uiMgr.getMe().show_ui_everytask(false);
        });

    },

});


ui_everytask.getMe = function () {
    return ui_everytask.g_instarn;
}

ui_everytask.ShowOrHide = function (flag) {
    if (flag == true) {
        if (ui_everytask.g_instarn == null) {
            ui_everytask.g_instarn = new ui_everytask();
            uiMgr.getMe().addChild(ui_everytask.g_instarn, 34000);
            ui_everytask.g_instarn.oninit('');
            return ui_everytask.g_instarn;
        }
        else {
            return ui_everytask.g_instarn;
        }
    }
    else {
        if (ui_everytask.g_instarn != null) {
            ui_everytask.g_instarn.shutdown();
            uiMgr.getMe().removeChild(ui_everytask.g_instarn);
            ui_everytask.g_instarn = null;
        }

    }


};
