/**
 * Created by cy1234 on 2016/5/5.
 */

//  维护者 ： 魏  选择怪物状态


var BaseKeyState_monster = BaseKeyState_config.extend(
    {
        m_ui_select_monster: null,
        ctor: function () {
            this._super();
        },
        init: function (father) {
            this.m_ui_select_monster = father;
            this._super(father);
        },
        shutdown: function () {
            this._super();
        },

        loop: function ()
        {
            if (this.m_key == null)
            {
                return;
            }

            //更新位置
            this.m_ui_select_monster.m_rootui.setPosition(this.m_key.getNode().getHeadBoneWroldPosition());
            if (this.m_key.node.isVisible()) {
                for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                    var nodeinfo = this.m_buttonlist.getData(i);
                    if (nodeinfo.getNode() == this.m_key.getNode()) {
                        this.m_key.getNode().setSelected(true);
                    }
                    else {
                        nodeinfo.getNode().setSelected(false);
                        //console.log(pButtonImageView.getName());
                    }
                }
            }
            else {
                var retkey = this.m_buttonlist.getnext(this.m_key);
                if (retkey != null) {
                    this.m_key = this.m_buttonlist.begin();
                }
            }
        },
        DoEnterCurButton: function () {
            if (this.m_buttonlist.size() == 0) {
                return false;
            }
            if (this.m_key != this.m_buttonlist.end()) {
                var monster = this.m_key.node;

                var retcount = roleMgr.getMe().getcurRole().addenemy(monster);

                var enemyCount = roleMgr.getMe().getcurRole().getskill_enemyCount();

                if (enemyCount >= roleMgr.getMe().setMonsterNum_isLife()) {
                    roleMgr.getMe().m_monster_map.each(function (k, data) {
                        roleMgr.getMe().getcurRole().addenemy(data);
                    }, this);

                    roleMgr.getMe().getcurRole().dealskill();

                    uiMgr.getMe().show_ui_select_monster(false);
                    return true;
                }

                if (retcount >= enemyCount) {
                    roleMgr.getMe().getcurRole().dealskill();
                    uiMgr.getMe().show_ui_select_monster(false);
                }

                return true;
            }
            return false;
        },

        left: function () {
            var ret = this.m_buttonlist.getDataByKey(this.m_key.left_pos);
            if (ret) {
                this.m_key = ret;
                if (this.m_key.getNode().isdead()) {
                    return this.left();
                }
                return true;
            }
            return false;
        },
        right: function () {
            var ret = this.m_buttonlist.getDataByKey(this.m_key.right_pos);
            if (ret) {
                this.m_key = ret;
                if (this.m_key.getNode().isdead()) {
                    return this.right();
                }
                return true;
            }
            return false;
        },
        up: function () {
            var ret = this.m_buttonlist.getDataByKey(this.m_key.up_pos);
            if (ret) {
                this.m_key = ret;
                if (this.m_key.getNode().isdead()) {
                    return this.up();
                }
                return true;
            }
            return false;
        },
        down: function () {
            var ret = this.m_buttonlist.getDataByKey(this.m_key.down_pos);
            if (ret) {
                this.m_key = ret;
                if (this.m_key.getNode().isdead()) {
                    return this.down();
                }
                return true;
            }
            return false;
        },
    });


var ui_select_monster = UiBase.extend({

    m_CBaseKeyState: null,
    m_rootui: null,
    ctor: function () {
        this._super();
        this.m_CBaseKeyState = new BaseKeyState_monster();
        this.m_des = "ui_select_monster类";
    },
    shutdown: function () {
        rootScene.getMe().zanting(false);
        if (roleMgr.getMe() != null) {
            roleMgr.getMe().removeChild(this.m_rootui);
        }

        this._super();
    },
    initColor: function () {
        this.setColor(cc.color(0, 0, 0));
        this.setOpacity(255 * 0);
        return true;
    },
    oninit: function (data) {

        this.m_rootui = this._parseUIFile("jiantou1.json", 0);
        this.m_rootui.setAnchorPoint(cc.p(0.5, 0.0));
        this.playAnimation("play", true);


        var Image_1 = ccui.helper.seekWidgetByName(this.m_rootui, "Image_1");
        Image_1.addTouchEventListener(this.enterEx, this);

        roleMgr.getMe().addChild(this.m_rootui, 100000);


        var monsterlist = roleMgr.getMe().getMonsterAlive();

        if (monsterlist.getSize() == 3) {
            this.m_CBaseKeyState.regNode_config(monsterlist.getData(2), 1, null, null, 2, null);
            this.m_CBaseKeyState.regNode_config(monsterlist.getData(1), 2, null, null, 3, 1);
            this.m_CBaseKeyState.regNode_config(monsterlist.getData(0), 3, null, null, null, 2);
        }
        else if (monsterlist.getSize() == 2) {
            this.m_CBaseKeyState.regNode_config(monsterlist.getData(1), 1, null, null, 2, 2);
            this.m_CBaseKeyState.regNode_config(monsterlist.getData(0), 2, null, null, 1, 1);
        }
        else if (monsterlist.getSize() == 1) {
            this.m_CBaseKeyState.regNode_config(monsterlist.getData(0), 1, null, null, null, null);
        }

        this.m_CBaseKeyState.init(this);

        rootScene.getMe().zanting(true);


    },


    enterEx: function ( sender, type )
    {
        switch (type)
        {
            case ccui.Widget.TOUCH_ENDED:
            {
                this.m_CBaseKeyState.DoEnterCurButton();
            }
            break;
        }
    },

    onKeyPressed: function (keyCode) {
        this._super(keyCode);
    },


    onBack: function () //弹出退出box
    {
        this._super();
        uiMgr.getMe().show_ui_select_monster(false);
        uiMgr.getMe().show_ui_selectSkill(true);
    },

    //退出這个状态
    DoEnterCurButton: function () {
        this._super();
    },
    onUpdate: function (t) {
        this._super(t);
        rootScene.getMe().zanting(true);
    }

});

ui_select_monster.getMe = function () {
    return ui_select_monster.g_instarn;
}

ui_select_monster.ShowOrHide = function (flag) {
    if (flag == true) {
        if (ui_select_monster.g_instarn == null) {
            ui_select_monster.g_instarn = new ui_select_monster();
            uiMgr.getMe().addChild(ui_select_monster.g_instarn, 3000);

            ui_select_monster.g_instarn.oninit('');
            return ui_select_monster.g_instarn;
        }
        else {
            return ui_select_monster.g_instarn;
        }
    }
    else {
        if (ui_select_monster.g_instarn != null) {
            ui_select_monster.g_instarn.shutdown();
            uiMgr.getMe().removeChild(ui_select_monster.g_instarn);
            ui_select_monster.g_instarn = null;
        }

    }


};
