/**
 * Created by Allen on 2016/6/14.
 */


var ui_yindao = UiBase.extend({
    m_CBaseKeyState: null,
    m_ButtonNode: null,
    m_FatherButtonNode: null,
    m_FatherPos: null,
    m_candelete: false, //可以delete
    m_timeout: 15, //15s后直接跳过
    m_canclick: false, //可以点击状态
    m_time: 0,

    ctor: function () {
        this._super();
        this.m_des = "ui_yindao类";
        this.m_CBaseKeyState = new BaseKeyState();
//this.m_key_not_close = false;
    },


    //yindaoid 向导id
    //node 高亮的控件
    //canclick 高亮的控件是否响应键盘消息
    //keyboard ui是否响应键盘消息
    oninit: function (yindaoid, node, canclick, keyboard) {
        //var data = yindaoType + "." + xiangdaoid;
        var root = this._parseUIFile("xinshouyindao" + yindaoid + ".json", 0);
        if (root == null) {
            this.m_candelete = true;
            return;
        }

        //this.EnterUI();
        this.addChild(root);
        this.shipeiCenter(root);
        this.playAnimation("play", true);


        this.m_key_not_close = keyboard;

        var yindao_ok = ccui.helper.seekWidgetByName(root, "CheckBox_ok");
        if (yindao_ok) {
            yindao_ok.addTouchEventListener(this.yindao_okfunc, this);
            this.m_CBaseKeyState.regNodeEx(yindao_ok, 1);
        }

        if (node) {
            this.initBtnNode(node);
            if (node.setSelected != null && canclick) {
                this.m_CBaseKeyState.regNodeEx(node, 1);
            }
        }

        this.m_CBaseKeyState.init(this);
    },

    initBtnNode: function (pnode) {
        if (!pnode) {
            return;
        }

        this.m_ButtonNode = pnode;
        this.m_FatherButtonNode = pnode.getParent();
        this.m_FatherPos = pnode.getPosition();
        this.m_FatherButtonNode.retain();

        var posw = this.m_FatherButtonNode.convertToWorldSpace(this.m_FatherPos);
        var apoint = this.m_ButtonNode.getAnchorPoint();

        pnode.setVisible(true);
        pnode.retain();
        pnode.getParent().removeChild(pnode, false);
        this.m_root.addChild(pnode, 200);
        pnode.setPosition(this.m_root.convertToNodeSpace(posw));
        pnode.setAnchorPoint(apoint);

        //this.m_CBaseKeyState.regNodeEx(pnode, 1);
        //this.m_CBaseKeyState.init(this);

    },

    shutdown: function () {
        if (this.m_ButtonNode != null) {
            this.m_ButtonNode.retain();
            this.m_FatherButtonNode.retain();
            this.m_ButtonNode.getParent().removeChild(this.m_ButtonNode, false);
            this.m_FatherButtonNode.addChild(this.m_ButtonNode);
            this.m_ButtonNode.setPosition(this.m_FatherPos);


            this.m_ButtonNode.release();
            this.m_FatherButtonNode.release();
            this.m_ButtonNode = null;
            this.m_FatherButtonNode = null;
        }
        this._super();
    },

    DoEnterCurButton: function () {
        if (this.m_canclick) {
            this.m_candelete = true;
            this._super();
        }
    },

    yindao_okfunc: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                if (this.m_canclick) {
                    this.m_candelete = true;
                }
            }
            break;
        }
    },

    loop: function (t) {
        this._super(t);
        //this.m_timeout -= t;
        this.m_time += t;
        if (this.m_time > 1) {
            this.m_canclick = true;
            this.m_time = 0;
        }

        this.loopBtnPos(t);
    },

    loopBtnPos: function (t)
    {
        if (this.m_FatherButtonNode)
        {
            var posw = this.m_FatherButtonNode.convertToWorldSpace(this.m_FatherPos);
            this.m_ButtonNode.setPosition(this.m_root.convertToNodeSpace(posw));
        }
    }

});

ui_yindao.create = function (yindaoid, checkbox, canclick, keyboard) {
    var _instarn = new ui_yindao();
    _instarn.oninit(yindaoid, checkbox, canclick, keyboard);
    return _instarn;
};

