/**
 * Created by Allen on 2016/6/14.
 */

g_yindaoType = {
    yindaoType_FIGHT: 1, //战斗向导
    yindaoType_LOBBY: 2,  //大厅向导
    yindaoType_GUANKA: 3,  //进入关卡向导
    yindaoType_JINENGSHENGJI: 4, //成就技能升级向导
    yindaoType_QIANGHUA: 5, //装备升级向导
    yindaoType_RENWUSHENGJI: 6, //人物升级向导
    yindaoType_TIAOGUO: 7, //关卡跳过向导

    yindaoType_GUANKA1: 8, //关卡地图占有率提示
    yindaoType_GUANKA2: 9, //关卡地图怪物进攻提示
};

var yindaoMgr = cc.Class.extend({
    m_arr_yindao: null,
    m_yindaoType: 0,  //向导类型
    m_xiangdaoid: 0,  //子向导id
    m_isfinish: true, //是否完成子向导
    ctor: function () {
        this.m_arr_yindao = new ArrayEx();
    },

    createyindao: function (checkbox, canclick, keyboard) {
        if (!this.m_isfinish) {
            return;
        }

        if (canclick == undefined) {
            canclick = true;
        }

        if (keyboard == undefined) {
            keyboard = true;
        }
        var id = this.m_yindaoType + "." + this.m_xiangdaoid;
        var yindaoLay = ui_yindao.create(id, checkbox, canclick, keyboard);
        uiMgr.getMe().addChild(yindaoLay, 300000);
        this.m_arr_yindao.put(yindaoLay);

        this.m_isfinish = false;
    },


    createyindaoByType: function (yindaoType) {

        if (DataMgr.getMe().isFinishxiangdao(yindaoType)) {
            return false;
        }

        //有向导在进行
        if (this.m_xiangdaoid != 0) {
            return false;
        }

        this.m_yindaoType = yindaoType;
        this.m_xiangdaoid = 1;

        //首先完成向导
        DataMgr.getMe().finishxiangdao(this.m_yindaoType);

        return true;
    },

    remove_yindao: function () {
        this.m_arr_yindao.each(function (obj) {
            if (obj) {
                obj.m_candelete = true;
            }
        }, this, null);
    },

    loop: function () {
        this.m_arr_yindao.each(function (obj) {
            if (obj) {
                if (obj.m_candelete == true) {
                    this.m_arr_yindao.remove(obj);
                    obj.shutdown();
                    uiMgr.getMe().removeChild(obj, true);
                    obj = null;

                    this.m_xiangdaoid++;
                    this.m_isfinish = true;
                }
            }
        }, this, null);

        this.update_yindao();
    },

    update_yindao: function () {

        //if (!this.m_isfinish) {
        //    return;
        //}

        switch (this.m_yindaoType) {
            case g_yindaoType.yindaoType_FIGHT:
            {

                if (this.m_xiangdaoid == 1) {
                    if (ui_fight.getMe()) {
                        rootScene.getMe().zanting(true);
                        yindaoMgr.getMe().createyindao(ui_fight.getMe().m_jindutiao);
                    }
                } else if (this.m_xiangdaoid == 2) {
                    rootScene.getMe().zanting(false);
                    if (ui_selectSkill.getMe()) {
                        if (!this.m_isfinish) {
                            return;
                        }
                        yindaoMgr.getMe().createyindao(null, false, false);
                        ui_selectSkill.getMe().m_CBaseKeyState.setCurKey_byName("CheckBox_2");
                        ui_selectSkill.getMe().setLocalZOrder(500000);
                    } else {
                        this.remove_yindao();
                    }

                } else if (this.m_xiangdaoid == 3 && !roleMgr.getMe().getcurRole().isFight()) {
                    if (ui_fight.getMe()) {
                        rootScene.getMe().zanting(true);
                        yindaoMgr.getMe().createyindao(ui_fight.getMe().m_nengliangcao);
                    }
                } else if (this.m_xiangdaoid == 4) {
                    rootScene.getMe().zanting(false);
                    if (ui_selectSkill.getMe()) {
                        if (!this.m_isfinish) {
                            return;
                        }
                        rootScene.getMe().zanting(true);
                        yindaoMgr.getMe().createyindao(null,false, false);
                        ui_selectSkill.getMe().m_CBaseKeyState.setCurKey_byName("CheckBox_4_0");
                        ui_selectSkill.getMe().setLocalZOrder(500000);
                    } else {
                        this.remove_yindao();
                    }
                } else if (this.m_xiangdaoid == 5) {
                    this.m_xiangdaoid = 0;
                }
            }
                break;
            case g_yindaoType.yindaoType_LOBBY:
            {
                if (!this.m_isfinish) {
                    return;
                }

                if (this.m_xiangdaoid == 1) {
                    if (ui_root.getMe()) {
                        yindaoMgr.getMe().createyindao( ui_root.getMe().renwuanniu, false);
                    }
                    if (ui_rootApk.getMe()) {
                        yindaoMgr.getMe().createyindao( ui_rootApk.getMe().renwuanniu, false);
                    }

                } else if (this.m_xiangdaoid == 2) {
                    if (ui_root.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_root.getMe().jingjichang, false);
                    }
                    if (ui_rootApk.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_rootApk.getMe().jingjichang, false);
                    }
                } else if (this.m_xiangdaoid == 3) {
                    if (ui_root.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_root.getMe().guankaxuanzeanniu, false);
                    }
                    if (ui_rootApk.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_rootApk.getMe().guankaxuanzeanniu, false);
                    }
                } else if (this.m_xiangdaoid == 4) {
                    this.m_xiangdaoid = 0;
                    uiMgr.getMe().show_ui_map(true);
                    uiMgr.getMe().show_ui_root(false);
                }
            }
                break;
            case g_yindaoType.yindaoType_GUANKA:
            {
                if (!this.m_isfinish) {
                    return;
                }

                if (this.m_xiangdaoid == 1) {
                    //if (ui_map.getMe()) {
                    yindaoMgr.getMe().createyindao( ui_map.getMe().m_scene_1);
                    //}
                } else if (this.m_xiangdaoid == 2) {
                    this.m_xiangdaoid = 0;
                }
            }
                break;
            case g_yindaoType.yindaoType_JINENGSHENGJI:
            {
                if (!this.m_isfinish) {
                    return;
                }
                if (this.m_xiangdaoid == 1) {

                    yindaoMgr.getMe().createyindao();

                } else if (this.m_xiangdaoid == 2) {
                    sceneMgr.getMe().selectScene(g_SceneType.SceneType_login);
                    uiMgr.getMe().show_ui_login(false);
                    uiMgr.getMe().show_ui_root(true);
                    uiMgr.getMe().show_ui_chengjiu(true);

                    if (ui_chengjiu.getMe()) {
                        yindaoMgr.getMe().createyindao( ui_chengjiu.getMe().m_level5_chengjiu);
                    }

                } else if (this.m_xiangdaoid == 3) {
                    yindaoMgr.getMe().createyindao();

                } else if (this.m_xiangdaoid == 4) {
                    uiMgr.getMe().show_ui_chengjiu(false);
                    uiMgr.getMe().show_ui_root(true);
                    if (ui_root.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_root.getMe().renwuanniu);
                    }
                    if (ui_rootApk.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_rootApk.getMe().renwuanniu);
                    }

                } else if (this.m_xiangdaoid == 5) {
                    //uiMgr.getMe().show_ui_renwujiemian(true);
                    if (ui_renwujiemian.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_renwujiemian.getMe().m_jinengshengji);
                    }
                } else if (this.m_xiangdaoid == 6) {
                    //uiMgr.getMe().show_ui_jinengshengji(true, "liefeng");
                    if (ui_jinengshengji.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_jinengshengji.getMe().m_jiesuo1);
                    }
                } else if (this.m_xiangdaoid == 7) {
                    this.m_xiangdaoid = 0;
                }
            }
                break;
            case g_yindaoType.yindaoType_QIANGHUA:
            {
                if (!this.m_isfinish) {
                    return;
                }
                if (this.m_xiangdaoid == 1) {
                    yindaoMgr.getMe().createyindao();
                } else if (this.m_xiangdaoid == 2) {
                    sceneMgr.getMe().selectScene(g_SceneType.SceneType_login);
                    uiMgr.getMe().show_ui_login(false);
                    uiMgr.getMe().show_ui_root(true);
                    uiMgr.getMe().show_ui_renwujiemian(true);
                    uiMgr.getMe().show_ui_zhuangbeishengji(true, "liefeng");
                    if (ui_zhuangbeishengji.getMe()) {
                        yindaoMgr.getMe().createyindao( ui_zhuangbeishengji.getMe().qianghuayici);
                    }
                    if (ui_zhuangbeishengjiApk.getMe()) {
                        yindaoMgr.getMe().createyindao( ui_zhuangbeishengjiApk.getMe().qianghuayici);
                    }

                } else if (this.m_xiangdaoid == 3) {
                    this.m_xiangdaoid = 0;
                }
            }
                break;
            case g_yindaoType.yindaoType_RENWUSHENGJI:
            {
                if (!this.m_isfinish) {
                    return;
                }

                if (this.m_xiangdaoid == 1) {
                    if (ui_chengjiu.getMe()) {
                        yindaoMgr.getMe().createyindao();
                    }
                } else if (this.m_xiangdaoid == 2) {

                    sceneMgr.getMe().selectScene(g_SceneType.SceneType_login);
                    uiMgr.getMe().show_ui_login(false);
                    uiMgr.getMe().show_ui_root(true);
                    uiMgr.getMe().show_ui_renwujiemian(true);
                    uiMgr.getMe().show_ui_renwushengji(true, "liefeng");

                    if (ui_renwushengji.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_renwushengji.getMe().m_yipingxiaoyaoshui);
                    }
                } else if (this.m_xiangdaoid == 3) {
                    this.m_xiangdaoid = 0;
                }
            }
                break;
            case g_yindaoType.yindaoType_TIAOGUO:
            {
                if (!this.m_isfinish) {
                    return;
                }

                if (this.m_xiangdaoid == 1) {
                    if (ui_map.getMe()) {
                        yindaoMgr.getMe().createyindao(ui_map.getMe().m_menu_image);
                    }
                } else if (this.m_xiangdaoid == 2) {
                    this.m_xiangdaoid = 0;
                }
            }
                break;
            case g_yindaoType.yindaoType_GUANKA1:
            {
                if (!this.m_isfinish) {
                    return;
                }
                if (this.m_xiangdaoid == 1) {
                    if (ui_map.getMe()) {
                        yindaoMgr.getMe().createyindao( ui_map.getMe().m_scene_1, false);
                    }
                } else if (this.m_xiangdaoid == 2) {
                    if (ui_map.getMe()) {
                        yindaoMgr.getMe().createyindao( ui_map.getMe().m_scene_1, false);
                    }
                } else if (this.m_xiangdaoid == 3) {
                    this.m_xiangdaoid = 0;
                }
            }
                break;

            case g_yindaoType.yindaoType_GUANKA2:
            {
                if (!this.m_isfinish) {
                    return;
                }
                if (this.m_xiangdaoid == 1) {
                    if (ui_map.getMe()) {
                        yindaoMgr.getMe().createyindao( ui_map.getMe().m_scene_1, false);
                    }
                } else if (this.m_xiangdaoid == 2) {
                    this.m_xiangdaoid = 0;
                }
            }
                break;

            default:
                break
        }
    },
    shutdown: function () {
        this.m_arr_yindao = null;
    }
});

yindaoMgr.getMe = function () {
    return yindaoMgr.create();
};

yindaoMgr.create = function () {
    if (yindaoMgr.g_instarn == null) {
        yindaoMgr.g_instarn = new yindaoMgr();
        return yindaoMgr.g_instarn;
    }
    else {
        return yindaoMgr.g_instarn;
    }

};