/**
 * Created by Allen on 2016/6/27.
 */


//

var ui_yueka = UiBase.extend({
    m_CBaseKeyState: null,
    ctor: function () {
        this._super();
        this.m_des = "ui_yueka类";
        this.m_CBaseKeyState = new BaseKeyState();
    },

    oninit: function (data) {

        var root = this._parseUIFile("yueka.json", 0);
        this.EnterUI();
        this.addChild(root);
        this.shipeiCenter(root);


        var lingqu1_che = ccui.helper.seekWidgetByName(root, "lingqu1");
        lingqu1_che.addTouchEventListener(this.lingqu1_func, this);

        var lingqu2_che = ccui.helper.seekWidgetByName(root, "lingqu2");
        lingqu2_che.addTouchEventListener(this.lingqu2_func, this);

        var maiyueka1_che = ccui.helper.seekWidgetByName(root, "maiyueka1");
        maiyueka1_che.addTouchEventListener(this.maiyueka1_func, this);

        var maiyueka2_che = ccui.helper.seekWidgetByName(root, "maiyueka2");
        maiyueka2_che.addTouchEventListener(this.maiyueka2_func, this);

        this.m_CBaseKeyState.regNodeEx(lingqu1_che, 1);
        this.m_CBaseKeyState.regNodeEx(lingqu2_che, 2);

        this.m_CBaseKeyState.regNodeEx(maiyueka1_che, 3);
        this.m_CBaseKeyState.regNodeEx(maiyueka2_che, 4);

        this.m_CBaseKeyState.init(this);

        this.updateUI();
    },

    updateUI: function () {

        var goldyuekaInfo = fileMgr.getMe().getShopInfoItem_byid(9);
        var zuanshiyuekaInfo = fileMgr.getMe().getShopInfoItem_byid(10);
        var gold_num = ccui.helper.seekWidgetByName(this.m_root, "Text_1");
        gold_num.setString(goldyuekaInfo.gold);
        var zuanshi_num = ccui.helper.seekWidgetByName(this.m_root, "Text_2");
        zuanshi_num.setString(zuanshiyuekaInfo.zuanshi)
        var gold_syday = ccui.helper.seekWidgetByName(this.m_root, "Text_3");
        var zuanshi_syday = ccui.helper.seekWidgetByName(this.m_root, "Text_4");

        var curdate = DataMgr.getMe().getcurdate();
        var goldyueka_num = DataMgr.getMe().getyueka("goldyueka");
        var goldyueka_timeout = DataMgr.getMe().getyueka_timeout("goldyueka");

        var syday = everyDayMgr.getMe().DateDiff(goldyueka_timeout, curdate);
        if (DataMgr.getMe().getyueka_islingqu("goldyueka")) { //已经领取减一天
            syday = syday - 1;
        }
        if (syday < 0) {
            syday = 0;
        }

        gold_syday.setString("剩余天数: " + syday + "/" + goldyueka_num * 30);

        var zuanshiyueka_num = DataMgr.getMe().getyueka("zuanshiyueka");
        var zuanshiyueka_timeout = DataMgr.getMe().getyueka_timeout("zuanshiyueka"); //获取月卡过期时间
        syday = everyDayMgr.getMe().DateDiff(zuanshiyueka_timeout, curdate);
        if (DataMgr.getMe().getyueka_islingqu("zuanshiyueka")) { //已经领取减一天
            syday = syday - 1;
        }
        if (syday < 0) {
            syday = 0;
        }
        zuanshi_syday.setString("剩余天数:" + syday + "/" + zuanshiyueka_num * 30);

    },

    onKeyPressed: function (keyCode) {
        this._super(keyCode);
    },

    onBack: function () {

        this.endLayout(function () {
            uiMgr.getMe().show_ui_root(true);
            uiMgr.getMe().show_ui_yueka(false);
        });

    },


    //领取今日金币月卡奖励
    lingqu1_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                var curdate = DataMgr.getMe().getcurdate();
                var goldyueka_timeout = DataMgr.getMe().getyueka_timeout("goldyueka");
                var syday = everyDayMgr.getMe().DateDiff(goldyueka_timeout, curdate);
                if (syday < 0) {
                    uiMgr.getMe().show_ui_MessageBox2(true, "    您的金币月卡已过期！");
                    return;
                }

                if (DataMgr.getMe().getyueka_islingqu("goldyueka")) {
                    uiMgr.getMe().show_ui_MessageBox2(true, "    已经领取今日金币月卡奖励！");
                    return;
                }
                var goldyuekaInfo = fileMgr.getMe().getShopInfoItem_byid(9);
                DataMgr.getMe().addgold(goldyuekaInfo.gold);
                DataMgr.getMe().setyueka_islingqu("goldyueka", true);
                uiMgr.getMe().show_ui_playOnce("lingquchenggong.json", "play");
                this.updateUI();
            }
                break;
            default:
                break;
        }
    },

//领取今日勋章月卡奖励
    lingqu2_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                var curdate = DataMgr.getMe().getcurdate();
                var zuanshiyueka_timeout = DataMgr.getMe().getyueka_timeout("zuanshiyueka");
                var syday = everyDayMgr.getMe().DateDiff(zuanshiyueka_timeout, curdate);
                if (syday < 0) {
                    uiMgr.getMe().show_ui_MessageBox2(true, "    您的勋章月卡已过期！");
                    return;
                }

                if (DataMgr.getMe().getyueka_islingqu("zuanshiyueka")) {
                    uiMgr.getMe().show_ui_MessageBox2(true, "    已经领取今日勋章月卡奖励！");
                    return;
                }

                var zuanshiyuekaInfo = fileMgr.getMe().getShopInfoItem_byid(10);
                DataMgr.getMe().addzuanshi(zuanshiyuekaInfo.zuanshi);
                DataMgr.getMe().setyueka_islingqu("zuanshiyueka", true);
                uiMgr.getMe().show_ui_playOnce("lingquchenggong.json", "play");
                this.updateUI();
            }
                break;
            default:
                break;
        }
    },

//购买金币月卡
    maiyueka1_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                var callback_func = MyCallback.create(this.updateUI, this, null);
                iapMgr.getMe().buy(9, callback_func);
            }
                break;
            default:
                break;
        }
    },

    //购买勋章月卡
    maiyueka2_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                var callback_func = MyCallback.create(this.updateUI, this, null);
                iapMgr.getMe().buy(10, callback_func);
            }
                break;
            default:
                break;
        }
    }
});


ui_yueka.ShowOrHide = function (flag) {
    if (flag == true) {
        if (ui_yueka.g_instarn == null) {
            ui_yueka.g_instarn = new ui_yueka();
            uiMgr.getMe().addChild(ui_yueka.g_instarn, 10001);

            ui_yueka.g_instarn.oninit('');
            return ui_yueka.g_instarn;
        }
        else {
            return ui_yueka.g_instarn;
        }
    }
    else {
        if (ui_yueka.g_instarn != null) {
            ui_yueka.g_instarn.shutdown();
            uiMgr.getMe().removeChild(ui_yueka.g_instarn);
            ui_yueka.g_instarn = null;
        }

    }

};