//var UIEnum_Type =
//{
//    UI_CONNECT : 0,
//    UI_WAITING : 1,
//    UI_contorlUI : 2,
//    UI_GETACCOUNT : 3,
//    UI_CHANGE_ACCOUNT: 4,
//    UI_LOGIN: 5,
//    UI_ZHUCE: 6,
//    UI_BANGDING: 7,
//    UI_CHANAGENICHENG: 8,//换昵称
//    UI_ROOT: 9,
//    UI_selectPlayDev: 10,
//    UI_selectPlayFIght: 11,
//    UI_TOOL: 12,
//    UI_MAP: 13,
//    UI_ZHANYI: 14,
//    UI_RENWUJIESHAO: 15,
//    UI_RANKINGLIST: 16,
//    UI_QIANDAO: 17,
//    UI_RENWUJIEMIAN: 18,
//    UI_ZHANYI_CHUZHAN: 19,
//    UI_ZHANYI_CHUZHAN_XUANZE: 20,
//    UI_TIP: 21,
//    UI_HELP: 22,
//    UI_SETTING: 23,
//    UI_NANDU: 24,
//    UI_MESSAGEBOX: 25,
//    UI_ZHANTING: 26,
//    UI_JIANGLI: 27,
//    UI_SHIBAI_SHENGLI: 28,
//    UI_SHIBAI_SHENGLI_SHOUHU: 30,
//
//    UI_shibai_shengli_DoubleFightScene: 31,
//    UI_shibai_shengli_ShiwanScene: 32,
//    UI_SHIBAI_SHENGLI_TPLAY: 33,
//    UI_BUY_GOLD: 34,
//    UI_DUIHUAN: 35,
//    UI_CHENGJIU: 36
//};

var UiBase = cc.LayerColor.extend({
    m_des: "描述下這个ui类",
    m_type: 0,
    m_pLayout: null,
    m_curstate: null,
    m_Keyboard: false,
    m_key_not_close: true,
    m_root: null,
    m_touchListener: null,
    m_uiannimationList: null,
    m_endLayout: false,

    ctor: function () {
        this._super();
        this.initColor();
        uiMgr.getMe().adduibase(this);
        this.initTouch();
    },

    initTouch: function () {

        var touchListener =
        {
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan.bind(this),
        };
        cc.eventManager.addListener(touchListener, this);
        this.m_touchListener = touchListener;
    },


    onTouchBegan: function (touch, event)
    {
        var target = event.getCurrentTarget();

        if (this.m_key_not_close == false)
        {
            return false;
        }

        if (!uiMgr.getMe()._topUiBase) {
            return false;
        }
        if (uiMgr.getMe()._topUiBase.__instanceId != target.__instanceId) {
            return true;
        }


        if (!target.isVisible() || (!this.isTouchInside(target, touch))) {
            return false;
        }
        return true;
    },
    isTouchInside: function (owner, touch) {
        if (!owner || !owner.getParent()) {
            return false;
        }
        var touchLocation = touch.getLocation(); // Get the touch position
        touchLocation = owner.getParent().convertToNodeSpace(touchLocation);
        return cc.rectContainsPoint(owner.getBoundingBox(), touchLocation);
    },
    //界面结束的时候调用
    shutdown: function () {
        // cc.eventManager.addListener( this.m_touchListener, this);
        uiMgr.getMe().deleteuibase(this);
    },

    //初始化背景透明度
    initColor: function () {
        this.setColor(cc.color(0, 0, 0));
        this.setOpacity(255 * 0.7);

        return true;
    },


    //playAnimation: function (name, loop) {
    //    var node = this.m_pLayout.node;
    //    var action = this.m_pLayout.action; // 动作
    //    node.runAction(action); // 播放动作
    //    action.play(name, loop);
    //},

    playAnimationEx: function (_pLayout, name, loop, callback, target) {
        if (loop == null) {
            loop = true;
        }

        if (_pLayout == null) {
            if (callback !== undefined && target !== undefined) {
                callback.call(target);
            }
            return false;
        }

        var node = _pLayout.node;
        var action = _pLayout.action; // 动作

        if (action.getTarget() == null) {
            node.runAction(action); // 播放动作
        }

        if (callback !== undefined && target !== undefined) {
            callback.bind(target);
            action.clearLastFrameCallFunc();
            action.setLastFrameCallFunc(function () {
                callback.call(target)
            });
            action.play(name, loop);
        }
        else {
            action.play(name, loop);
        }
    },

    //播放ui 动画
    playAnimation: function (name, loop, callback, target) {

        if (this.m_pLayout == null) {
            if (callback !== undefined && target !== undefined) {
                callback.call(target);
            }

            return false;
        }

        var node = this.m_root;

        var action = this.m_pLayout.action; // 动作

        if (action.getTarget() == null) {
            node.runAction(action); // 播放动作
        }


        if (callback !== undefined && target !== undefined) {
            callback.bind(target);
            action.clearLastFrameCallFunc();
            action.setLastFrameCallFunc(function () {
                callback.call(target)
            });
            action.play(name, loop);
        } else {
            action.play(name, loop);
        }
    },

//是否在播放ui动画
    isPlay: function () {
        var action = this.m_pLayout.action; // 动作
        if(action == null)
        {
            return false;
        }
        return action.isPlaying();
    },
//解析ui 资源
    _parseUIFile: function (file, cocoStudioOldApi, shipei) {
        cc.log("ccs.load : %s", file);
        console.log("_parseUIFile ccs.load " + file);
        var json = ccs.load("xingjieyuanqiyongzhe/big/ui/" + file);
        this.m_pLayout = json;
        this.m_root = this.m_pLayout.node;
        this.playBackMusic();

        return this.m_root;
    },

    //
    parseUiFile_static: function (file) {
        cc.log("parseUiFileEx ccs.load : %s", file);
        var json = ccs.load("xingjieyuanqiyongzhe/big/ui/" + file);
        return json;
    },


    playBackMusic: function () {
        try {
            if (this.m_root) {
                var data = this.m_root.getComponent("ComExtensionData").getCustomProperty();
                if (data != "" && data != null) {
                    var outjson = JSON.parse(data);
                    if (outjson["bm"] != null) {
                        musicMgr.getMe().playbackmusic(outjson["bm"]);
                    }
                    else if (outjson["click"] != null) {
                        musicMgr.getMe().playeffect(outjson["click"]);
                    }
                }
            }
        }
        catch (e) {
            throw e;
            cb("load json [" + url + "] failed : " + e);
            uiMgr.getMe().show_ui_MessageBox(true, "用户数据填错了");

        }
    },


    backEvent: function (sender, type) {
        if (type == ccui.Widget.TOUCH_ENDED) {

        }
    },

    onInitDialog: function () {
        return true;
    },

    loop: function (t) {
        this.onUpdate(t);
    },
    onUpdate: function (t) {

        if (this.m_curstate != null) {
            this.m_curstate.loop(t);

        }

    },

    onKeyUp: function (keyCode, event) {

    },
    onKeyDown: function (keyCode, event) {

    },

    left: function () {
        if (this.m_curstate) {
            return this.m_curstate.left();
        }
    },
    right: function () {
        if (this.m_curstate) {
            return this.m_curstate.right();
        }
    },
    up: function () {
        if (this.m_curstate) {
            return this.m_curstate.up();
        }
    },
    down: function () {
        if (this.m_curstate) {
            return this.m_curstate.down();
        }
    },

    left_Released: function () {
        return true;
    },

    right_Released: function () {
        return true;
    },

    up_Released: function () {
        return true;
    },

    down_Released: function () {
        return true;
    },

    DoEnterCurButton: function () {
        if (this.m_curstate != null) {
            return this.m_curstate.DoEnterCurButton();
        }
    },

    DoEnterCurButton_Released: function () {

    },

    onMenu: function () {

    },

    onMenu_Released: function () {

    },

    onBack: function () {

    },

    onBack_Released: function () {

    },

    playAnimationList: function (animationMaplist) {

        if (animationMaplist.size() <= 0) {
            return;
        }
        this.m_uiannimationList = animationMaplist;
        var it = this.m_uiannimationList.pop();
        this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
    },

    playAnimationListCallback: function () {

        if (this.m_uiannimationList.size() <= 0) {
            //this.m_Vis_key = true;
            return;
        }


        var it = this.m_uiannimationList.pop();
        this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
    },

    EnterUI: function () {
        //this.m_Vis_key = false;
        var animationlist = new Queue();
        var info = {};
        info.animation = "playstart";
        info.loop = false;
        animationlist.push(info);
        var info2 = {};
        info2.animation = "play";
        info2.loop = true;
        animationlist.push(info2);
        this.playAnimationList(animationlist);
    },

    //结束ui
    endLayout: function (callback) {
        //this.m_key_not_close = false;
        this.m_endLayout = true;
        if (callback)
        {
            this.playAnimation("playend", false, function () {
                callback.call(this);
                this.endLayoutCallBack();
            }, this);
        }
        else
        {
            this.playAnimation("playend", false, this.endLayoutCallBack, this);
        }

    },


    endLayoutCallBack: function () {
        this.m_key_not_close = true;
    },

    EnterUIEx: function (startname, loopname) {

    },

    releaseKeyBoard: function () {
        //if ('keyboard' in cc.sys.capabilities)
        //{
        //    cc.eventManager.dispatchCustomEvent("keyboard", "");
        //}
        //else
        //{
        //    cc.log("KEYBOARD Not supported");
        //}
    },


    onKeyPressed: function (keyCode) {
        //if (this.m_Vis_key == false) {
        //    return;
        //}
        if( this.m_endLayout == true)
        {
            return;
        }

        if (this.m_key_not_close == false) {
            return;
        }
        cc.log("UiBase::onKeyPressed() " + keyCode);
        switch (keyCode) {
            case cc.KEY.escape:
            case cc.KEY.back:
            {
                this.onBack();
            }
                break;

                break;
            case cc.KEY.up:
            case cc.KEY.dpadUp:
            {
                this.up();
            }
                break;
            case cc.KEY.down:
            case cc.KEY.dpadDown:
            {
                this.down();
            }
                break;
            case cc.KEY.left:
            case cc.KEY.dpadLeft:
            {
                this.left();
            }
                break;
            case cc.KEY.right:
            case cc.KEY.dpadRight:
            {
                this.right();
            }
                break;


            case cc.KEY.dpadCenter:
            case cc.KEY.enter:
            {
                this.DoEnterCurButton();
            }
                break;
            case cc.KEY.f1:
            case cc.KEY.menu:
            case cc.KEY.num1:

            {
                this.onMenu();
            }
                break;
            default:
                break;
        }

    },

    onKeyReleased: function (keyCode) {
        //if (this.m_Vis_key == false) {
        //    return;
        //}
        if( this.m_endLayout == true)
        {
            return;
        }
        if (this.m_key_not_close == false) {
            return;
        }
        cc.log("UiBase::onKeyReleased() " + keyCode);

        switch (keyCode) {
            case cc.KEY.up:
            case cc.KEY.dpadUp:
            {
                this.up_Released();
            }
                break;
            case cc.KEY.down:
            case cc.KEY.dpadDown:
            {
                this.down_Released();
            }
                break;
            case cc.KEY.left:
            case cc.KEY.dpadLeft:


            {
                this.left_Released();
            }
                break;
            case cc.KEY.right:
            case cc.KEY.dpadRight:


            {
                this.right_Released();
            }
                break;


            case cc.KEY.escape:
            case cc.KEY.back:
            {
                this.onBack_Released();
            }
                break;

            case cc.KEY.enter:
            case cc.KEY.dpadCenter:
            {
                this.DoEnterCurButton_Released();
            }
                break;
            case cc.KEY.f1:
            case cc.KEY.menu:
            case cc.KEY.num1:
            {
                this.onMenu_Released();
            }
                break;
            default:
                break;
        }


    },
    shipeiTop: function (playout) {
        var winSize = cc.director.getWinSize();
        playout.setPosition(cc.p(winSize.width / 2, winSize.height));
        playout.setAnchorPoint(cc.p(0.5, 1));
        playout.setScale(uiMgr.getMe().getUiScale());
    },

    shipeiRight: function (playout) {
        var winSize = cc.director.getWinSize();
        playout.setPosition(cc.p(winSize.width, winSize.height / 2));
        playout.setAnchorPoint(cc.p(1, 0.5));

        playout.setScale(uiMgr.getMe().getUiScale());

    },
    shipeiLift: function (playout) {

        var winSize = cc.director.getWinSize();
        playout.setPosition(cc.p(winSize.width / 2, 0));
        playout.setAnchorPoint(cc.p(0, 0.5));

        playout.setScale(uiMgr.getMe().getUiScale());
    },

    shipeiBottom: function (playout) {
        var winSize = cc.director.getWinSize();
        playout.setPosition(cc.p(winSize.width / 2, 0));
        playout.setAnchorPoint(cc.p(0.5, 0));

        playout.setScale(uiMgr.getMe().getUiScale());
    },
    shipeiCenter_720: function (playout) {
        var winSize = cc.director.getWinSize();
        playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
        playout.setAnchorPoint(cc.p(0.5, 0.5));
        playout.setScale( uiMgr.getMe().getUiScale_720() );
        return playout.getScale();
    },
    shipeiCenter: function (playout) {
        var winSize = cc.director.getWinSize();
        playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
        playout.setAnchorPoint(cc.p(0.5, 0.5));

        playout.setScale(uiMgr.getMe().getUiScale());

        return playout.getScale();
    },

    getUiType: function () {
        return m_type;
    }


});


