
 // 没有消息相应的 ui 节点

var uiBaseNode = cc.Node.extend({
    m_des: "描述下這个ui类",
    m_pLayout: null,
    m_root: null,
    m_uiannimationList: null,
    ctor: function () {
        this._super();
    },

    shutdown: function () {
    },


    playAnimationEx: function ( _pLayout , name , loop , callback , target )
    {
        if(loop == null)
        {
            loop = true;
        }

        if (_pLayout == null) {
            if (callback !== undefined && target !== undefined) {
                callback.call(target);
            }
            return false;
        }

        var node = _pLayout.node;
        var action = _pLayout.action; // 动作

        if (action.getTarget() == null)
        {
            node.runAction(action); // 播放动作
        }

        if ( callback !== undefined && target !== undefined ) {
            callback.bind(target);
            action.clearLastFrameCallFunc();
            action.setLastFrameCallFunc(function () {
                callback.call(target)
            });
            action.play(name, loop);
        }
        else
        {
            action.play(name, loop);
        }
    },


    playAnimation: function (name, loop, callback, target) {

        if (this.m_pLayout == null) {
            if (callback !== undefined && target !== undefined) {
                callback.call(target);
            }

            return false;
        }

        var node = this.m_root;

        var action = this.m_pLayout.action; // 动作

        if (action.getTarget() == null) {
            node.runAction(action); // 播放动作
        }


        if (callback !== undefined && target !== undefined) {
            callback.bind(target);
            action.clearLastFrameCallFunc();
            action.setLastFrameCallFunc(function () {
                callback.call(target)
            });
            action.play(name, loop);
        } else {
            action.play(name, loop);
        }
    },

//
    isPlay: function () {
        var action = this.m_pLayout.action; // 动作
        return action.isPlaying();
    },

    _parseUIFile: function (file) {
        cc.log("ccs.load : %s", file);
        var json = ccs.load("xingjieyuanqiyongzhe/big/ui/" + file);
        this.m_pLayout = json;
        this.m_root = this.m_pLayout.node;


        return this.m_root;
    },

    //
    parseUiFile_static: function (file) {
        cc.log("parseUiFileEx ccs.load : %s", file);
        var json = ccs.load("xingjieyuanqiyongzhe/big/ui/" + file);
        return json;
    },




    loop: function (t) {
        this.onUpdate(t);
    },
    onUpdate: function (t) {



    },




    playAnimationList: function (animationMaplist) {

        if (animationMaplist.size() <= 0) {
            return;
        }
        this.m_uiannimationList = animationMaplist;
        var it = this.m_uiannimationList.pop();
        this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
    },

    playAnimationListCallback: function () {

        if (this.m_uiannimationList.size() <= 0) {
            //this.m_Vis_key = true;
            return;
        }


        var it = this.m_uiannimationList.pop();
        this.playAnimation(it.animation, it.loop, this.playAnimationListCallback, this);
    },

    EnterUI: function () {
        //this.m_Vis_key = false;
        var animationlist = new Queue();
        var info = {};
        info.animation = "playstart";
        info.loop = false;
        animationlist.push(info);
        var info2 = {};
        info2.animation = "play";
        info2.loop = true;
        animationlist.push(info2);
        this.playAnimationList(animationlist);
    },

    //结束ui
    endLayout: function (callback) {
        this.m_key_not_close = false;
        if (callback) {
            this.playAnimation("playend", false, function (){
                callback.call(this);
                this.endLayoutCallBack();
            }, this);

        }
        else
        {
            this.playAnimation("playend", false, this.endLayoutCallBack, this);
        }

    },


    endLayoutCallBack: function () {
        this.m_key_not_close = true;
    },


    shipeiCenter: function (playout) {
             var winSize = cc.director.getWinSize();
        playout.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
        playout.setAnchorPoint(cc.p(0.5, 0.5));

        playout.setScale(uiMgr.getMe().getUiScale());

        return playout.getScale();
    },




});


