//json

//json 遍历代码
//如果是jsonarray就外面套一层for即可
//var jsonarray =yourarray;
//for(var i =0;i<jsonarray.length;i++){
//    var jsonobj = jsonarray[i];
//    for(var x in jsonobj){
//        document.write(x+"="+jsonobj[x]);
//    }
//}

var g_MaxLevel = 100;
var g_SkillMaxLevel = 20;
var g_EquipMaxLevel = 20;

//主要用于玩家存档
var DataMgr = cc.Class.extend({

    ctor: function () {
    },

    getPlayDoc: function () {
        return fileMgr.getMe().m_play_doc;
    },

    //返回场景中有多少个%100 占有率的场景
    getAllPerScene_num: function () {
        var ret = 0;
        var scenes_list = fileMgr.getMe().m_play_doc["scenes"];
        for (var p in scenes_list) {
            var curzhanlingper = scenes_list[p]["curzhanlingper"];
            if (curzhanlingper == 100) {
                ++ret;
            }
        }
        return ret;
    },


    //返回当前英雄的攻击点数
    getHeroGongji_num: function (name) {
        //assertNull(name, "getHeroGongji_num : name ");
        if (name == null) {
            return null;
        }
        if (fileMgr.getMe().m_play_doc["heros"][name] == null) {
            return null;
        }
        var ret = fileMgr.getMe().m_play_doc["heros"][name]["jinggong_num"];
        return ret;
    },

    //消耗英雄攻击点数
    removeHeroGongji_num: function (name, num) {
        var ret = fileMgr.getMe().m_play_doc["heros"][name]["jinggong_num"];
        ret -= num;
        if (ret < 0) {
            ret = 0;
        }
        fileMgr.getMe().m_play_doc["heros"][name]["jinggong_num"] = ret;
    },


//返回当前英雄的fangshou点数
    getHeroFangshou_num: function (name) {
        //assertNull(name, "getHeroFangshou_num : name ");
        if (name == null) {
            return null;
        }
        if (fileMgr.getMe().m_play_doc["heros"][name] == null) {
            return null;
        }
        var ret = fileMgr.getMe().m_play_doc["heros"][name]["fangshou_num"];
        return ret;
    },
    //消耗英雄攻击点数
    removeHerofangshou_num: function (name, num) {
        var ret = fileMgr.getMe().m_play_doc["heros"][name]["fangshou_num"];
        ret -= num;
        if (ret < 0) {
            ret = 0;
        }
        fileMgr.getMe().m_play_doc["heros"][name]["fangshou_num"] = ret;
    },

    getSceneZhuxianLockId: function (name) {
        var scenelist = fileMgr.getMe().m_play_doc.g_zhuxian_scene;
        for (var i = 1; i <= 51; ++i) {
            if (name === scenelist[i]["name"]) {
                return i;
            }

        }
        return null;


    },

    getcurSceneZhuxian: function () {
        var scenelist = fileMgr.getMe().m_play_doc.g_zhuxian_scene;
        var zhuxianobj = null;
        for (var i = 1; i <= 51; ++i) {
            zhuxianobj = scenelist[i];
            if (scenelist[i] == null) {
                console.log("error getcurSceneZhuxian " + i);
            }

            if (scenelist[i]["lock"] == null) {
                console.log("error getcurSceneZhuxian" + i);
            }

            if (parseInt(scenelist[i]["lock"]) == 0) {

                return zhuxianobj;
            }
        }

        return null;
    },


    //主线是否能战斗
    getcurSceneZhuxianCanFight: function () {
        var scenelist = fileMgr.getMe().m_play_doc.g_zhuxian_scene;
        var zhuxianobj = null;
        for (var i = 1; i <= 51; ++i) {
            zhuxianobj = scenelist[i];
            if (scenelist[i] == null) {
                console.log("error getcurSceneZhuxian " + i);
            }

            if (scenelist[i]["lock"] == null) {
                console.log("error getcurSceneZhuxian" + i);
            }

            if (parseInt(scenelist[i]["lock"]) == 0) {

                // 防守失败后，关卡被敌人占领，被隔开的主线任务不能打，需要把敌人占领的关卡抢夺回来才可以继续主线任务

                var checkinfo = g_uiKeyLogic["guanka_tongguanLine"][scenelist[i]["name"]];
                var isCanFight = false;

                var up_checkinfo = DataMgr.getMe().isSceneZhanling(checkinfo["up"]);
                var down_checkinfo = DataMgr.getMe().isSceneZhanling(checkinfo["down"]);
                var left_checkinfo = DataMgr.getMe().isSceneZhanling(checkinfo["left"]);
                var right_checkinfo = DataMgr.getMe().isSceneZhanling(checkinfo["right"]);

                var upid = this.getSceneZhuxianLockId(checkinfo["up"]);
                var downid = this.getSceneZhuxianLockId(checkinfo["down"]);
                var leftid = this.getSceneZhuxianLockId(checkinfo["left"]);
                var rightid = this.getSceneZhuxianLockId(checkinfo["right"]);


                if (upid > i && up_checkinfo == true) {
                    up_checkinfo = false;
                }

                if (downid > i && down_checkinfo == true) {
                    down_checkinfo = false;
                }
                if (leftid > i && left_checkinfo == true) {
                    left_checkinfo = false;
                }

                if (rightid > i && right_checkinfo == true) {
                    right_checkinfo = false;
                }

                if (upid == null) {
                    up_checkinfo = false;
                }
                if (downid == null) {
                    down_checkinfo = false;
                }
                if (leftid == null) {
                    left_checkinfo = false;
                }
                if (rightid == null) {
                    right_checkinfo = false;
                }

                if (up_checkinfo || down_checkinfo || left_checkinfo || right_checkinfo) {
                    isCanFight = true;
                }

                if (isCanFight == false) {
                    return null;
                }

                return true;
            }
        }

        return false;
    },
    setSceneZhuxianIsLock: function (scenename) {
        var scenelist = fileMgr.getMe().m_play_doc.g_zhuxian_scene;
        for (var i = 1; i <= 51; ++i) {
            if (scenelist[i]["name"] == scenename) {
                scenelist[i]["lock"] = 1;
            }
        }
    },
    sceneZhuxianIsLock: function (scenename) {
        var scenelist = fileMgr.getMe().m_play_doc.g_zhuxian_scene;
        for (var i = 1; i <= 51; ++i) {
            if (scenelist[i]["name"] == scenename) {
                return parseInt(scenelist[i]["lock"]);
            }
        }
        return 0;
    },

    addzuanshi: function (num) {
        if (num == null) {
            console.error("addzuanshi");
            return false;
        }

        if (num < 0) {
            console.error("addzuanshi");
            return false;
        }

        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var buffnum = fileMgr.getMe().m_play_doc["coreData"]["zuanshi"] + num;
        if (buffnum > Number.MAX_VALUE) {
            console.error("addzuanshi");
            return false;
        }
        fileMgr.getMe().m_play_doc["coreData"]["zuanshi"] += num;

        uiMgr.getMe().updateGoldandDiamonds();
        return true;
    },

    //获取当前日期
    getcurdate: function () {
        return DataMgr.getMe().getPlayDoc().curdate;
    },

    //获取yueka过期时间
    getyueka_timeout: function (name) {
        if (name == "goldyueka") {
            return fileMgr.getMe().m_play_doc["yueka"]["goldyueka_timeout"];
        } else if (name == "zuanshiyueka") {
            return fileMgr.getMe().m_play_doc["yueka"]["zuanshiyueka_timeout"];
        }
        return null;
    },


    //获取yueka是否领取
    getyueka_islingqu: function (name) {
        if (name == "goldyueka") {
            return fileMgr.getMe().m_play_doc["yueka"]["lingqu_goldyueka"];
        } else if (name == "zuanshiyueka") {
            return fileMgr.getMe().m_play_doc["yueka"]["lingqu_zuanshiyueka"];
        }
        return null;
    },

    //设置yueka是否领取
    setyueka_islingqu: function (name, islingqu) {
        if (name == "goldyueka") {
            fileMgr.getMe().m_play_doc["yueka"]["lingqu_goldyueka"] = islingqu;
        } else if (name == "zuanshiyueka") {
            fileMgr.getMe().m_play_doc["yueka"]["lingqu_zuanshiyueka"] = islingqu;
        }
    },


    //获取yueka 数量
    getyueka: function (name) {
        if (name == "goldyueka") {
            return fileMgr.getMe().m_play_doc["yueka"]["goldyueka"];
        } else if (name == "zuanshiyueka") {
            return fileMgr.getMe().m_play_doc["yueka"]["zuanshiyueka"];
        }
        return null;
    },

    //增加月卡
    addyueka: function (name) {
        if (name != "goldyueka" && name != "zuanshiyueka") {
            console.error("addyueka");
            return false;
        }

        var buffnum = fileMgr.getMe().m_play_doc["yueka"][name] + 1;
        if (buffnum > Number.MAX_VALUE) {
            console.error("addyueka");
            return false;
        }

        fileMgr.getMe().m_play_doc["yueka"][name] += 1;

        this.addyueka_timeout(name);
        return true;
    },

    //增加月卡到期时间
    addyueka_timeout: function (name) {
        var curDate = DataMgr.getMe().getPlayDoc().curdate;
        curDate = new Date(curDate);

        if (name == "goldyueka") {
            var yueka_timeout = this.getyueka_timeout(name);
            yueka_timeout = new Date(yueka_timeout);
            if (yueka_timeout > curDate) {
                var timebuff = new Date(yueka_timeout.valueOf() + 30 * 24 * 60 * 60 * 1000);
                timebuff = timebuff.toJSON();
                timebuff = timebuff.substring(0, timebuff.indexOf('T'));
                fileMgr.getMe().m_play_doc["yueka"]["goldyueka_timeout"] = timebuff;
            } else {
                var timebuff = new Date(curDate.valueOf() + 30 * 24 * 60 * 60 * 1000);
                timebuff = timebuff.toJSON();
                timebuff = timebuff.substring(0, timebuff.indexOf('T'));
                fileMgr.getMe().m_play_doc["yueka"]["goldyueka_timeout"] = timebuff;
            }

        } else if (name == "zuanshiyueka") {

            var yueka_timeout = this.getyueka_timeout(name);
            yueka_timeout = new Date(yueka_timeout);
            if (yueka_timeout > curDate) {
                var timebuff = new Date(yueka_timeout.valueOf() + 30 * 24 * 60 * 60 * 1000);
                timebuff = timebuff.toJSON();
                timebuff = timebuff.substring(0, timebuff.indexOf('T'));
                fileMgr.getMe().m_play_doc["yueka"]["zuanshiyueka_timeout"] = timebuff;
            } else {
                var timebuff = new Date(curDate.valueOf() + 30 * 24 * 60 * 60 * 1000);
                timebuff = timebuff.toJSON();
                timebuff = timebuff.substring(0, timebuff.indexOf('T'));
                fileMgr.getMe().m_play_doc["yueka"]["zuanshiyueka_timeout"] = timebuff;
            }
        }
    },

    getyaoshui: function (name) {
        var item = fileMgr.getMe().m_play_doc["items"];

        for (var i in item) {
            if (item[i]["name"] == name) {
                return item[i]["num"];
            }
        }
        return null;
    },

    addyaoshui: function (name, num) {

        if (num == 0) {
            return false;
        }

        if (num == null) {
            console.error("addyaoshui");
            return false;
        }

        if (num < 0) {
            console.error("addyaoshui");
            return false;
        }

        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var item = fileMgr.getMe().m_play_doc["items"];

        for (var i in item) {
            if (item[i]["name"] == name) {
                var buffnum = item[i]["num"] + num;
                if (buffnum > Number.MAX_VALUE) {
                    console.error("addyaoshui");
                    return false;
                }
                item[i]["num"] += num;
            }
        }

        return true;
    },


    removeyaoshui: function (name, num) {
        if (num == null) {
            console.error("removeyaoshui");
            return false;
        }

        if (num < 0) {
            console.error("removeyaoshui");
            return false;
        }

        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var item = fileMgr.getMe().m_play_doc["items"];

        for (var i in item) {
            if (item[i]["name"] == name) {
                var buffnum = item[i]["num"] - num;
                if (buffnum < 0) {
                    console.error("removeyaoshui");
                    return false;
                }
                item[i]["num"] -= num;
            }
        }

        everyTaskMgr.getMe().yaoshui_task(name, num);

        return true;
    },

    getzuanshi: function () {
        return fileMgr.getMe().m_play_doc["coreData"]["zuanshi"];
    },

    //增加武魂碎片
    addsuipian: function (num) {
        if (num == null) {
            console.error("addsuipian");
            return false;
        }
        if (num < 0) {
            console.error("addsuipian");
            return false;
        }
        //
        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var item = fileMgr.getMe().m_play_doc["items"];

        for (var i in item) {
            if (item[i]["name"] == "suipian") {
                var buffnum = item[i]["num"] + num;
                if (buffnum > Number.MAX_VALUE) {
                    console.error("addsuipian");
                    return false;
                }
                item[i]["num"] += num;
            }
        }


        uiMgr.getMe().updateGoldandDiamonds();

        return true;
    },

    removeSuipian: function (num) {
        if (num == null) {
            console.error("removeSuipian");
            return false;
        }

        if (num < 0) {
            console.error("removeSuipian");
            return false;
        }

        //
        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var item = fileMgr.getMe().m_play_doc["items"];

        for (var i in item) {
            if (item[i]["name"] == "suipian") {
                var buffnum = item[i]["num"] - num;
                if (buffnum < 0) {
                    console.error("removeSuipian");
                    return false;
                }
                item[i]["num"] -= num;
            }
        }

        uiMgr.getMe().updateGoldandDiamonds();
        return true;
    },


    getsuipian: function () {
        var item = fileMgr.getMe().m_play_doc["items"];

        for (var i in item) {
            if (item[i]["name"] == "suipian") {
                return item[i]["num"];
            }
        }
        return null;
    },

    addgold: function (num) {
        if (num == null) {
            console.error("addgold");
            return false;
        }
        if (num < 0) {
            console.error("addgold");
            return false;
        }
        //
        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var buffnum = fileMgr.getMe().m_play_doc["coreData"]["zuanshi"] + num;
        if (buffnum > Number.MAX_VALUE) {
            console.error("addgold");
            return false;
        }
        fileMgr.getMe().m_play_doc["coreData"]["gold"] += num;

        uiMgr.getMe().updateGoldandDiamonds();

        return true;
    },

    getgold: function () {
        return fileMgr.getMe().m_play_doc["coreData"]["gold"];
    },

    removeZuanshi: function (num) {
        if (num == null) {
            console.error("removeZuanshi");
            return false;
        }

        if (num < 0) {
            console.error("removeZuanshi");
            return false;
        }

        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var buffnum = fileMgr.getMe().m_play_doc["coreData"]["zuanshi"] - num;
        if (buffnum < 0) {
            console.error("removeZuanshi");
            return false;
        }
        fileMgr.getMe().m_play_doc["coreData"]["zuanshi"] -= num;

        uiMgr.getMe().updateGoldandDiamonds();

        return true;

    },

    removeGold: function (num) {
        if (num == null) {
            console.error("removegold");
            return false;
        }

        if (num < 0) {
            console.error("removegold");
            return false;
        }

        //
        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var buffnum = fileMgr.getMe().m_play_doc["coreData"]["gold"] - num;
        if (buffnum < 0) {
            console.error("removegold");
            return false;
        }
        fileMgr.getMe().m_play_doc["coreData"]["gold"] -= num;

        uiMgr.getMe().updateGoldandDiamonds();
        return true;
    },


    //更新累计充值数
    addchongzhi: function (num) {

        if (num == 0) {
            return false;
        }

        if (num == null) {
            console.error("addchongzhi");
            return false;
        }

        if (num < 0) {
            console.error("addchongzhi");
            return false;
        }

        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var buffnum = fileMgr.getMe().m_play_doc["coreData"]["chongzhi"] + num;
        if (buffnum > Number.MAX_VALUE) {
            console.error("addchongzhi");
            return false;
        }
        fileMgr.getMe().m_play_doc["coreData"]["chongzhi"] += num;

        this.setviplevel();
        return true;
    },

    //设置vip等级
    setviplevel: function () {

        var level = DataMgr.getMe().getVipLevel();
        var chongzhi = DataMgr.getMe().getchongzhi();
        var item = fileMgr.getMe().m_vip_info;
        for (var i in item) {
            if (chongzhi >= item[i]["chongzhi"]) {
                fileMgr.getMe().m_play_doc["coreData"]["viplevel"] = i;
            } else {
                break;
            }
        }
        var curlevel = DataMgr.getMe().getVipLevel();
        if (curlevel > level) {
            uiMgr.getMe().show_ui_playOnce("VIPjinjie.json", "play");
        }
    },

    //获取积点
    getjidian: function () {
        return parseInt(DataMgr.getMe().getPlayDoc().jidian);
    },

    addjidian: function (num) {
        if (num == 0) {
            return false;
        }

        if (num == null) {
            console.error("addjidian");
            return false;
        }

        if (num < 0) {
            console.error("addjidian");
            return false;
        }

        if (!isNaN(num)) {
            num = parseInt(num);
        }

        var buffnum = fileMgr.getMe().m_play_doc["jidian"] + num;
        if (buffnum > Number.MAX_VALUE) {
            console.error("addjidian");
            return false;
        }
        fileMgr.getMe().m_play_doc["jidian"] += num;

        return true;
    },

    getchongzhi: function () {
        return parseInt(fileMgr.getMe().m_play_doc["coreData"]["chongzhi"]);
    },
    //返回竞技场每日最大挑战次数
    getMaxEveryFight: function () {
        var l_pknum = g_vip_info[DataMgr.getMe().getVipLevel()]["pknum"];
        l_pknum = parseInt(l_pknum);
        return l_pknum;
    },


    getVipLevel: function () {
        return parseInt(fileMgr.getMe().m_play_doc["coreData"]["viplevel"]);
    },

    getguajiTime: function () {
        return fileMgr.getMe().m_play_doc["guaji"]["guajitime"];
    },

    /**
     * 设置挂机开始时间
     */
    setguajiTime: function (date) {
        return fileMgr.getMe().m_play_doc["guaji"]["guajitime"] = date;
    },

    /**
     * 获得挂机结束时间
     */
    getEndTime: function () {
        return fileMgr.getMe().m_play_doc["guaji"]["endguajitime"];
    },

    /**
     * 设置挂机结束时间
     */
    setEndTime: function (date) {
        return fileMgr.getMe().m_play_doc["guaji"]["endguajitime"] = date;
    },

    /**
     * 获得挂机总时间
     */
    getHangTime: function () {
        return fileMgr.getMe().m_play_doc["guaji"]["hangTime"];
    },

    /**
     * 设置挂机总时间
     */
    setHangTime: function (date) {
        return fileMgr.getMe().m_play_doc["guaji"]["hangTime"] = date;
    },

    getguajiHero: function () {
        return fileMgr.getMe().m_play_doc["guaji"]["guajihero"];
    },

    /**
     *  添加挂机英雄
     */
    setguajiHero: function (heroes) {
        return fileMgr.getMe().m_play_doc["guaji"]["guajihero"] = heroes;
    },

    /**
     * 获得按钮状态
     */
    getButtonState: function () {
        return fileMgr.getMe().m_play_doc["guaji"]["state"];
    },

    /**
     *  添加按钮状态
     */
    setButtonState: function (state) {
        return fileMgr.getMe().m_play_doc["guaji"]["state"] = state;
    },

    //获得英雄是否解锁
    getHeroIsLocked: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getHeroIsLocked 没有这个角色" + heroname)
            return false;
        }

        var ret = fileMgr.getMe().m_play_doc["coreData"][heroname]["islocked"]

        if (ret == null) {
            console.error("getHeroIsLocked:" + heroname);
            return false;
        }

        if (!ret) {
            return false;
        }

        return true;
    },

    addItemById: function (itemid, num) {
        if (itemid == 1) {
            return this.addgold(num);
        }
        else if (itemid == 2) {
            return this.addzuanshi(num);
        }
        else if (itemid == 3) {
            return this.addyaoshui("smallPotion", num);
        }
        else if (itemid == 4) {
            return this.addyaoshui("centerPotion", num);
        }
        else if (itemid == 5) {
            return this.addyaoshui("bigPotion", num);
        }
        else if (itemid == 6) {
            return this.addsuipian(num);
        }
        else if (itemid == 7) {
            for(var i = 0; i < num; i++){
                this.addyueka("goldyueka");
            }
        }
        else if (itemid == 8) {
            for(var i = 0; i< num; i++){
                return this.addyueka("zuanshiyueka");
            }
        }
        else if (itemid == 9) {
            return this.addchongzhi(num);
        }
    },

    addItemByType: function (name, num) {

        if (name == "diamond") {
            return this.addzuanshi(num);
        }
        else if (name == "gold") {
            return this.addgold(num);
        }
        else if (name == "smallPotion") {
            return this.addyaoshui("smallPotion", num);
        }
        else if (name == "centerPotion") {
            return this.addyaoshui("centerPotion", num);
        }
        else if (name == "bigPotion") {
            return this.addyaoshui("bigPotion", num);
        }
        else if (name == "suipian") {
            return this.addsuipian(num);
        }
        else if (name == "goldyueka") {
            for(var i = 0; i < num; i++){
                this.addyueka("goldyueka");
            }
        }
        else if (name == "zuanshiyueka") {
            for(var i = 0; i< num; i++){
                return this.addyueka("zuanshiyueka");
            }
        }
    },

    // 向导是否完成
    isFinishxiangdao: function (id) {
        var ret = fileMgr.getMe().m_play_doc["yindaos"][id]["lock"]

        if (ret == null) {
            console.error("isFinishxiangdao:" + id);
            return false;
        }

        if (!ret) {
            return false;
        }

        return true;

    },

    // 完成向导id
    finishxiangdao: function (id) {
        var ret = fileMgr.getMe().m_play_doc["yindaos"][id]["lock"]

        if (ret == null) {
            console.error("isFinishxiangdao:" + id);
            return false;
        }

        fileMgr.getMe().m_play_doc["yindaos"][id]["lock"] = 1;

        return true;

    },
    // 场景是否占领
    isSceneZhanling: function (scenename) {
        var ret = this.getScenePer(scenename);

        if (ret >= 50) {
            return true;
        }
        return false;

    },

    addScenePer: function (scenename, val) {

        val = parseInt(val);

        var sceneinfo = fileMgr.getMe().m_play_doc["scenes"][scenename];
        if (sceneinfo == null) {
            console.log("error addScenePer !");
            return 0;
        }

        var curzhanlingper = sceneinfo["curzhanlingper"];

        if (sceneinfo == null) {
            uiMgr.getMe().show_ui_MessageBox(true, "error setScenePer");
            return 0;
        }

        curzhanlingper += val;

        if (curzhanlingper < 0) {
            curzhanlingper = 0;
        }
        else if (curzhanlingper > 100) {
            curzhanlingper = 100;
        }
        sceneinfo["curzhanlingper"] = curzhanlingper;

    },

    setScenePer: function (scenename, scenezhixian, win) {
        var sceneinfo = fileMgr.getMe().m_play_doc["scenes"][scenename];
        if (sceneinfo == null) {
            uiMgr.getMe().show_ui_MessageBox(true, "error setScenePer 场景" + scenename);
            return;
        }

        var curzhanlingper = sceneinfo["curzhanlingper"];

        if (curzhanlingper == null) {
            uiMgr.getMe().show_ui_MessageBox(true, "场景" + scenename + "没有填 curzhanlingper 字段！");
            return;
        }

        if (scenezhixian == null) //主线
        {
            if (sceneinfo == null) {
                uiMgr.getMe().show_ui_MessageBox(true, "error setScenePer");
                return 0;
            }

            if (win == true) {
                if (sceneinfo["isWined"] == false) {
                    sceneinfo["isWined"] = true;
                    curzhanlingper += g_player_default["zhuxian_firstwin_zhanling_per"];
                    //主线成就
                    chengjiuMgr.getMe().zhuxian();
                }
                else {
                    curzhanlingper += g_player_default["zhuxian_secondwin_zhanling_per"];
                }
                if (curzhanlingper > 100)
                    curzhanlingper = 100;

                DataMgr.getMe().setSceneZhuxianIsLock(scenename);

            }

        }
        else {
            var l_sceneinfo = fileMgr.getMe().m_play_doc["scenes"][scenename][scenezhixian];
            if (l_sceneinfo == null) {

                uiMgr.getMe().show_ui_MessageBox(true, "setScenePer!  error  play_default.js 表错误，  没有分支场景：" + scenezhixian);
                return 0;
            }

            if (win == true) {
                if (sceneinfo["isWined"] == false) // 主线没过 支线最多只能打到%50
                {
                    if (curzhanlingper < 50) {
                        if (sceneinfo["isWined_zhixian"] == null) {
                            sceneinfo["isWined_zhixian"] = true;
                            curzhanlingper += g_player_default["zhixian_firstwin_zhanling_per"];
                        }
                        else {
                            curzhanlingper += g_player_default["zhixian_secondwin_zhanling_per"];
                        }

                        if (curzhanlingper > 50)
                            curzhanlingper = 50;
                    }

                }
                else if (sceneinfo["isWined"] == true) // 主线过了 支线最多只能打到%100
                {
                    if (sceneinfo["isWined_zhixian"] == null) {
                        sceneinfo["isWined_zhixian"] = true;
                        curzhanlingper += g_player_default["zhixian_firstwin_zhanling_per"];
                    }
                    else {
                        curzhanlingper += g_player_default["zhixian_secondwin_zhanling_per"];
                    }

                    if (curzhanlingper > 100)
                        curzhanlingper = 100;
                }

                //支线成就
                chengjiuMgr.getMe().zhixian();
                everyTaskMgr.getMe().zhixian_task();
                //添加支线胜利次数
                var fight_count = l_sceneinfo["fight_count"];
                console.log("fight_count1   " + fight_count);
                if (!fight_count) {
                    fight_count = 0;
                }
                ++fight_count;
                console.log("fight_count2   " + fight_count);
                l_sceneinfo["fight_count"] = fight_count;
            }
        }


        if (curzhanlingper < 0) {
            curzhanlingper = 0;
        }
        else if (curzhanlingper > 100) {
            curzhanlingper = 100;
        }

        sceneinfo["curzhanlingper"] = curzhanlingper;

        if (!sceneinfo["iszhanlinged"] && curzhanlingper == 100) {
            chengjiuMgr.getMe().zhanling();
        }
        if (curzhanlingper == 100) {
            sceneinfo["iszhanlinged"] = true;
        }
    },


    //

    //获得场景占领%
    getScenePer: function (scenename) {
        if (fileMgr.getMe().m_play_doc["scenes"][scenename] == null) {
            return 0;
        }

        var ret = fileMgr.getMe().m_play_doc["scenes"][scenename]["curzhanlingper"];
        if (ret == null) {
            console.error("getScenePer:");
            return 0;
        }
        return ret;


    },

    // 玩家总的占领度
    getAllScenePer: function () {


        var allzhanling = 0;
        var obj = fileMgr.getMe().m_play_doc["scenes"];
        for (var p in obj) {
            var curzhanlingper = obj[p]["curzhanlingper"];
            curzhanlingper = parseInt(curzhanlingper);
            if (curzhanlingper != null) {
                if (curzhanlingper >= 50) {
                    ++allzhanling;
                }
            }
        }


        //fileMgr.getMe().m_play_doc["scenes"]["allZhanlingper"] = allzhanling;

        return allzhanling;
    },


    //获得当前英雄的等级
    getLevel: function (heroname) {
        if (fileMgr.getMe().m_play_doc["coreData"][heroname] == null) {
            console.error("error getLevel 没有这个角色" + heroname)
        }
        var ret = fileMgr.getMe().m_play_doc["coreData"][heroname]["level"]
        if (ret == null) {
            console.error("getLevel:" + heroname);
        }
        return ret;
    },

    //获得当前英雄的下一个等级
    getNextLevel: function (heroname) {
        var ret = this.getLevel(heroname) + 1;
        if (ret > g_MaxLevel) {
            ret = g_MaxLevel;
        }
        return ret;
    },
    getEquipPoint: function (heroname, inlevel) {
        if (g_player_levelup_map[heroname] == null) {
            console.log("error getLevelInfoPoint name error" + heroname);
            return null;
        }

        var equiplevel = 1;
        if (inlevel == null) {
            equiplevel = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["level"];
        }
        else {
            equiplevel = inlevel;
        }

        var equipname = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["name"];
        if (!equipname) {
            console.error("getEquipPoint:" + heroname);
        }


        return g_player_equipment[equipname][equiplevel];
    },

    getLevelInfoPoint: function (heroname, inlevel) {
        if (g_player_levelup_map[heroname] == null) {
            console.log("error getLevelInfoPoint name error" + heroname);
            return null;
        }

        var level = 1;
        if (inlevel == null) {
            level = this.getLevel(heroname);
        }
        else {
            level = inlevel;
        }
        return g_player_levelup_map[heroname][level];
    },
    //玩家升级函数
    addlevel: function (heroname) {
        var level = this.getLevel(heroname) + 1;
        if (level > g_MaxLevel) {
            //console.error("addlevel: > g_MaxLevel" + heroname);
            return false;
        }

        fileMgr.getMe().m_play_doc["coreData"][heroname]["level"]++;

        fileMgr.getMe().m_play_doc["heros"][heroname]["levelInfoPoint"] = g_player_levelup_map[heroname][level];
        if (fileMgr.getMe().m_play_doc["heros"][heroname]["levelInfoPoint"]["level"] != level) {
            console.error("init levelInfoPoint error！ ");
        }

        //成就完成
        var maxlevel = 0;
        var heros = fileMgr.getMe().m_play_doc["heros"];
        for (var p in heros) {
            if (p == heroname) {
                continue;
            }
            if (this.getLevel(p) > maxlevel) {
                maxlevel = this.getLevel(p);
            }
        }
        if (level > maxlevel) {
            chengjiuMgr.getMe().renwushengji();
        }

        if (level >= 5) {
            yindaoMgr.getMe().createyindaoByType(g_yindaoType.yindaoType_JINENGSHENGJI);
        }

        return true;

    },

    //获得当前英雄的经验
    getcurexp: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getcurexp 没有这个角色" + heroname)
        }
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["curexp"];
        if (ret == null) {
            console.error("getcurexp:" + heroname);
        }
        return ret;
    },

    //获得当前英雄的经验 的 % （升级%）
    getcurexp_per: function (heroname) {
        var curexp = this.getcurexp(heroname);
        var Needexp = this.getCurNeedexp(heroname);
        var per = curexp / Needexp * 100;
        return per;
    },

    getCurNeedexp: function (heroname) {
        var ret = this.getHeroNextLevelAtt(heroname).needexp;
        if ((ret == null)) {
            console.error("getCurNeedexp:" + heroname);
        }
        return ret;
    },


    //+英雄的经验  并处理升级逻辑
    addcurexp: function (heroname, val) {
        var ret = this.getcurexp(heroname);
        if (ret == null) {
            console.error("addcurexp:" + heroname);
            return false;
        }

        if (val == null) {
            console.error("addcurexp");
            return false;
        }

        if (val < 0) {
            console.error("addcurexp");
            return false;
        }

        if (!isNaN(val)) {
            val = parseInt(val);
        }

        var isleveled = false;
        var buff = val + ret;
        while (true) {
            var needExp = this.getCurNeedexp(heroname);
            if (buff >= needExp) {
                this.addlevel(heroname);
                isleveled = true;
                buff = buff - needExp;
            } else {
                break;
            }
        }

        fileMgr.getMe().m_play_doc["heros"][heroname]["curexp"] = buff;


        if (isleveled) {
            //升级特效
            uiMgr.getMe().show_ui_playOnce("shengjichenggong.json", "play");
        }

        return true;
    },

    getHeroBaseInfo: function (heroname) {
        var ret = g_playhero[heroname];
        if (ret == null) {
            console.error("error getBaseInfo 没有这个角色" + heroname)
        }
        return ret;
    },

    //获得基础攻击
    getBaseAtt: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getBaseAtt 没有这个角色" + heroname)
        }
        // levelInfoPoint 指向 hero 升级表
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["levelInfoPoint"]["shanghai"];
        if (ret == null) {
            console.error("getBaseAtt:" + heroname);
        }
        return ret;
    },

    //获得武器攻击力
    getEquipmentAtt: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getEquipmentAtt 没有这个角色" + heroname)
        }

        // equipPoint 指向 hero 装备升级表
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["equipPoint"]["att"];
        if (ret == null) {
            console.error("getEquipmentAtt:" + heroname);
        }
        return ret;

    },

    //获得武器名字
    getEquipmentName: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getEquipmentLevel 没有这个角色" + heroname)
        }

        var equipname = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["name"];
        if (!equipname) {
            console.error("getEquipmentAtt:" + heroname);
        }

        var ret = g_player_equipment[equipname]["name"];
        if (ret == null) {
            console.error("getEquipmentName: name error" + heroname);
        }

        return ret;
    },

    //获得武器等级
    getEquipmentLevel: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getEquipmentLevel 没有这个角色" + heroname)
        }

        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["level"];
        if (ret == null) {
            console.error("getEquipmentLevel: level error" + heroname);
        }
        return ret;
    },

    //获得武器下一个等级
    getEquipmentNextLevel: function (heroname) {
        var ret = this.getEquipmentLevel(heroname) + 1;
        if (ret > g_EquipMaxLevel) {
            ret = g_EquipMaxLevel;
        }
        return ret;
    },

    //获得武器下一个等级攻击力
    getEquipmentNextLevelAtt: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getEquipmentNextLevelAtt 没有这个角色" + heroname)
        }

        // levelInfoPoint 指向 hero 升级表
        var equipname = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["name"];
        var equiplevel = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["level"] + 1;

        if (!equipname) {
            console.error("getEquipmentNextLevelAtt:" + heroname);
        }
        if (equiplevel > g_EquipMaxLevel) {
            equiplevel = g_EquipMaxLevel;
        }

        var ret = g_player_equipment[equipname][equiplevel]["att"];
        if (ret == null) {
            console.error("getEquipmentNextLevelAtt: att error" + heroname);
        }

        return ret;
    },


    //获得武器升一级的花费
    getEquipmentLevelMoney: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getEquipmentLevelSuipian 没有这个角色" + heroname)
        }

        // equipPoint 指向 hero 装备升级表
        var needgold = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["equipPoint"]["needgold"];
        if (needgold == null) {
            console.error("getEquipmentLevelMoney:" + heroname);
        }

        var needdiamond = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["equipPoint"]["needdiamond"];
        if (needdiamond == null) {
            console.error("getEquipmentLevelMoney:" + heroname);
        }

        // equipPoint 指向 hero 装备升级表
        var needsuipian = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["equipPoint"]["needsuipian"];
        if (needsuipian == null) {
            console.error("getEquipmentLevelSuipian:" + heroname);
        }

        return [needgold, needdiamond, needsuipian];

    },


    //获得武器升一级的成功率Apk
    getEquipmentLevelSuccessRate: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getEquipmentLevelSuccessRate 没有这个角色" + heroname)
        }

        // equipPoint 指向 hero 装备升级表
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["equipPoint"]["successrate"];
        if (ret == null) {
            console.error("getEquipmentLevelSuccessRate:" + heroname);
        }

        return ret;

    },

    //升级武器等级的
    addEquipmentLevel: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error addEquipmentLevel 没有这个角色" + heroname)
            return false;
        }

        var equipname = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["name"];
        var equiplevel = fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["level"];


        if (!equipname) {
            console.error("addEquipmentLevel:" + heroname);
            return false;
        }

        if (g_player_equipment[equipname][equiplevel]["level"] != equiplevel) {
            console.error("addEquipmentLevel: 武器等级不正确 可能表填错 equipment.js" + heroname); //
            return false;
        }

        equiplevel = equiplevel + 1;
        if (equiplevel > g_EquipMaxLevel) {
            return false;
        }
        fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["level"]++;

        fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["equipPoint"] = g_player_equipment[equipname][equiplevel];
        if (fileMgr.getMe().m_play_doc["heros"][heroname]["equip"][0]["equipPoint"]["level"] != equiplevel) {
            console.error("init equipPoint error！ ");
        }

        //成就
        var maxlevel = 0;
        var heros = fileMgr.getMe().m_play_doc["heros"];
        for (var p in heros) {
            if (p == heroname) {
                continue;
            }

            if (this.getEquipmentLevel(p) > maxlevel) {
                maxlevel = this.getEquipmentLevel(p);
            }
        }
        if (equiplevel > maxlevel) {
            chengjiuMgr.getMe().qianghua();
        }
        chengjiuMgr.getMe().qianghuaall();

        return true;
    },

    getMaxMp: function () {
        if (fileMgr.getMe().m_play_doc["max_mp"]) {
            return fileMgr.getMe().m_play_doc["max_mp"]
        }
    },
    getBasehp: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getBasehp 没有这个角色" + heroname)
        }
        // levelInfoPoint 指向 hero 升级表
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["levelInfoPoint"]["hp"];
        if (ret == null) {
            console.error("getBasehp:" + heroname);
        }
        return ret;
    },


    getBasemiss: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getBasemiss 没有这个角色" + heroname)
        }
        // levelInfoPoint 指向 hero 升级表
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["levelInfoPoint"]["miss"];
        if (ret == null) {
            console.error("getBasemiss:" + heroname);
        }
        return ret;
    },
//技能基础cd 不升级  玩家和 怪物公用
    getBasecd: function (heroname) {
        if (g_playhero[heroname] == null) {
            console.error("error getBasecd 没有这个角色" + heroname)
        }

        var ret = g_playhero[heroname]["basecd"];
        if (ret == null) {
            console.error("getBasecd:" + heroname);
        }
        return ret;
    },
//基础防御力
    getBasesdefense: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getBasesdefense 没有这个角色" + heroname)
        }
        // levelInfoPoint 指向 hero 升级表
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["levelInfoPoint"]["defense"];
        if (ret == null) {
            console.error("getBasesdefense:" + heroname);
        }
        return ret;
    },

    getskillinfo: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getskillinfo 没有这个角色" + heroname)
        }

        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["skill"];
        if (ret == null) {
            console.error("getskillinfo:" + heroname);
        }


        return ret;


    },

    //获取当前等级技能属性
    getSkillLevelAtt: function (heroname, skillname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getSkillLevelAtt 没有这个角色" + heroname)
        }

        // skillPoint 指向 hero 升级表
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["skill"][skillname]["skillPoint"];
        if (ret == null) {
            console.error("getSkillLevelAtt:" + heroname);
        }
        return ret;
    },

    //获取技能名称
    getSkillName: function (heroname, skillname) {

        if (g_player_skill[heroname][skillname] == null) {
            console.error("error getSkillName 没有这个角色或技能 " + heroname)
        }

        var ret = g_player_skill_uides[heroname][skillname]["uides"]["skill_name"];
        if (ret == null) {
            console.error("getSkillName:" + heroname);
        }
        return ret;

    },

    //获取技能描述
    getSkillDes: function (heroname, skillname) {

        if (g_player_skill[heroname][skillname] == null) {
            console.error("error getSkillDes 没有这个角色或技能 " + heroname)
        }

        var ret = g_player_skill_uides[heroname][skillname]["uides"]["skill_des"];
        if (ret == null) {
            console.error("getSkillDes:" + heroname);
        }
        return ret;

    },

    //获取下一个等级技能属性
    getSkillNextLevelAtt: function (heroname, skillname) {
        var skilllevel = this.getSkillLevel(heroname, skillname) + 1;
        if (skilllevel > g_SkillMaxLevel) {
            skilllevel = g_SkillMaxLevel;
        }

        var ret = g_player_skill[heroname][skillname][skilllevel];
        if (ret == null) {
            console.error("getSkillNextLevelAtt: att error" + heroname);
        }

        return ret;
    },


    //获得技能解锁的花费
    getunLockSkillMoney: function (heroname, skillname) {
        if (g_player_skill[heroname][skillname] == null) {
            console.error("error getunLockSkillMoney 没有这个角色或技能 " + heroname)
        }

        var gold = g_player_skill[heroname][skillname]["unlock_gold"];
        if (gold == null) {
            console.error("getunLockSkillMoney:" + heroname);
        }

        var diamond = g_player_skill[heroname][skillname]["unlock_diamond"];
        if (diamond == null) {
            console.error("getunLockSkillMoney:" + heroname);
        }
        return [gold, diamond];
    },

    //获得技能解锁的要求的等级
    getunLockSkillRequireLevel: function (heroname, skillname) {
        if (g_player_skill[heroname][skillname] == null) {
            console.error("error getunLockSkillRequireLevel 没有这个角色或技能 " + heroname)
        }

        if (skillname == "skillnormal") {
            return 0;
        }

        var ret = g_player_skill[heroname][skillname]["unlock_level"];
        if (ret == null) {
            console.error("getunLockSkillRequireLevel:" + heroname);
        }
        return ret;
    },

    //获得技能图标
    getSkillIcon: function (heroname, skillname) {
        if (g_player_skill[heroname][skillname] == null) {
            console.error("error getSkillIcon 没有这个角色或技能 " + heroname)
        }

        var ret = g_player_skill[heroname][skillname]["xiaotubiao"];
        if (ret == null) {
            console.error("getSkillIcon:" + heroname);
        }
        return ret;
    },


    //获得技能升级的花费
    getSkillLevelMoney: function (heroname, skillname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getSkillLevelMoney 没有这个角色" + heroname)
        }

        // skillPoint 指向 hero 升级表
        var gold = fileMgr.getMe().m_play_doc["heros"][heroname]["skill"][skillname]["skillPoint"]["needgold"];
        if (gold == null) {
            console.error("getSkillLevelMoney:" + heroname);
        }

        var diamond = fileMgr.getMe().m_play_doc["heros"][heroname]["skill"][skillname]["skillPoint"]["needdiamond"];
        if (diamond == null) {
            console.error("getSkillLevelMoney:" + heroname);
        }

        return [gold, diamond];
    },

    //解锁技能
    unLockHeroSkill: function (heroname, skillname) {
        var skillinfo = this.getskillinfo(heroname);
        if (skillinfo == null) {
            console.error("error unLockHeroSkill 技能等级不正确 可能表填错" + heroname);
            return false;
        }

        var islocked = skillinfo[skillname].islocked;
        if (islocked == null) {
            console.error("unLockHeroSkill:" + heroname);
            return false;
        }

        skillinfo[skillname].islocked = 0;

        return true;

    },

    //获得解锁英雄的花费
    getunLockHeroMoney: function (heroname) {

        if (g_playhero[heroname] == null) {
            console.error("error getunLockHeroMoney 没有这个角色" + heroname)
        }

        var golds = g_playhero[heroname]["goumaigolds"];
        if (golds == null) {
            console.error("getunLockHeroMoney:" + heroname);
        }

        var diamonds = g_playhero[heroname]["goumaidiamonds"];
        if (diamonds == null) {
            console.error("getunLockHeroMoney:" + heroname);
        }

        return [golds, diamonds];

    },

    //获得英雄的大头像
    getHeroBigImage: function (heroname) {

        if (g_playhero[heroname] == null) {
            console.error("error getHeroBigImage 没有这个角色" + heroname)
        }

        var ret = g_playhero[heroname]["hero_big_Image"];
        if (ret == null) {
            console.error("getHeroBigImage:" + heroname);
        }
        return ret;

    },

    //获得英雄的名字 中文
    getHeroName_ZH: function (heroname) {

        if (g_playhero[heroname] == null) {
            console.error("error getHeroBigImage 没有这个角色" + heroname)
        }

        var ret = g_playhero[heroname]["herodes_name"];
        if (ret == null) {
            console.error("getHeroBigImage:" + heroname);
        }
        return ret;

    },

    //获得英雄名字的图片
    getHeroNameImage: function (heroname) {

        if (g_playhero[heroname] == null) {
            console.error("error getHeroNameImage 没有这个角色" + heroname)
        }

        var ret = g_playhero[heroname]["heroname_Image"];
        if (ret == null) {
            console.error("getHeroNameImage:" + heroname);
        }
        return ret;

    },

    //获得解锁英雄的前提要求
    getunLockHeroRequire: function (heroname) {

        if (g_playhero[heroname] == null) {
            console.error("error getunLockHeroRequire 没有这个角色" + heroname)
        }

        var ret = g_playhero[heroname]["unlock_require"];
        if (ret == null) {
            console.error("getunLockHeroRequire:" + heroname);
        }
        return ret;

    },

    //升级技能
    addSkillLevel: function (heroname, skillname) {
        var skillinfo = this.getskillinfo(heroname);
        if (skillinfo == null) {
            console.error("error addSkillLevel 技能等级不正确 可能表填错" + heroname);
            return false;
        }

        if (skillname == "skillnormal") {
            console.error("error addSkillLevel skillnormal等级不正确 可能表填错" + heroname);
            return false;
        }

        var skilllevel = skillinfo[skillname].level + 1;
        if (skilllevel > g_SkillMaxLevel) {
            return false;
        }

        skillinfo[skillname].level++;

        skillinfo[skillname]["skillPoint"] = g_player_skill[heroname][skillname][skilllevel];
        if (skillinfo[skillname]["skillPoint"]["level"] != skilllevel) {
            console.error("init skillPoint error！ ");
        }

        return true;

    },

    //获取技能级别
    getSkillLevel: function (heroname, skillname) {

        var skillinfo = this.getskillinfo(heroname);
        if (skillinfo == null) {
            console.error("error getSkillLevel 技能等级不正确 可能表填错" + heroname)
        }

        var ret = skillinfo[skillname]["level"];
        if ((ret == null)) {
            console.error("getSkillLevel: skillinfo error" + heroname);
        }

        return ret;
    },

    //获得技能下一个等级
    getSkillNextLevel: function (heroname, skillname) {
        var ret = this.getSkillLevel(heroname, skillname) + 1;
        if (ret > g_SkillMaxLevel) {
            ret = g_SkillMaxLevel;
        }
        return ret;
    },

    //获取技能是否解锁
    getSkillIsLocked: function (heroname, skillname) {
        var skillinfo = this.getskillinfo(heroname);
        if (skillinfo == null) {
            console.error("error getSkillIsLocked 技能等级不正确 可能表填错" + heroname)
            return false;
        }
        var ret = skillinfo[skillname].islocked;

        if ((ret == null)) {
            console.error("getSkillIsLocked:" + heroname);
            return false;
        }

        if (!ret) {
            return false;
        }

        return true;
    },

    //获取英雄本等级的属性
    getHeroInfo: function (heroname) {
        if (fileMgr.getMe().m_play_doc["heros"][heroname] == null) {
            console.error("error getHeroinfo 没有这个角色" + heroname)
        }
        var ret = fileMgr.getMe().m_play_doc["heros"][heroname]["levelInfoPoint"];
        if ((ret == null)) {
            console.error("getHeroinfo:" + heroname);
        }

        return ret;

    },

    //获取英雄下一等级的属性
    getHeroNextLevelAtt: function (heroname) {
        var herolevel = this.getLevel(heroname) + 1;
        if (herolevel > g_MaxLevel) {
            herolevel = g_MaxLevel;
        }

        var ret = g_player_levelup_map[heroname][herolevel];
        if (ret == null) {
            console.error("getHeroNextLevelinfo: att error" + heroname);
        }

        return ret;
    },

    //判断英雄是否满级
    isMaxHeroLevel: function (heroname) {
        var level = this.getLevel(heroname)
        if ((level == null)) {
            console.error("isSkillMaxLevel: isSkillMaxLevel error" + heroname);
        }

        if (level == g_MaxLevel) {
            return true;
        }

        return false;
    },

    //判断英雄技能是否满级
    isSkillMaxLevel: function (heroname, skillname) {
        var ret = this.getSkillLevel(heroname, skillname)
        if ((ret == null)) {
            console.error("isSkillMaxLevel: isSkillMaxLevel error" + heroname);
        }

        if (ret < g_SkillMaxLevel) {
            return false;
        }

        return true;
    },

    //判断英雄装备是否满级
    isEquipmentMaxLevel: function (heroname) {
        var ret = this.getEquipmentLevel(heroname);
        if (ret == null) {
            console.error("isEquipmentMaxLevel:" + heroname);
        }

        if (ret < g_EquipMaxLevel) {
            return false;
        }

        return true;
    },

    //解锁英雄
    unLockHero: function (heroname) {
        if (fileMgr.getMe().m_play_doc["coreData"][heroname] == null) {
            console.error("error unLockHero 没有这个角色" + heroname)
            return false;
        }
        var ret = fileMgr.getMe().m_play_doc["coreData"][heroname]["islocked"]
        if (ret == null) {
            console.error("unLockHero:" + heroname);
            return false;
        }

        fileMgr.getMe().m_play_doc["coreData"][heroname]["islocked"] = 0;

        return true;

    },

    //获取物品信息
    getItemInfo: function (itemname) {
        var ret = g_items_info[itemname];
        if (ret == null) {
            console.error("getItemInfo:" + itemname);
        }

        return ret;

    },

    getTaskInfoById: function (id) {
        var ret = fileMgr.getMe().m_play_doc["tasks"][id];
        if (ret == null) {
            console.error("getTaskInfoById:" + id);
        }

        return ret;
    },

    getChengjiuInfoById: function (id) {
        var ret = fileMgr.getMe().m_play_doc["chengjius"][id];
        if (ret == null) {
            console.error("getChengjiuInfoById:" + id);
        }

        return ret;
    },


    finishChengjiu: function (id) {
        var ret = fileMgr.getMe().m_play_doc["chengjius"][id];
        if (ret == null) {
            console.error("getChengjiuInfoById:" + id);
        }

        fileMgr.getMe().m_play_doc["chengjius"][id]["over"] = 2;

    },

//获得解锁英雄数量
    getUnLockHeroesNum: function () {

        var heroes = fileMgr.getMe().m_play_doc["heros"];
        if (heroes == null) {
            console.error("error 配置信息问题")
            return;
        }


        var num = 0;
        for (var h in heroes) {
            if (fileMgr.getMe().m_play_doc["coreData"][h]["islocked"] == 0) {
                ++num;
            }
        }
        return num;
    },


    /**
     * 获得未解锁英雄
     */
    getLockHeroes: function () {
        if (fileMgr.getMe().m_play_doc["heros"] == null) {
            console.error("error 配置信息问题")
            return;
        }
        var lockHeroes = [];
        var heroes = fileMgr.getMe().m_play_doc["heros"];
        if (heroes == null) {
            console.error("m_play_doc heros");
            return;
        }
        for (var h in heroes) {
            if (fileMgr.getMe().m_play_doc["coreData"][h]["islocked"] == 1) {
                lockHeroes.push(h);
            }
        }
        return lockHeroes;
    },

    /**
     * 购买所需金币或勋章 提示语句
     */
    needGoldsOrDiamonds: function (heroName, type) {
        if (!heroName || heroName == null) {
            console.log("error needGoldsOrDiamonds is null!");
            return;
        }
        var isEnoughPaidState = unLockHeroMgr.getMe().isEnoughPaid(heroName, type);
        var goldsAndDiamonds = null;
        if (type == 1) {
            goldsAndDiamonds = DataMgr.getMe().getunLockHeroMoney(heroName);
            if (goldsAndDiamonds != null) {
                if (isEnoughPaidState == 1)
                    return "是否消耗" + goldsAndDiamonds[0] + "金币";
                if (isEnoughPaidState == 3)
                    return "是否消耗" + goldsAndDiamonds[1] + "勋章";
                if (isEnoughPaidState == 2)
                    return "金币不足，是否花费" + iapMgr.getMe().getDefaultGoldPrice() + "购买" + iapMgr.getMe().getUseGoldDefaultLibao() + "金币，解锁此英雄需要" + goldsAndDiamonds[0] + "金币";
                if (isEnoughPaidState == 4)
                    return "勋章不足，是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() + "购买" + iapMgr.getMe().getUseDiamondsDefaultLibao() + "勋章，解锁此英雄需要" + goldsAndDiamonds[1] + "勋章";
            }
        } else if (type == 2) {
            goldsAndDiamonds = DataMgr.getMe().getEquipmentLevelMoney(heroName);
            if (goldsAndDiamonds != null) {
                if (isEnoughPaidState == 1)
                    return "是否消耗" + goldsAndDiamonds[0] + "金币";
                if (isEnoughPaidState == 3)
                    return "是否消耗" + goldsAndDiamonds[1] + "勋章";
                if (isEnoughPaidState == 2)
                    return "金币不足，是否花费" + iapMgr.getMe().getDefaultGoldPrice() + "购买" + iapMgr.getMe().getUseGoldDefaultLibao() + "金币，升级需要" + goldsAndDiamonds[0] + "金币";
                if (isEnoughPaidState == 4)
                    return "勋章不足，是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() + "购买" + iapMgr.getMe().getUseDiamondsDefaultLibao() + "勋章，升级需要" + goldsAndDiamonds[1] + "勋章";
            }
        }
    },

});


DataMgr.getMe = function () {
    return DataMgr.create();
};

DataMgr.create = function () {
    if (DataMgr.g_ing == null) {
        DataMgr.g_ing = new DataMgr();
        return DataMgr.g_ing;
    }
    else {
        return DataMgr.g_ing;
    }
};



