//json

//json 遍历代码
//如果是jsonarray就外面套一层for即可
//var jsonarray =yourarray;
//for(var i =0;i<jsonarray.length;i++){
//    var jsonobj = jsonarray[i];
//    for(var x in jsonobj){
//        document.write(x+"="+jsonobj[x]);
//    }
//}


var fileMgr = cc.Class.extend({
    m_sceneinfo_MapGame: null,
    m_play_default: null,
    m_play_doc: null, //玩家存档
    m_playhero: null, //
    m_play_info: null, //
    m_monster: null, // 怪物属性
    m_resouce: null, // 资源列表
    m_xiangsu_info: null, // 适配像素信息
    m_net_info: null, //
    m_curMyStruct_xiangsu_base: null,
    m_xiangdao: null, //
    m_shop_info: null, //iap 购买信息
    m_vip_info: null,
    m_task_info: null,
    m_player_buff: null, //buff
    m_monster_buff: null, //buff
    m_monster_Ai: null, //
    ctor: function () {
        this.m_sceneinfo_MapGame = new MapGame();

    },


    init: function () {

        this.initSkill();
        this.readPlay_equipment();
        this.readnet_info();
        //this.readPlayerDocEx( );
        this.readPlayerdefault();
        //this.readPlayerDoc();
        this.readPlayHero();
        this.readmonster();
        this.readresouce();
        this.read_xiangsu();

        this.read_shop_info();
        this.read_vip_info();
        this.read_play();
        this.read_buff();
        this.read_task_info();

        this.read_monster_Ai();
        console.log("fileMgr init ok!");
    },


    isYunyingshang: function () {

        return this.m_xiangsu_info["root"]["winiap"];

    },

    getSkillMap: function () {
        return g_player_skill;
    },

    read_player_liefeng_levelup: function () {
        return g_player_levelup_map["leifeng"];
    },

    read_monster_Ai: function () {
        this.m_monster_Ai = g_monster_Ai;//outjson;
        return true;
    },

    read_buff: function () {
        this.m_player_buff = g_player_buff;//  outjson;
        this.m_monster_buff = g_monster_buff;//  outjson;
        return true;
    },

    read_play: function () {
        this.m_play_info = g_player;//outjson;
        return true;
    },
    getShopInfoItem_byid: function (id) {
        var items = fileMgr.getMe().m_shop_info.root.item;
        for (var i = 0; i < items.length; i++) {
            if (items[i].id == id) {
                return items[i];
            }
        }
    },
    getShopInfoItem_byTVid: function (id) {
        var items = fileMgr.getMe().m_shop_info.root.item;
        for (var i = 0; i < items.length; i++) {
            if (items[i].tvid == id) {
                return items[i];
            }
        }
    },
    getVIPInfoItem_byid: function (id) {
        return fileMgr.getMe().m_vip_info[id];
    },

    getTaskInfoItem_byid: function (id) {
        return fileMgr.getMe().m_task_info[id];
    },

    read_task_info: function () {
        this.m_task_info = g_task_info;
        return true;
    },

    read_vip_info: function () {
        if (cc.sys.isNative) {
            if (cc.sys.OS_WINDOWS == cc.sys.os) {
                this.m_vip_info = g_vip_info_pc;
            }
            else {
                if (fileMgr.getMe().m_xiangsu_info["root"]["version"] == 0) {
                    this.m_vip_info = g_vip_info_apk;
                }
                // 天津联通 弹出套餐
                if (fileMgr.getMe().m_xiangsu_info["root"]["version"] == "tianjinliantong") {
                    this.m_vip_info = g_vip_info_pc;
                }
                // 天威 弹出套餐
                if (fileMgr.getMe().m_xiangsu_info["root"]["version"] == "tianwei") {
                    this.m_vip_info = g_vip_info_pc;
                }
            }
        }
        else {
            this.m_vip_info = g_vip_info_pc;
        }

        return true;
    },

    read_shop_info: function () {
        //var data = null;
        if (cc.sys.isNative) {
            if (cc.sys.OS_WINDOWS == cc.sys.os) {
                this.m_shop_info = g_shop_info_pc;
            }
            else {
                if (fileMgr.getMe().m_xiangsu_info["root"]["version"] == 0) {
                    this.m_shop_info = g_shop_info_apk;
                }
                // 天津联通 弹出套餐
                if (fileMgr.getMe().m_xiangsu_info["root"]["version"] == "tianjinliantong") {
                    this.m_shop_info = g_shop_info_tianjinliantong;
                }
                // 天威 弹出套餐
                if (fileMgr.getMe().m_xiangsu_info["root"]["version"] == "tianwei") {
                    this.m_shop_info = g_shop_info_tianwei;
                }
            }
        }
        else {
            this.m_shop_info = g_shop_info_pc;
        }
        g_shop_info = this.m_shop_info;
        return true;
    },

    read_xiangsu: function () {

        var data = null;
        if (cc.sys.isNative && cc.sys.os == cc.sys.OS_ANDROID) {
            data = this.ReadFileData("xiangsu_apk.json"); //普通安卓包
            //data = this.ReadFileData("xiangsu_tianjinliantong.json");
            //data = this.ReadFileData("xiangsu_tianwei.json");
        }
        else {
            data = this.ReadFileData("xiangsu.json");
        }


        var outjson = JSON.parse(data);
        this.m_xiangsu_info = outjson;
        return true;
    },


    readProjectManifest: function () {
        var data = this.ReadFileData("xingjieyuanqiyongzhe/project.manifest");
        var outjson = JSON.parse(data);
        return outjson;
    },


    readnet_info: function () {
        var data = this.ReadFileData("net.json");
        if (data == null) {
            console.log("error readnet_info");
        }

        var outjson = JSON.parse(data);
        this.m_net_info = outjson;
        return true;
    },

    readmonster: function () {
        this.m_monster = g_monster;//outjson;
        return true;
    },
    readmonsterDataByName: function (name) {
        //this.m_monster = g_monster;//
        var ret = g_monster[name];
        if (ret == null) {
            log("怪物表中没有这个怪物:" + name);
        }
        return ret;

    },
    readresouce: function () {
        //var data = this.ReadFileData("resouce.json");
        // var outjson = JSON.parse(data);
        this.m_resouce = g_resouce;
        return true;

    },

    initSkill: function () {

        if (cc.sys.isNative) {
            if (cc.sys.OS_WINDOWS == cc.sys.os) {

            }
            else
            {
                for ( var p in g_player_skill ) {
                    g_player_skill[p] = g_player_skill_apk[p];
                }
            }
        }

    },

    readPlay_equipment: function () {

        if (cc.sys.isNative) {
            if (cc.sys.OS_WINDOWS == cc.sys.os) {
                g_player_equipment = g_player_equipment_pc;
            }
            else {
                g_player_equipment = g_player_equipment_apk;
            }
        }
        else {
            g_player_equipment = g_player_equipment_pc;
        }


        return true;

    },

    readPlayHero: function () {

        if (cc.sys.isNative) {
            if (cc.sys.OS_WINDOWS == cc.sys.os) {
                this.m_playhero = g_playhero_pc;
            }
            else {
                if (fileMgr.getMe().m_xiangsu_info["root"]["version"] == "tianjinliantong") {
                    this.m_playhero = g_playhero_pc;
                }else{
                    this.m_playhero = g_playhero_apk;
                }

            }
        }
        else {
            this.m_playhero = g_playhero_pc;
        }

        g_playhero = this.m_playhero;

        return true;

    },


//是否有这个场景的数据
    hasSceneInfo: function (filename) {
        return this.m_sceneinfo_MapGame.hasData(filename);
    },
    getSceneInfo: function (filename) {

        if (filename == undefined) {
            return null;
        }

        var ret = this.hasSceneInfo(filename);
        if (ret == false) {
            this.readSceneInfo(filename);
        }
        return this.m_sceneinfo_MapGame.getDataByKey(filename);
    },

//返回怪物信息
    getSceneInfoMonsterInfo: function (scenename, id) {
        var sceneret = this.getSceneInfo(scenename);
        // var monsterret = sceneret["monster"][id];
        var monsternameret = sceneret["monster"][id]["name"];
        return g_monster[monsternameret];
    },

    getSceneInfoBePlayerInfo: function (scenename, id) {
        var sceneret = this.getSceneInfo(scenename);
        var playernameret = sceneret["monster"][id]["name"];
        return g_playhero[playernameret];

    },

    getSceneInfoMonsterInfo_fangshouScene: function (SceneInfo, id) {
        var sceneret = SceneInfo;

        if (sceneret["monster"] == null) {
            return null;
        }
        var monsternameret = sceneret["monster"][id]["name"];
        return g_monster[monsternameret];
    },

//返回玩家信息
    getSceneInfoPlayerInfo: function (scenename, id) {
        var sceneret = this.getSceneInfo(scenename);
        var playerret = sceneret["player"][id];
        var playernameret = sceneret["player"][id]["name"];
        return g_playhero[playernameret];
    },

    readSceneInfo: function (filename) {
        var outjson = g_scene_config[filename];
        this.m_sceneinfo_MapGame.put(filename, outjson);
        return true;
    },

    ReadFileData: function (filename) {
        //console.log("ReadFileData： " + filename);
        if (cc.sys.isNative) {
            // console.log("ReadFileData： " + filename);
            var fullPath = jsb.fileUtils.getWritablePath();
            fullPath += filename;
            // console.log("ReadFileData： " + fullPath);

            if (jsb.fileUtils.isFileExist(fullPath)) {
                console.log("ReadFileData： " + fullPath);
                return jsb.fileUtils.getStringFromFile(fullPath);
            }

            if (jsb.fileUtils.isFileExist(filename)) {
                console.log("ReadFileData： " + filename);
                return jsb.fileUtils.getStringFromFile(filename);
            }
            if (jsb.fileUtils.isFileExist("config/" + filename)) {
                console.log("ReadFileData： " + "config/" + filename);
                return jsb.fileUtils.getStringFromFile("config/" + filename);
            }

            console.log("ReadFileData： " + "not find file" + filename);
            return false;
        }
        else {//网页
            var txt = cc.loader._loadTxtSync("xingjieyuanqiyongzhe/public_res/config/" + filename);
            return txt;
        }

        return false;

    },
    distanceEx: function (x, y) {

        x = parseFloat(x);
        y = parseFloat(x);
        if (x > y) {
            return x - y;
        }
        return y - x;
    },

    initxiangsu_andriod_ios: function (sizein) {


        var len = 10000;
        var lenBuff = 0;
        // this.m_xiangsu_info
        var phonelist = this.m_xiangsu_info.root.iphone;
        for (var i = 0; i < phonelist.length; ++i) {
            var data = phonelist[i];
            lenBuff = this.distanceEx(data.xiangsu_w, sizein.width) + this.distanceEx(data.xiangsu_h, sizein.height);// it->second.xiangsu_w + it->second.xiangsu_h;
            if (lenBuff < len) {
                len = lenBuff;
                this.m_curMyStruct_xiangsu_base = data;
                //uiMgr.getMe().show_ui_MessageBox( true , "手机开的房间initxiangsu_andriod_ios width:"+ data.xiangsu_w);
                // this.curxiangsu = it->second.name;

            }
        }

        // console.log("initxiangsu_andriod_ios name:"+ this.m_curMyStruct_xiangsu_base.name+ "xiangsu_w:"+this.m_curMyStruct_xiangsu_base.xiangsu_w)
        //  uiMgr.getMe().show_ui_MessageBox( true , "initxiangsu_andriod_ios name:"+ this.m_curMyStruct_xiangsu_base.name);

        console.log("jjj:" + "len:" + len + "lenBuff:" + lenBuff + this.m_curMyStruct_xiangsu_base.xiangsu_w + ":" + this.m_curMyStruct_xiangsu_base.xiangsu_h + ":" + this.m_curMyStruct_xiangsu_base.scale);
        return this.m_curMyStruct_xiangsu_base;

    },

    readPlayerdefault: function () {
        //var data = this.ReadFileData("player_default.json");
        this.m_play_default = g_player_default;// JSON.parse(data);
    },
    firstReadPlayerDoc: function () {

        this.readPlay_equipment();
        this.initSkill();
        if (g_playhero == null) {
            fileMgr.getMe().readPlayHero();
        }

        this.m_play_doc = cc.copy(g_player_default); //


        //更新jinggong_num
        var heros = this.m_play_doc.heros;
        for (var p in heros) {
            var obj = heros[p];
            obj["jinggong_num"] = g_playhero[p]["jinggong_num"];
            obj["fangshou_num"] = g_playhero[p]["fangshou_num"]
        }

        var heros = this.m_play_doc.heros;
        for (var p in heros) {
            var obj = heros[p];
            var level = DataMgr.getMe().getLevel(p);// obj["level"];
            obj["levelInfoPoint"] = g_player_levelup_map[p][level];
            if (obj["levelInfoPoint"]["level"] != level) {
                console.error("init levelInfoPoint error！ ");
            }

            var equipobj = obj["equip"][0];
            var equipname = equipobj["name"];
            var equiplevel = equipobj["level"];


            equipobj["equipPoint"] = g_player_equipment[equipname][equiplevel];

            if (equipobj["equipPoint"]["level"] != equiplevel) {
                console.error("init equipPoint error！ ");
            }

            var skillArr = ["skilljueji1", "skilljueji2", "skilljueji3", "skilljuezhao"];
            for (var i = 0; i < skillArr.length; i++) {
                var skillname = skillArr[i];
                var skillobj = obj["skill"][skillname];

                var skilllevel = skillobj.level;

                if (g_player_skill[p][skillname] == null) {
                    console.log(p + skillname + "技能表出错");
                }

                if (g_player_skill[p][skillname][skilllevel] == null) {
                    console.log(p + skillname + "技能表出错");
                }

                skillobj["skillPoint"] = g_player_skill[p][skillname][skilllevel];

                if (skillobj["skillPoint"]["level"] != skilllevel) {
                    console.error("init skillPoint error！ ");
                }
            }

        }


    },
    readPlayerDoc: function () {
        //从网络获取存档
        //httpMgr.getMe().getPlayData();
        //if(g_player.testPlayDoc)
        {
            if ( cc.sys.isNative && cc.sys.os == cc.sys.OS_WINDOWS )
            {
                //加载
                if (jsb.fileUtils.isFileExist("save/player_doc.js"))
                {
                    executeScript("save/player_doc.js");
                    log("g_paly_doc !!!!!!! ok!!!");
                    this.m_play_doc = g_paly_doc; //
                    return true;
                }
                else {
                    //this.firstReadPlayerDoc();
                }
            }
            else if ( cc.sys.isNative )
            {
                var _writablePath = jsb.fileUtils.getWritablePath();
                console.log("安卓存档目录：" + _writablePath + "player_doc.js");
                if ( jsb.fileUtils.isFileExist( _writablePath + "player_doc.js") )
                {
                    executeScript(_writablePath + "player_doc.js");
                    console.log("安卓存档目录 001：" + _writablePath + "player_doc.js");
                    this.m_play_doc = g_paly_doc; //
                    return true;
                }
                else
                {
                    // this.firstReadPlayerDoc();
                }
            }
            else {
                // this.firstReadPlayerDoc();
            }
        }
        //
        return false;

    },

    savePlayInfo: function () {

        //var json_scenes = JSON.stringify( this.m_play_doc["scenes"] , null , '\t' );
        //var json = JSON.stringify( this.m_play_doc , null , '\t' );
        //var dd_len = json.length;
        //var json_sceneslen = json_scenes.length;

        if (cc.sys.isNative) {
            var _writablePath = jsb.fileUtils.getWritablePath();

            var json = JSON.stringify(this.m_play_doc, null, '\t');
            //需要存档到服务器
            if (cc.sys.os == cc.sys.OS_WINDOWS) {

                console.log("存档目录：" + _writablePath + "save/player_doc.js");
                var srcpath = _writablePath + "save/player_doc_backup.js";
                jsb.fileUtils.writeStringToFile("g_paly_doc = " + json, srcpath);
                jsb.fileUtils.removeFile(_writablePath + "save/player_doc.js");
                jsb.fileUtils.renameFile(_writablePath + "save/", "player_doc_backup.js", "player_doc.js");
            }
            else {

                console.log("安卓存档目录：" + _writablePath + "player_doc.js");
                var srcpath = _writablePath + "player_doc.js";
                jsb.fileUtils.writeStringToFile( "g_paly_doc = " + json, srcpath );
            }
        }

        httpMgr.getMe().savePlayData();
        //存档
        //httpMgr.getMe().sendMsg(g_httpType.type_WritePlayData);

    },

    getPlayInfo_String: function () {
        var json = JSON.stringify(this.m_play_doc, null, '\t');
        var data = "g_paly_doc = " + json;
        return data;
    },

    saveProjectJson: function (filelist) {
        if (cc.sys.isNative) {
            var data = fileMgr.getMe().ReadFileData("project.json");

            var outjson = JSON.parse(data);
            //console.log(data);
            outjson["jsList"] = filelist;

            var json = JSON.stringify(outjson, null, '\t');

            jsb.fileUtils.writeStringToFile(json, "project.json");

        }
    },


});


fileMgr.getMe = function () {
    return fileMgr.create();
};


fileMgr.create = function () {
    if (fileMgr.g_fileMgr == null) {
        fileMgr.g_fileMgr = new fileMgr();
        return fileMgr.g_fileMgr;
    }
    else {
        return fileMgr.g_fileMgr;
    }
};

