//
//
//


//cc.audioEngine = cc.AudioEngine.getInstance();

var musicMgr = cc.Class.extend({

    m_stopEffect:false,
    m_stopmusic:false,
    m_back_music:null,
    ctor: function ()
    {
        this.initmusicMgr();
    },

    initmusicMgr: function ()
    {
       this.setmusic();
    },

    setmusic:function()
    {
       
        this.m_stopmusic =  !this.m_stopmusic;
        if (!this.m_stopmusic)
        {
            cc.audioEngine.setMusicVolume(0.0);
            this.setBackMusicConfig(true);
            this.setEffectsConfig(true);
        }
        else
        {
            cc.audioEngine.setMusicVolume(1.0);
            this.setBackMusicConfig(false);
            this.setEffectsConfig(false);
        }
    },

    //为了跨平台
    shipeiname: function (name)
    {
        if(name == "")
            return null;
        if(name == null)
            return null;


        var namelist =  name.split("/");
        if(namelist.length > 0)
        {
            name = namelist[ namelist.length -1 ];
        }


        var buffurl = null;
        if (cc.sys.isNative)
        {
            buffurl = "xingjieyuanqiyongzhe/public_res/music/" + name;
            buffurl =  buffurl.replace(".ogg", ".mp3");
        }
        else
        {
            buffurl = "xingjieyuanqiyongzhe/public_res/music/" + name;
        }

        if (cc.sys.os == cc.sys.ANDROID)
        {
            buffurl =  buffurl.replace(".mp3", ".ogg");
        }

        return buffurl;
    },

    playbackmusic: function (name,qiangzhibofang)
    {
        if( qiangzhibofang == null )
        {
            qiangzhibofang = false;
        }

        if(this.m_stopBackupMusic)
        {
            return;
        }
        var buffurl = this.shipeiname(name);

        if(buffurl == null)
            return;

        if( qiangzhibofang == false )
        {
            if( this.m_back_music == buffurl )
            {
                return ;
            }
        }


        this.m_back_music = buffurl;
        if (cc.sys.isNative)
        {
            cc.audioEngine.playMusic(buffurl, true);
        }
        else
        {
            cc.audioEngine.playMusic(buffurl, true);
        }
    },

    pauseMusic: function(){
        if (cc.sys.isNative) {
            cc.audioEngine.pauseMusic();
        }
    },
    resumeMusic: function(){
        if (cc.sys.isNative) {
            cc.audioEngine.resumeMusic();
        }
    },

    stopbackmuisc:function(){
        cc.audioEngine.stopMusic();
        this.m_back_music = null;
    },


    playData: function (data) {
        try
        {
            if (data != "" && data != null)
            {
                var outjson = JSON.parse(data);
                if (outjson["bm"] != null)
                {
                    musicMgr.getMe().playbackmusic(outjson["bm"]);
                }
                if (outjson["click"] != null)
                {
                    musicMgr.getMe().playeffect(outjson["click"]);
                }
            }
        }
        catch (e)
        {
            throw e;
            cb("load json [" + url + "] failed : " + e);
            uiMgr.getMe().show_ui_MessageBox(true, "用户数据填错了" + data);

        }
    },

    playCheckBoxeffect: function (checkbox)
    {

    },

    playeffect: function (name) {

        if(this.m_stopEffect){
            return;
        }
        var buffurl = this.shipeiname(name);
        if(buffurl == null)
            return;
        if (cc.sys.isNative)
        {
            cc.audioEngine.playEffect(buffurl);
        }
        else
        {
            cc.audioEngine.playEffect(buffurl);
        }
        //cc.error( "music " + buffurl);
        console.log( "music: " + buffurl);


    },


    setBackMusicConfig:function(stopMusic){
        if(stopMusic != this.m_stopBackupMusic){
            this.m_stopBackupMusic = stopMusic;
            if( stopMusic)
            {
                this.stopbackmuisc();
            }
            else
            {
                this.playbackmusic(this.m_back_music , true);
            }

        }
    },

    setEffectsConfig:function(stopMusic) {
        if (this.m_stopEffect != stopMusic)
        {
            if ( this.m_stopEffect)
            {
                cc.audioEngine.stopAllEffects();
                cc.audioEngine.setEffectsVolume(0);
            }
            else
            {
                cc.audioEngine.stopAllEffects();
                cc.audioEngine.setEffectsVolume(1);
            }
            this.m_stopEffect = stopMusic;
        }
    },

    getMusicConfig:function()
    {
         return this.m_stopBackupMusic;
    },

    getEffectConfig:function()
    {
        return this.m_stopEffect;
    }
});

musicMgr.getMe = function () {
    return musicMgr.create();
};

musicMgr.create = function () {
    if (musicMgr.g_musicMgr == null) {
        musicMgr.g_musicMgr = new musicMgr();
        //musicMgr.g_musicMgr = l_musicMgr ;
        return musicMgr.g_musicMgr;
    }
    else {
        return musicMgr.g_musicMgr;
    }

};







