/**
 * Created by cy1234 on 2016/5/4.
 */
//播放电影ui

var MoviePlayerMgr = UiBase.extend({

    m_MoviePlayer: null,
    m_func: null,
    m_funcPoint: null,
    m_root: null,
    m_sleep: 0,
    m_music_setting:true,
    ctor: function () {
        this._super();
    },
    initColor: function () {
        this.setColor(cc.color(0, 0, 0));
        this.setOpacity(255 * 1.0);
        return true;
    },

    init_MoviePlayer:function()
    {
        if (!this.m_root) {

            if(fileMgr.getMe().m_xiangsu_info["root"]["vedio"] != 0)
            {
                if (cc.sys.isNative ) {
                    this.m_MoviePlayer = new cc.MoviePlayer();
                    var winSize = cc.director.getWinSize();
                    this.m_MoviePlayer.setPosition(cc.p(winSize.width / 2, winSize.height / 2));
                    this.addChild(this.m_MoviePlayer, 100);
                    this.shipeiCenter(this.m_MoviePlayer);
                }
                else {

                    this.m_MoviePlayer = new ccui.VideoPlayer("");
                    window.video = this.m_MoviePlayer;
                    this.addChild(this.m_MoviePlayer);
                }
            }



            this.m_root = this._parseUIFile("tiaoguo.json", 0);
            this.playAnimation("play",true);
            this.addChild(this.m_root, 10000);
            this.shipeiCenter(this.m_root);
        }
        this.setVisible(false);
    },

    oninit: function (mp4, func, point) {
        this.init_MoviePlayer();
        if(mp4 != "")
        {
            this.play(mp4, func, point);
        }
    },

    play_web: function (path) {
    },

    play: function (name, func, point) {

        if(fileMgr.getMe().m_xiangsu_info["root"]["vedio"] != 1)
        {
            return;
        }

        this.m_funcPoint = point;
        this.m_func = func;
        this.setVisible(true);

        var namelsit = name.split("/");
        var lastname = namelsit[namelsit.length - 1];

        if (cc.sys.isNative ) {

            if (cc.sys.os == cc.sys.OS_WINDOWS) {
                path = "video/" + lastname;
            }
            else
            {
                path = name;
            }


            console.log("play movie! win " + path);
            if (this.m_MoviePlayer)
                this.m_MoviePlayer.play(path);
        }
        else {



            path = name;

             if (this.m_MoviePlayer == null) {
                this.m_MoviePlayer = new ccui.VideoPlayer("cocosvideo.mp4");
                window.video = this.m_MoviePlayer;
                this.addChild(this.m_MoviePlayer);
             }

            this.m_sleep = 10;
            var winSize = cc.director.getWinSize();
            this.m_MoviePlayer.setContentSize(winSize.width, winSize.height);
            this.m_MoviePlayer.setPosition(winSize.width / 2, winSize.height / 2);
            this.m_MoviePlayer.setScale(1);
            this.m_MoviePlayer.setFullScreenEnabled(true);

            console.log("play movie  anzhuo!" + path);

            this.m_MoviePlayer.setURL(path);
            this.m_MoviePlayer.play();
        }
    },
    setVisible: function (visible) {

        //console.log(  " moviePlayMgr  setVisible  ！" + visible );

        this._super(visible);
        if ( visible == true )
        {
            this.m_key_not_close = true ;

            //if( sceneMgr.getMe().getCurSceneType()   == g_SceneType.SceneType_fight
            //    ||sceneMgr.getMe().getCurSceneType() == g_SceneType.SceneType_arena
            //    ||sceneMgr.getMe().getCurSceneType() == g_SceneType.SceneType_fangyu )
            //{
                 musicMgr.getMe().pauseMusic();
           // }
        }
        else
        {
            this.m_key_not_close = false ;

            musicMgr.getMe().resumeMusic();

        }
        uiMgr.getMe().updateBaseUi_OTT_key();
    },

    stop: function () {

        if (this.m_func) {
            this.m_func.call(this.m_funcPoint);
        }
        this.setVisible(false);
        if (cc.sys.isNative  ) {
            if (this.m_MoviePlayer)
                this.m_MoviePlayer.stop();
        }
        else {
            if (this.m_MoviePlayer)
            {
                this.m_MoviePlayer.stop();
                if (cc.sys.isNative ) {

                }
                else
                {
                    this.removeChild(this.m_MoviePlayer);
                    this.m_MoviePlayer = null;
                }

            }
        }


    },
    pause: function () {
        if (this.m_MoviePlayer)
            this.m_MoviePlayer.pause();

    },
    loop: function (t) {
        if (!this.m_MoviePlayer) {
            return;
        }

        if (!this.isVisible()) {
            return;
        }

        this.m_sleep -=t;
        if(  this.m_sleep > 0)
        {
            return;
        }

        var ret = this.isplay();
        if (ret == false)
        {
            this.stop();
        }
        else
        {
            this.setVisible(true);
        }
    },
    isplay: function () {
        if (!this.m_MoviePlayer) {
            return false;
        }
        if (cc.sys.isNative ) {
            if (this.m_MoviePlayer)
                return this.m_MoviePlayer.isplay();
        }
        else {

            if (this.m_MoviePlayer)
                return this.m_MoviePlayer.isPlaying();

        }


    },

    DoEnterCurButton: function () {
        this._super();
        this.stop();
    },


    onBack: function () {
        this.stop();
        this._super();
    },

});

MoviePlayerMgr.getMe = function () {
    return MoviePlayerMgr.g_instarn;
};


MoviePlayerMgr.ShowOrHide = function (flag, mp4, func, point) {


    if (flag == true)
    {
        uiMgr.getMe().show_MoviePlayerMgr(false);

        if ( MoviePlayerMgr.g_instarn == null )
        {
            MoviePlayerMgr.g_instarn = new MoviePlayerMgr();
            uiMgr.getMe().addChild( MoviePlayerMgr.g_instarn, 9000100 );
            MoviePlayerMgr.g_instarn.oninit( mp4, func, point );
            return MoviePlayerMgr.g_instarn;
        }
        else
        {
            MoviePlayerMgr.g_instarn.oninit( mp4, func, point );
            return MoviePlayerMgr.g_instarn;
        }
    }
    else
    {
        if(cc.sys.isNative  )
        {
            if ( MoviePlayerMgr.g_instarn != null )
            {
                MoviePlayerMgr.g_instarn.shutdown();
                uiMgr.getMe().removeChild( MoviePlayerMgr.g_instarn );
                MoviePlayerMgr.g_instarn = null;
            }
        }

    }
};