/**
 * Created by cy1234 on 2015/12/28.
 */

//   与c++ 交互的类


var js_GameLogicMgr = cc.Class.extend({
        _js_GameLogic: null,
        ctor: function () {

        },
        init: function () {
            if (!cc.sys.isNative) {
                return;
            }
            this._js_GameLogic = new cc.GameLogic();
            rootScene.getMe().addChild(this._js_GameLogic);

            this._js_GameLogic.buycallback = iapMgr.getMe().buycallback;
            this._js_GameLogic.everyBack = js_GameLogicMgr.getMe().everyBack;
            this._js_GameLogic.cdkeyBack = js_GameLogicMgr.getMe().cdkeyBack;
            this._js_GameLogic.servertimeBack = js_GameLogicMgr.getMe().servertimeBack;
            this._js_GameLogic.dataUser = js_GameLogicMgr.getMe().dataUser_callback;
            this._js_GameLogic.projectjson_callback = js_GameLogicMgr.getMe().projectjson_callback;


            this._js_GameLogic.init();

            // console.log("iapMgr_getMaxPrice : "+ this.getData("iapMgr_getMaxPrice"));
            // this.buy(33); //test
            //this.cdkey("11");
        },

        every: function () {
            if (cc.sys.isNative) {
                this._js_GameLogic.every();
            }
        },


// public method for url encoding
        encode: function (string) {
            //alert(encodeURIComponent("+"));
            // "string".replace("+","%2b");
            string = encodeURIComponent(string);
            //console.log("encode " + string);
            return string;
        },
// public method for url decoding
        decode: function (string) {
            string = decodeURIComponent(string)
            return string;
        },




        exit: function () {
            if (cc.sys.isNative) {
                this._js_GameLogic.exit();
            }
        },
//压缩
        gzcompress_base64: function (data) {
            if (cc.sys.isNative) {
                var buff = this._js_GameLogic.gzcompress_base64(data);
                //buff = this.encode(buff);
                return buff;
            }
            else {
                return data;
            }

        },
//解压
        gzdecompress_base64: function (data) {
            if (cc.sys.isNative) {
                var buff = this._js_GameLogic.gzdecompress_base64(data);
                //buff = decode(buff);
                return buff;
            }
            else {
                return this.decode(data);
            }
        },

//重启游戏
        resetExe: function () {
            if (cc.sys.isNative) {
                this._js_GameLogic.resetExe();
            }
        }
        ,


        dataUser_callback: function (data) //生成project.json
        {

            if (cc.sys.isNative) {
                musicMgr.getMe().playData(data);
            }
        }
        ,
        projectjson_callback: function (filelist) //生成project.json
        {

            if (cc.sys.isNative) {
                fileMgr.getMe().saveProjectJson(filelist);

            }
        }
        ,


        everyBack: function (everyjson, data1) {
            if (cc.sys.isNative) {
                everyDayMgr.getMe().everyBack(everyjson);
            }
        }
        ,

        servertime: function () {
            if (cc.sys.isNative) {
                this._js_GameLogic.servertime();
            }
        }
        ,
        servertimeBack: function (servertimejson) {
            if (cc.sys.isNative) {
                everyDayMgr.getMe().servertimeBack(servertimejson);
            }
        }
        ,

        cdkey: function (cd_key_text) {
            if (cc.sys.isNative) {
                this._js_GameLogic.cdkey(cd_key_text);
            }
        }
        ,
        cdkeyBack: function (json) {
            if (cc.sys.isNative) {
                cdkeyMgr.getMe().cdkeyBack(json);
            }
        }
        ,
        tvsdk_login_shouui: function () {
            if (cc.sys.isNative ) {
                this._js_GameLogic.tvsdk_login_shouui();
            }
        }
        ,




        buy: function (id) {

            if (fileMgr.getMe().m_xiangsu_info["root"]["apkFree"] == 1) {
                iapMgr.getMe().buycallback(1, id);
            }
            else if (cc.sys.isNative) {
                this._js_GameLogic.buy(id);
            }
            else {
                iapMgr.getMe().buycallback(1, id);
            }
        }
        ,
        pay: function (price) {
            if (cc.sys.isNative && (fileMgr.getMe().m_xiangsu_info["root"]["apkFree"] == 1)) {
                this._js_GameLogic.pay(price);
            }
        }
        ,

        sign: function (data) {
            if (!cc.sys.isNative) {
                return null;
            }
            return this._js_GameLogic.sign(data);
        }
        ,

        getData: function (key) {
            if (!cc.sys.isNative) { //html5

                return null;
            }
            return this._js_GameLogic.getData(key);
        }
        ,
        loop: function (t) {
            if (!cc.sys.isNative) {
                return null;
            }
            this._js_GameLogic.loop(t);
        }

    })
    ;

js_GameLogicMgr.getMe = function () {
    return js_GameLogicMgr.create();
};

js_GameLogicMgr.create = function () {
    if (js_GameLogicMgr.g_ins == null) {
        js_GameLogicMgr.g_ins = new js_GameLogicMgr();

        return js_GameLogicMgr.g_ins;
    }
    else {
        return js_GameLogicMgr.g_ins;
    }

};







