/**
 * Created by cy1234 on 2016/5/4.
 */
//播放电影 开场电影

var ui_MoviePlayer_startGame = UiBase.extend({

    m_MoviePlayer: null,
    m_func: null,
    m_funcPoint: null,
    m_root: null,
    m_sleep: 0,
    m_music_setting: true,
    m_playState: 0,// 0 资源加载中 1 可以结束界面了
    ctor: function () {
        this._super();
    },
    initColor: function () {
        this.setColor(cc.color(0, 0, 0));
        this.setOpacity(255 * 1.0);
        return true;
    },

    init_MoviePlayer: function () {
        if (!this.m_root) {
            console.log( "的分地方地方" + fileMgr.getMe().m_xiangsu_info["root"]["vedio_start"]);
            if( fileMgr.getMe().m_xiangsu_info["root"]["vedio_start"] != 0 )
            {
                if (cc.sys.isNative ) {
                    this.m_MoviePlayer = new cc.MoviePlayer();
                    var winSize = cc.director.getWinSize();
                    this.m_MoviePlayer.setPosition( cc.p( winSize.width / 2 , winSize.height / 2 ) );
                    this.m_MoviePlayer.setAnchorPoint( cc.p( 0.5 , 0.5 ) );
                    this.addChild( this.m_MoviePlayer, 100 );
                    this.shipeiCenter( this.m_MoviePlayer );
                }
                else
                {
                    this.m_MoviePlayer = new ccui.VideoPlayer("");
                    window.video = this.m_MoviePlayer;
                    this.addChild(this.m_MoviePlayer);
                }

            }



            this.m_root = this._parseUIFile("tiaoguo.json", 0);
            this.playAnimation("play2", true);
            this.addChild(this.m_root, 10000);
            this.shipeiCenter(this.m_root);
        }
        this.setVisible(false);
    },

    oninit: function (mp4, func, point) {
        this.init_MoviePlayer();
        if (mp4 != "") {
            this.play(mp4, func, point);
        }
    },


    play: function (name, func, point) {

        if(fileMgr.getMe().m_xiangsu_info["root"]["vedio_start"] != 1)
        {
            return;
        }

        this.m_funcPoint = point;
        this.m_func = func;
        this.setVisible(true);
        var namelsit = name.split("/");
        var lastname = namelsit[namelsit.length - 1];


        if ( cc.sys.isNative )
        {
            if (cc.sys.os == cc.sys.OS_WINDOWS)
            {
                path = "video/" + lastname;
            }
            else
            {
                path = name;
            }

            console.log("play movie! win " + path);
            if (this.m_MoviePlayer)
                this.m_MoviePlayer.play(path);
        }
        else
        {


            path = name;
            if (this.m_MoviePlayer == null) {
                this.m_MoviePlayer = new ccui.VideoPlayer("cocosvideo.mp4");
                window.video = this.m_MoviePlayer;
                this.addChild(this.m_MoviePlayer);
            }
            this.m_sleep = 10;
            var winSize = cc.director.getWinSize();
            this.m_MoviePlayer.setContentSize(winSize.width, winSize.height);
            this.m_MoviePlayer.setPosition(winSize.width / 2, winSize.height / 2);
            this.m_MoviePlayer.setScale(1);
            this.m_MoviePlayer.setFullScreenEnabled(true);

            console.log("play movie  anzhuo!" + path);

            try {
                this.m_MoviePlayer.setURL(path);
                this.m_MoviePlayer.play();
            }
            catch (e) {
            }

        }


    },
    setVisible: function (visible)
    {



        this._super(visible);
        if (visible == true) {
            this.m_key_not_close = true;


            musicMgr.getMe().pauseMusic();

        }
        else {
            this.m_key_not_close = false;

            musicMgr.getMe().resumeMusic();

        }
        uiMgr.getMe().updateBaseUi_OTT_key();
    },

    stop: function () {

        console.log("stop");
        if (this.m_func) {
            this.m_func.call(this.m_funcPoint);
        }
        this.setVisible(false);
        if (cc.sys.isNative  ) {
            if (this.m_MoviePlayer)
            {
                this.m_MoviePlayer.stop();
                this.removeChild(this.m_MoviePlayer);
                this.m_MoviePlayer = null;
            }

        }
        else {
            if (this.m_MoviePlayer)
            {
                this.m_MoviePlayer.stop();
                this.removeChild(this.m_MoviePlayer);
                this.m_MoviePlayer = null;
            }
        }


    },
    pause: function () {
        if (this.m_MoviePlayer)
            this.m_MoviePlayer.pause();

    },
    loop: function (t) {
        if (!this.m_MoviePlayer) {
            return;
        }

        if (!this.isVisible()) {
            return;
        }

        this.m_sleep -= t;
        if (this.m_sleep > 0) {
            return;
        }

        var ret = this.isplay();
        if (ret == false) {
            this.stop();
        }
        else {
            this.setVisible(true);
        }
    },
    isplay: function () {
        if (!this.m_MoviePlayer) {
            return false;
        }
        if (cc.sys.isNative  ) {
            if (this.m_MoviePlayer)
                return this.m_MoviePlayer.isplay();
        }
        else {
            if (this.m_MoviePlayer)
                return this.m_MoviePlayer.isPlaying();
        }

    },

    DoEnterCurButton: function () {
        if (this.m_playState != 1)
            return;
        this._super();
        this.stop();
    },


    onBack: function () {
        this.stop();
        this._super();
    },

    //
    resLoadEnd: function () {
        this.m_playState = 1;
        this.playAnimation("play", true);
    },


});


ui_MoviePlayer_startGame.getMe = function () {
    return ui_MoviePlayer_startGame.g_instarn;
};


ui_MoviePlayer_startGame.shutdownEx = function ()
{
    if ( ui_MoviePlayer_startGame.g_instarn )
    {
        ui_MoviePlayer_startGame.g_instarn.stop();
        ui_MoviePlayer_startGame.g_instarn.shutdown();
        uiMgr.getMe().removeChild(ui_MoviePlayer_startGame.g_instarn);
        ui_MoviePlayer_startGame.g_instarn = null;
    }
};


ui_MoviePlayer_startGame.ShowOrHide = function (flag, mp4, func, point) {
    if (flag == true) {
        if (ui_MoviePlayer_startGame.g_instarn == null) {
            ui_MoviePlayer_startGame.g_instarn = new ui_MoviePlayer_startGame();
            uiMgr.getMe().addChild(ui_MoviePlayer_startGame.g_instarn, 90001000);
            ui_MoviePlayer_startGame.g_instarn.oninit(mp4, func, point);
            return ui_MoviePlayer_startGame.g_instarn;
        }
        else {
            ui_MoviePlayer_startGame.g_instarn.oninit(mp4, func, point);
            return ui_MoviePlayer_startGame.g_instarn;
        }
    }
    else {

    }
};