/**
 * Created by xieli on 2016/4/24.
 */




var playerAi_idle = aiBase.extend({

    ctor: function (role) {
        this.m_AiType = AiType.AiType_Idle;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        this._super(key, data);
        return true;
    },
    InternalEvent: function (key, data) {
        this.m_object_role.playAnimation("daiji");
        this._super(key, data);
        return true;
    },
    update: function (t) {
        this._super(t);
        return true;
    },
    onFrameEvent: function (type, event) {
        this._super(type, event);
        return true;
    }

});

var playerAi_beiji = aiBase.extend({

    ctor: function (role) {
        this.m_AiType = AiType.AiType_beiji;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        return true;
    },
    InternalEvent: function (data) {
        rootScene.getMe().zanting_fightcd(true);
        this.m_object_role.playAnimation("shouji1", false);
        this._super(data);
        return true;
    },

    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    onFrameEvent: function (type, event) {
        this._super(type, event);
        return true;
    },
    Complete: function () {
        this._super();
        return true;
    },
});
//眩晕
var playerAi_dead = aiBase.extend({

    ctor: function (role) {
        this.m_AiType = AiType.AiType_Dead;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        this._super(key, data);
        return false;
    },
    InternalEvent: function (data) {
        //删除buff

        this.m_object_role.m_roleBuffMgr.shutdown();
        ui_fight.getMe().initTouxiang();
        //更新buff ui
        ui_fight.getMe().updateBuff();
        this.m_object_role.playAnimation("siwang", false);
        this._super(data);
        if (roleMgr.getMe().isPlayerAllDead()) {
            rootScene.getMe().zanting_fightcd();
        }


        return true;
    },

    update: function (t) {
        if (roleMgr.getMe().isPlayerAllDead()) {
            rootScene.getMe().zanting_fightcd();
        }
        this._super(t);
        return true;
    },
    onFrameEvent: function (type, event) {
        this._super(type, event);
        return true;
    },
    Complete: function ()
    {


        if (this.m_object_role.m_SelfType == false) {//弹出
            if (roleMgr.getMe().isMonsterAllDead()) {
                sceneMgr.getMe().getCurScene().gameOver(true);
            }
            return;
        }


        //弹出
        if (roleMgr.getMe().isPlayerAllDead()) {
            sceneMgr.getMe().getCurScene().gameOver(false);
        }




        return true;
    },
});







//眩晕
var playerAi_yun = aiBase.extend({

    ctor: function (role) {
        this.m_AiType = AiType.AiType_yun;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        //
        this._super(key, data);
        return true;
    },
    InternalEvent: function (key, data) {
        this.m_object_role.playAnimation("yun", true);
        this._super(key, data);
        return true;
    },
    update: function (t) {
        this._super(t);
        return true;
    },
    onFrameEvent: function (type, event) {
        this._super(type, event);
        return true;
    }
});


//if (curskill.typeState == "none")

//单体攻击
var playerAi_none = aiBase.extend({
    _skillinfo: null,
    ctor: function (role) {
        this.m_AiType = AiType.AiType_none;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_roleBuffMgr.skillEnd(); //技能结束 触发
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = data;
        this.m_object_role.playAnimation(this._skillinfo.animation, false);
        this._super(key, data);
        //釋放buff
        this.m_object_role.dealbuff(this._skillinfo);
        return true;
    },
    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {
        //var name = event.data.name;
        //if (name.indexOf("shanghai") > -1)
        //{
        // var enemylist = this.m_object_role.getenemy();
        // enemylist.each(function (key, data) {
        //    data.dealShanghai(this.m_object_role.getOutAtt(), this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);
        //}, this);
        // }
        // jizhong_texiao
        return true;
    },


});


//单体攻击
var playerAi_single = aiBase.extend({
    _skillinfo: null,
    ctor: function (role) {
        this.m_AiType = AiType.AiType_single;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_roleBuffMgr.skillEnd(); //技能结束 触发
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = data;
        this.m_object_role.playAnimation(this._skillinfo.animation, false);
        this._super(key, data);
        //釋放buff
        this.m_object_role.dealbuff(this._skillinfo);
        return true;
    },
    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {
        var name = event.data.name;
        if (name.indexOf("shanghai") > -1) {
            var enemylist = this.m_object_role.getenemy();
            enemylist.each(function (key, data) {
                var lianjiNum = this.m_object_role.getCurSkill_Father().lianjiNum;
                if (lianjiNum == null) {
                    lianjiNum = 1;
                }
                data.dealShanghai(this.m_object_role.getOutAtt() / lianjiNum, this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);

            }, this);
        }
        // jizhong_texiao
        return true;
    },


});

// 攻击2个
var playerAi_att_double = aiBase.extend({

    _skillinfo: null,
    ctor: function (role) {
        this.m_AiType = AiType.AiType_double;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_roleBuffMgr.skillEnd();
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = data;
        this.m_object_role.playAnimation(this._skillinfo.animation, false);
        this._super(key, data);
        this.m_object_role.dealbuff(this._skillinfo);
        return true;
    },
    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {
        var name = event.data.name;
        if (name.indexOf("shanghai") > -1) {

            var enemylist = this.m_object_role.getenemy();
            enemylist.each(function (key, data) {
                data.dealShanghai(this.m_object_role.getOutAtt() / this._skillinfo.killMonsterNum, this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);

            }, this);

        }
        // jizhong_texiao
        return true;
    },


});

//


var playerAi_att_All = aiBase.extend({

    _skillinfo: null,
    ctor: function (role) {
        this.m_AiType = AiType.AiType_attall;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_roleBuffMgr.skillEnd();
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {

        //this.m_object_role.clearenemy();
        //var monsterlist = roleMgr.getMe().getMonsterAlive();
        //for( var i = 0 ; i < monsterlist.size();++i )
        //{
        //    var obj = monsterlist.getData( i );
        //    this.m_object_role.addenemy( obj );
        //}


        this._state = 0;
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = data;
        this.m_object_role.playAnimation(this._skillinfo.animation, false);
        this._super(key, data);
        this.m_object_role.dealbuff(this._skillinfo);
        return true;
    },

    update: function (t) {
        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {
        var name = event.data.name;
        if (name.indexOf("shanghai") > -1) {
            var enemylist = this.m_object_role.getenemy();
            enemylist.each(function (key, data) {
                data.dealShanghai(this.m_object_role.getOutAtt() / this._skillinfo.killMonsterNum, this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);
            }, this);
        }
        // jizhong_texiao
        return true;
    },


});

//必杀技
var playerAi_att_bishaji = aiBase.extend({

    _skillinfo: null,
    ctor: function (role) {
        this.m_AiType = AiType.AiType_bishaji;
        this._super(role);
    },
    ExternalEvent: function (key, data) {
        rootScene.getMe().zanting_fightcd(false);
        this._super(key, data);
        this.m_object_role.m_roleBuffMgr.skillEnd();
        this.m_object_role.m_cdFull = false;
        return true;
    },
    InternalEvent: function (key, data) {
        this._state = 0;
        rootScene.getMe().zanting_fightcd(true);
        this._skillinfo = data;


        this.m_object_role.zanting(true);
        this._super(key, data);
        this.m_object_role.dealbuff( this._skillinfo );
        return true;
    },
    PlayMove: function () {

       if( fileMgr.getMe().m_xiangsu_info["root"]["vedio"] >0 )
       {
           rootScene.getMe().zanting_fightcd(true);
           this._skillinfo.nameMp4 = this.m_object_role.PlayheroInfo["nameMp4"];
           console.log( this._skillinfo.nameMp4 );
           uiMgr.getMe().show_MoviePlayerMgr(true, this._skillinfo.nameMp4, function () {
               rootScene.getMe().zanting_fightcd(false);
               this.m_object_role.zanting(false);
               this.CompleteEx();
           }, this);
       }
        else
       {
           this.m_object_role.zanting(false);
           this.m_object_role.playAnimation("jineng5");
       }

        return true;
    },
    update: function (t) {
        if (this._state == 0) {
            this.PlayMove();
            this._state = 1;
        }

        rootScene.getMe().zanting_fightcd(true);
        this._super(t);
        return true;
    },
    Event: function (event) {

        var name = event.data.name;
        if (name.indexOf("shanghai") > -1)
        {
            this.shanghai();
        }
        // jizhong_texiao
        return true;
    },

    shanghai: function () {
        var enemylist = this.m_object_role.getenemy();
        enemylist.each(function (key, data) {
            var shanghai = this.m_object_role.getOutAtt() / this._skillinfo.killMonsterNum;
            data.dealShanghai(shanghai, this.m_object_role, this._skillinfo.jizhong_texiao, this._skillinfo.jizhong_texiao_spine);

        }, this);
    },
    CompleteEx: function () {
        this.shanghai();
        this.m_object_role.chanageState(AiType.AiType_Idle);
        //this._super();
        return true;
    },
    Complete: function () {

        if( fileMgr.getMe().m_xiangsu_info["root"]["vedio"] >0 )
        {
            return;
        }
        // this.shanghai();
        return this._super();

    },

});


//加血 加防御 加攻击 加速度   减敌人防御 减敌人攻击 减敌人速度 晕眩
//var playerAi_add_hp = aiBase.extend({
//
//    ctor: function (role) {
//        this.m_AiType = "add_hp";
//        this._super(role);
//    },
//    ExternalEvent: function (key,data) {
//        this._super(key,data);
//        return true;
//    },
//    InternalEvent: function (key,data) {
//        this.m_object_role.playAnimation("yun",false);
//        this._super(key,data);
//        return true;
//    },
//    update: function (t) {
//        this._super(t);
//        return true;
//    },
//});









