var player = baseRole.extend({

    PlayerObjectInfo: null,
    PlayheroInfo: null,
    m_cur_playerAi: null,
    m_Ai_map: null,
    m_skill_info: null,
    m_cur_skill: null,
    m_Player_attribute_Mgr: null,
    m_levelInfoPoint: null,
    m_equipPoint:null,
    ctor: function () {
        this._super();
        this.m_baseRoleType = g_baseRoleType.type_play;
        this.m_Player_attribute_Mgr = Player_attribute_Mgr.create(this);
        this.m_roledir = -1;
    },

    getRoleName: function () {
        return this.PlayheroInfo["name"];
    },

    init: function ( heroname ) {
        this.loadres( heroname );
        this.initState();
    },

    //是否战斗状态
    isFight: function () {
        if (this.isCDFull()) {
            return true;
        }

        if (this.getCurStateType() == AiType.AiType_none) {
            return true;
        }
        else if (this.getCurStateType() == AiType.AiType_single) {
            return true;
        }
        else if (this.getCurStateType() == AiType.AiType_double) {
            return true;
        }
        else if (this.getCurStateType() == AiType.AiType_bishaji) {
            return true;
        }

        return false;
    },


    hasBuff_inskill: function (type) {
        for (var p in this.m_skill_info) {
            var obj = this.m_skill_info[p];
            if (obj["buff1"] == type ||
                obj["buff2"] == type ||
                obj["buff3"] == type) {
                return true;
            }
        }
        return false;
    },

    setxunyun: function (flag) {
        if (flag) {
            this.chanageState(AiType.AiType_yun);
        }
        else {
            this.chanageState(AiType.AiType_Idle);
        }
    },

    getTeam: function () {
        return roleMgr.getMe().getPlayerAlive();
    },

    sethp: function (val) //当前血
    {
        this.m_curHp = parseInt(val);
        if (ui_fight.getMe()) {
            ui_fight.getMe().updateMpHp(this.getMpPer(), this.getCurMp(), this.getcurhp(), this.gethpPer(), this.getRolePosType());
        }
    },

    getCurMp: function () //当前能量
    {
        return this._super();
    },
    setmp: function (val) //当前血
    {
        this.m_curMp = parseInt(val);
        if (ui_fight.getMe()) {
            ui_fight.getMe().updateMpHp(this.getMpPer(), this.getCurMp(), this.getcurhp(), this.gethpPer(), this.getRolePosType());
        }
    },
    getMaxMp: function () //
    {
        return DataMgr.getMe().getMaxMp();
    },

    addMp: function () //增加血
    {
        if (val < 0)
            return;
        var buff = this.getCurMp() + val;

        if (buff > this.getMaxMp()) {
            buff = this.getMaxMp();
        }
        this.setmp(buff);//
    },

    mpIsZugou: function () {
        if (this.getCurSkill().xiaohao_mp > this.getCurMp()) {
            return false;
        }
        return true;
    },

    mpIsZugou_BySkill: function (skillname) {
        if ("skillnormal" == skillname) {
            if (this.getskillnormal().skillPoint.xiaohao_mp > this.getCurMp()) {
                return false;
            }
        }
        else if ("skilljueji1" == skillname) {
            if (this.getskilljueji1().skillPoint.xiaohao_mp > this.getCurMp()) {
                return false;
            }
        }
        else if ("skilljueji2" == skillname) {
            if (this.getskilljueji2().skillPoint.xiaohao_mp > this.getCurMp()) {
                return false;
            }
        }
        else if ("skilljueji3" == skillname) {
            if (this.getskilljueji3().skillPoint.xiaohao_mp > this.getCurMp()) {
                return false;
            }
        }
        else if ("skilljuezhao" == skillname) {
            if (this.getskilljuezhao().skillPoint.xiaohao_mp > this.getCurMp()) {
                return false;
            }
        }
        return true;
    },

    removeMp: function (val) //增加血
    {
        val = parseFloat(val);

        if (val < 0)
            return false;

        if (this.getCurMp() < val) {
            return false;
        }

        var buff = this.getCurMp() - val;
        if (buff < 0) {
            buff = 0;

        }

        this.setmp(buff);//
        return true;
    },


    addHp: function (val) //当前血
    {
        if (val < 0)
            return;

        val = parseInt(val);

        var buff = this.getcurhp() + val;
        if (buff > this.getmaxhp()) {
            buff = this.getmaxhp();
        }

        dropHpMgr.getMe().addHp(roleMgr.getMe(), val, this.getBoneWroldPosition("head"));
        this.sethp(buff);
    },


    removeHp: function (val) //当前血
    {
        val = parseInt(val);
        if (val < 0)
            return false;

        var buff = this.getcurhp() - val;
        buff = parseInt(buff);
        if (buff < 0) {
            buff = 0;
        }

        dropHpMgr.getMe().removeHp(roleMgr.getMe(), val, this.getBoneWroldPosition("head"));
        this.sethp(buff);//m_curHp = buff;
        return true;
    },
    getcurhp: function () //当前血
    {
        return this.m_curHp;
    },
    getMoveHeadIcon: function () // 头像图片
    {
        return this.PlayheroInfo.move_fight_Head_icon;
    },
    getHeadIcon1: function () // 头像图片
    {
        return this.PlayheroInfo.fight_Head_icon1;
    },
    getHeadIcon2: function () // 头像图片
    {
        return this.PlayheroInfo.fight_Head_icon2;

    },
    getHeadIcon3: function () // 头像图片
    {
        return this.PlayheroInfo.fight_Head_icon3;
    },
    getheroName: function () {
        return this.PlayheroInfo.name;
    },
    getBasemiss: function () {

        return this.m_levelInfoPoint["miss"];
       //  return DataMgr.getMe().getBasemiss(this.getheroName());
    },
    //其实基础cd
    getBasecd: function () {

        return DataMgr.getMe().getBasecd(this.getheroName());
    },
    getBasesdefense: function () {

        var defense =  this.m_levelInfoPoint["defense"] * 0.0005;

        //var defense = DataMgr.getMe().getBasesdefense(this.getheroName()) * 0.0005;

        return defense / (1 + defense);
    },
    getLevel: function ()
    {
        return this.m_levelInfoPoint["level"] ;
        //DataMgr.getMe().getLevel(this.getheroName());
       // return 0;
    },
    getBaseAtt: function ()
    {
        return this.m_levelInfoPoint["shanghai"] ;
       // return DataMgr.getMe().getBaseAtt(this.getheroName());
    },
    getSkillAtt: function ()
    {
        return this.getBaseAtt() * this.getCurSkill().shanghai_per;
    },
    getEquipmentAtt: function ()
    {

        return this.m_equipPoint["att"];

        //return DataMgr.getMe().getEquipmentAtt(this.getheroName());
    },

    getOutAttNoBuff: function () {
        return ((this.getBaseAtt() + this.getEquipmentAtt()) * this.getCurSkill().shanghai_per);
    },

//获得当前伤害
    getOutAtt: function () {

        var NoBuff = this.getOutAttNoBuff();
        var att = ( NoBuff * (1 + this.m_roleBuffMgr.getBuffAtt()));
        return att;
    },
    //获得当前防御
    getOutDefense: function () {
        var out = this.getBasesdefense() + this.m_roleBuffMgr.getBuffdefense();
        if (out < 0) {
            out = 0;
        }
        return out;

    },
    //获得当前miss
    getOutMiss: function () {

        var out = this.getBasemiss() + this.m_roleBuffMgr.getBuffMiss();
        if (out < 0) {
            out = 0;
        }
        return out;
    },
    //获得当前cd
    getOutCd: function () {
        var out = this.getBasecd() + this.m_roleBuffMgr.getBuffSpeed();
        if (out < 0) {
            out = 0.01;
        }
        return out;
    },

//最大血量血
    getmaxhp: function ()
    {
        return  this.m_levelInfoPoint["hp"];//  DataMgr.getMe().getBasehp(this.getheroName());

    },
    getCurSkill: function () {
        return this.m_cur_skill.skillPoint;//
    },
    setCurSkill: function (skill) {
        this.m_cur_skill = skill;//
    },
    getCurSkill_Father: function () {
        return this.m_cur_skill;
    },


    getskill_enemyCount: function () {
        return this.getCurSkill().killMonsterNum;
    },

    getTeam_dead: function () {
        return roleMgr.getMe().getPlayerdead();
    },

    onFrameEvent: function (type, event) {
        this.m_cur_playerAi.onFrameEvent(type, event);
        this._super(type, event);
    },

    initState: function () {
        this.m_Ai_map = new MapGame();
        this.m_cur_playerAi = new playerAi_idle(this);
        this.m_cur_playerAi.InternalEvent();
        this.addState(this.m_cur_playerAi);

        this.addState(new playerAi_none(this));
        this.addState(new playerAi_beiji(this));
        this.addState(new playerAi_dead(this));
        this.addState(new playerAi_yun(this));
        this.addState(new playerAi_single(this));
        this.addState(new playerAi_att_double(this));
        this.addState(new playerAi_att_All(this));
        this.addState(new playerAi_att_bishaji(this));
        this.addState(new playerAi_single(this), AiType.AiType_selfSingle);

    },
    addState: function (data, type) {
        if (type == null) {
            this.m_Ai_map.put(data.m_AiType, data);
        }
        else {
            this.m_Ai_map.put(type, data);
        }
    },
//强制切换状态
    chanageState_Ex: function (key, data) {
        this.m_cur_playerAi.ExternalEvent(key);
        var buffai = this.m_Ai_map.getDataByKey(key);
        if (buffai == null) {
            return true;
        }
        if (buffai.InternalEvent(key, data)) {
            this.m_cur_playerAi = buffai;
            return true;
        }
    },

    chanageState: function (key) {

        var buffai = this.m_Ai_map.getDataByKey(key);
        if (buffai == null) {
            console.error("chanageState!");
        }

        if (!this.m_cur_playerAi.ExternalEvent(key))
            return false;

        if (buffai.InternalEvent()) {
            this.m_cur_playerAi = buffai;
            return true;
        }
        else {
            this.m_cur_playerAi.InternalEvent();
        }
    },


    //返回当前技能buff 信息

    getBuffInfo1: function () {
        if (this.getCurSkill().buff1 != null) {
            if (this.getCurSkill().buff1["type"] != null) {
                if (this.getCurSkill().buff1["type"] != "") {
                    var type = this.getCurSkill().buff1["type"];
                    return g_player_buff.getBuffInfoType(type);
                }
            }
        }
        return null;

    },
    getBuffInfo2: function () {
        if (this.getCurSkill().buff2 != null) {
            if (this.getCurSkill().buff2["type"] != null) {
                if (this.getCurSkill().buff2["type"] != "") {
                    var type = this.getCurSkill().buff2["type"];
                    return g_player_buff.getBuffInfoType(type);
                }
            }
        }
    },
    getBuffInfo3: function () {
        if (this.getCurSkill().buff3 != null) {
            if (this.getCurSkill().buff3["type"] != null) {
                if (this.getCurSkill().buff3["type"] != "") {
                    var type = this.getCurSkill().buff3["type"];
                    return g_player_buff.getBuffInfoType(type);
                }
            }
        }
    },

    //
    playAnimation: function (name, loop) {
        this._super(name, loop);
    },

//釋放buff
    dealbuff: function () {
        //playBuffMgr.createBuffById_staitc( this , g_buffType.buffType_xuanyunBuff , this.getenemy() , this.getTeam() , "self" , 1 );
        //return;

        if (this.getCurSkill() == null) {
            return;
        }

        if (this.getCurSkill().buff1 != null) {
            if (this.getCurSkill().buff1["type"] != null) {
                if (this.getCurSkill().buff1["type"] != "") {
                    var target = this.getCurSkill().buff1["target"];
                    playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff1["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
                }
            }
        }
        if (this.getCurSkill().buff2 != null) {
            if (this.getCurSkill().buff2["type"] != null) {
                if (this.getCurSkill().buff2["type"] != "") {
                    var target = this.getCurSkill().buff2["target"];
                    playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff2["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
                }
            }
        }
        if (this.getCurSkill().buff3 != null) {
            if (this.getCurSkill().buff3["type"] != null) {
                if (this.getCurSkill().buff3["type"] != "") {
                    var target = this.getCurSkill().buff3["target"];
                    playBuffMgr.createBuffById_staitc(this, this.getCurSkill().buff3["type"], this.getenemy(), this.getTeam(), target, this.getCurSkill().killMonsterNum);
                }
            }
        }

        this.m_roleBuffMgr.skillStart();

        //更新buff ui
        ui_fight.getMe().updateBuff();

    },

    //释放技能
    dealskill: function (name, data) {

        if (this.getCurSkill().typeState == null) {
            uiMgr.getMe().show_ui_MessageBox(true, this.PlayheroInfo.name + " 的技能表出错  ，typeState这个字段没有填");
            return;
        }

        if (this.getCurSkill()["killMonsterNum"] == 3) {
            this.initEnemy(3);
        }

        this.chanageState_Ex(this.getCurSkill().typeState, this.getCurSkill());

        //删除mp
        this.removeMp(Math.round(this.getCurSkill().xiaohao_mp));

        this.update_Z_oder();

    },

    update_Z_oder: function ()
    {
        roleMgr.getMe().update_Z_oder(1);
    },

    //被伤害
    dealShanghai: function (atthp, enemy, shoujitexiao, shoujitexiao_spine) {

        atthp = atthp * g_player.debugMonsterAttPer;

        if (atthp < 0) {
            return;
        }

        if (atthp == 0) {
            return;
        }

        var rend = cc.random0To1() * 100;
        if (rend <= this.getOutMiss()) {
            dropHpMgr.getMe().addmiss(roleMgr.getMe(), "", this.getBoneWroldPosition("head"));
            return;
        }
        //fangyu
        atthp = atthp - atthp * this.getOutDefense();
        if (atthp <= 1) {
            atthp = 1;
        }
        var ret = this.removeHp(atthp);
        if (ret == true) {
        }
        else {
            return;
        }
        this.playPlistAnimation_Once(shoujitexiao);

        if (shoujitexiao_spine != null) {
            spineMgr.getMe().createSpineOncePlay(shoujitexiao_spine.spineName, shoujitexiao_spine.animationName, this, null, this.getLocalZOrder() + 23);
        }
        if (this.getcurhp() <= 0) {
            this.chanageState(AiType.AiType_Dead);
        }
        else {
            this.chanageState(AiType.AiType_beiji);
        }
    },

    initFightSkill_MoveToUI: function (node) {

        node.setVisible(true);
        this.m_MyAction_FightUI_MoveTo = new MyAction_FightUI_MoveTo(this);
        var callback_func = MyCallback.create(this.FightSkill_MoveToUI_callbackFunc, this, null);
        this.m_MyAction_FightUI_MoveTo.oninit(node, 0, ui_fight.getMe().m_pos_ui_start, ui_fight.getMe().m_pos_ui_end, callback_func);
    },

    FightSkill_MoveToUI_callbackFunc: function () //可以释放技能了
    {

        //设置当前战斗的玩家
        roleMgr.getMe().setcurRole(this);
        roleMgr.getMe().getcurRole().clearenemy();
        uiMgr.getMe().show_ui_selectSkill(true);
        //this.m_roleBuffMgr.removeCd();
        this.m_cdFull = true;
    },

    getSkillLevel:function( skillType )
    {
        var level = this.m_skill_info[skillType]["level"];
        return level ;
    },

    initskill: function (skillType, l_skilllist) {

        if (l_skilllist == null)
        {
            uiMgr.getMe().show_ui_MessageBox(true, "hero:" + this.PlayheroInfo.name + "技能表没有配置！");
            return;
        }
        var level = this.getSkillLevel(skillType); //this.m_skill_info[skillType]["level"];
        if (level != l_skilllist[skillType][level]["level"])
        {
            console.error("initskill level error :" + level + skillType);
            return;
        }
        this.m_skill_info[skillType]["skillPoint"] = l_skilllist[skillType][level];
    },

    getskillnormal: function () {
        return this.m_skill_info["skillnormal"];
    },
    getskilljueji1: function () {
        return this.m_skill_info["skilljueji1"];
    },
    getskilljueji2: function () {
        return this.m_skill_info["skilljueji2"];
    },
    getskilljueji3: function () {
        return this.m_skill_info["skilljueji3"];
    },
    getskilljuezhao: function () {

        return this.m_skill_info["skilljuezhao"];
    },

    loadLevelInfoPoint: function ( heroname ) {

        this.m_levelInfoPoint = DataMgr.getMe().getLevelInfoPoint( heroname  );

    },

    loadEquipPoint: function ( heroname ) {

        this.m_equipPoint = DataMgr.getMe().getEquipPoint( heroname  );

    },


    loadres: function ( heroname ) {

        this.loadLevelInfoPoint( heroname );
        this.loadEquipPoint( heroname );

        this.PlayheroInfo = cc.clone( fileMgr.getMe().m_playhero[heroname] );

        if (this.PlayheroInfo.spine_res == null)
        {
            uiMgr.getMe().show_ui_MessageBox(true, "hero 表出错: name： " + heroname + "没有字段：spine_res");
            console.error("hero 表出错: name： " + heroname + "没有字段：spine_res");
        }

        this._super(this.PlayheroInfo.spine_res);

        this.m_skill_info = cc.clone(DataMgr.getMe().getskillinfo(this.PlayheroInfo.name));//   cc.clone( );

        var l_skilllist = g_player_skill[this.PlayheroInfo.name];

        if (l_skilllist == null)
        {
            uiMgr.getMe().show_ui_MessageBox(true, "hero:" + this.PlayheroInfo.name + "技能表没有配置！");
        }

        this.initskill("skillnormal", l_skilllist);
        this.initskill("skilljueji1", l_skilllist);
        this.initskill("skilljueji2", l_skilllist);
        this.initskill("skilljueji3", l_skilllist);
        this.initskill("skilljuezhao", l_skilllist);


        this.m_SpineNode.setScale(this.PlayheroInfo.scale);
        this.setRoleDir(this.m_roledir);

        //設置hp mp
        this.sethp(this.getmaxhp());
        this.setmp(this.getMaxMp());


    },
    update: function (dt) {
        this._super(dt);
        this.m_cur_playerAi.update(dt);
    },
    getCurStateType: function () {
        return this.m_cur_playerAi.m_AiType;
    },

    isdead: function () {
        if (this.getcurhp() <= 0) {
            return true;
        }

        if (this.getCurStateType() == AiType.AiType_Dead) {
            return true;
        }
        return false;
    },

    fuhuo: function () {
        //
        parMgr.getMe().createListAnimation_playOnce("xingjieyuanqiyongzhe/big/pre/chusheng.plist", this, cc.p(0, 0));
        this.sethp(this.getmaxhp());
        this.chanageState_Ex(AiType.AiType_Idle);
    }
});


player.getMe = function () {
    return player.create();
};

player.create = function () {
    var _player = new player();
    return _player;
};
