/**
 * Created by Administrator on 2016/6/29.
 * 出战前提示购买角色或升级武器
 */
var pop_beforeFight = cc.Class.extend({
    _lockHeroes: null,//弹出人物提示名称
    _heroAndequip: null,//需要升级武器对应的英雄名
    _levelHero:null,//需要升级的英雄
    // 出战前提示弹出次数
    _popCount : 0,
    //在popRandom次随机弹出
    _popRandom : 0,
    ctor: function () {
        this.m_des = "pop_beforeFight类";
    },

    init: function () {

    },
    pop: function () {
        if (g_isPop) {
            if (this._popCount == this._popRandom) {
                this.payForRoleOrEquip();
                this._popRandom = Math.floor(Math.random() * g_randomNum);
                this._popCount = -1;
            }
            this._popCount++;
        }
    },
    /**
     * 在战斗开始选择人物之前提示玩家购买角色或升级装备
     */
    payForRoleOrEquip: function () {
        var heroes = DataMgr.getMe().getLockHeroes();
        for (var i=0; i<heroes.length; i++) {
            //判断提示信息
            if (heroes[i] == "shiwangliefeng" || heroes[i] == "liuyingbaobing" ||
                heroes[i] == "shengguangtianfeng" || heroes[i] == "liefengzhanshen" ||
                heroes[i] == "liuyingzhanshen" || heroes[i] == "tianshe" || heroes[i] == "shengjizhanshen") {
                this._lockHeroes = heroes[i];
                var text = unLockHeroMgr.getMe().tipText(heroes[i]);
                uiMgr.getMe().show_ui_chuzhantankuang(true, text, heroes[i]);
                return;
            }
        }
        //提示升级武器
        if (heroes.length == 0) {

            var l_levelArrs = [];//获取装备等级集合
            var l_nameArrs = [];//可以升级装备英雄
            var l_sameArrs = [];//装备相同等级英雄

            for (var h in fileMgr.getMe().m_play_doc["heros"]) {
                var herolevel = DataMgr.getMe().getLevel(h);
                var equiplevel = DataMgr.getMe().getEquipmentLevel(h);
                if (equiplevel * 5 <= herolevel && !DataMgr.getMe().isEquipmentMaxLevel(h)) {
                    l_levelArrs.push(equiplevel);
                    l_nameArrs.push(h);
                }
            }
            //不能升级武器时，提示升级
            if(!l_nameArrs || l_nameArrs.length == 0){
               this.confirmLevelUp();
            }

            if (l_levelArrs == null || l_levelArrs.length == 0 || !l_levelArrs) return;
            else if (l_levelArrs.length > 1) {
                l_levelArrs.sort(function (a, b) {
                    return a - b;
                });
                for (var j = 0; j < l_nameArrs.length; j++) {
                    if (DataMgr.getMe().getEquipmentLevel(l_nameArrs[j]) == l_levelArrs[0]) {
                        l_sameArrs.push(l_nameArrs[j]);
                    }
                }
                this._heroAndequip = l_sameArrs[Math.floor(Math.random() * l_sameArrs.length)];
            }
            else if (l_levelArrs.length == 1) {
                this._heroAndequip = l_nameArrs[0];
            }
            var text2 = levelUpEquip.getMe().tipText(this._heroAndequip);
            uiMgr.getMe().show_ui_chuzhanwuqitankuang(true, this._heroAndequip,text2);
        }
    },

    /**
     * 进行武器升级
     */
    levelUpEquip: function () {
        //levelUpEquip.getMe().levelUp(this._heroAndequip);
        var callback_func = MyCallback.create(this.shengji_callback, this, null);

        //金币或勋章足够，直接支付
        var paidState = unLockHeroMgr.getMe().isEnoughPaid(this._heroAndequip,2);
        if(paidState==1 || paidState == 3){
            levelUpEquip.getMe().shengji_callback();
        }else
        //购买礼包并支付
        if(paidState==2 ){
            iapMgr.getMe().useGoldDefaultLibao(callback_func);
        }else if(paidState==4 ){
            iapMgr.getMe().useDiamondsDefaultLibao(callback_func);
        }else {
            console.log("error shengji_callback!");
            return;
        }
        uiMgr.getMe().show_ui_playOnce("jiesuochenggong.json", "play");
        uiMgr.getMe().show_ui_chuzhanwuqitankuang(false);
    },

    /**
     * 弹出人物之后对应的购买窗口
     */
    buyRole: function () {
        var heroName = unLockHeroMgr.getMe().isReqHeroes(this._lockHeroes);
        var callback_func = MyCallback.create(this.jiesuo_callback, this, null);
        //金币或勋章足够，直接支付
        var paidState = unLockHeroMgr.getMe().isEnoughPaid(heroName,1);
        if(paidState==1 || paidState == 3){
            if(!unLockHeroMgr.getMe().paid(heroName)){
                console.log("error unLockHeroMgr.getMe().paid!");
                return;
            }
        }else
        //购买礼包并支付
        if(paidState==2 ){
            iapMgr.getMe().useGoldDefaultLibao(callback_func);
        }else if(paidState==4 ){
            iapMgr.getMe().useDiamondsDefaultLibao(callback_func);
        }else {
            console.log("error unLockHeroMgr.getMe().paid2!");
            return;
        }
    },

    jiesuo_callback:function(){
        var heroName = unLockHeroMgr.getMe().isReqHeroes(this._lockHeroes);
        unLockHeroMgr.getMe().paid(heroName);
        ui_xuanzechuzhan.getMe().update_suo();
    },

    shengji_callback:function(){
        levelUpEquip.getMe().shengji_callback();
    },

    /**
     * 提示人物升级
     */
    confirmLevelUp:function(){
        var l_bigPotion = DataMgr.getMe().getItemInfo("bigPotion");
        var l_needdiamond = l_bigPotion.needdiamond * 10;
        var heroArrs = [];
        for (var h in fileMgr.getMe().m_play_doc["heros"]) {
            if(DataMgr.getMe().getPlayDoc().coreData[h].level <100 )
                heroArrs.push(h);
        }
        if(heroArrs.length<1) return;
        var randomNum = Math.floor(Math.random()*heroArrs.length);
        this._levelHero = heroArrs[randomNum];
        var l_tipName = DataMgr.getMe().getHeroName_ZH(heroArrs[randomNum]);
        var l_text = g_pop_payEvent["buyExp"]["text"];
        var l_tip = null;

        if(l_needdiamond){
            if( l_needdiamond <= DataMgr.getMe().getzuanshi()){
                l_tip =l_tipName + "太弱了！是否消耗"+ l_needdiamond + l_text;
                uiMgr.getMe().show_ui_MessageBox(true, l_tip, this.buyBigPotion, null, this);
            }else{
                l_tip =l_tipName + "太弱了！是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() + "购买" +
                    iapMgr.getMe().getUseDiamondsDefaultLibao()+"勋章，并花费其中的"+ l_needdiamond + l_text;
                uiMgr.getMe().show_ui_MessageBox(true, l_tip, this.buyDiamondBigPotion, null, this);
            }
        }
    },
    /**
     * 钱够，直接购买
     */
    buyBigPotion:function(){
        var l_bigPotion = DataMgr.getMe().getItemInfo("bigPotion");
        var l_needdiamond = l_bigPotion.needdiamond * 10;
        var l_addExp = l_bigPotion.addexp * 10;
        if(DataMgr.getMe().removeZuanshi(l_needdiamond)){
            DataMgr.getMe().addcurexp(this._levelHero, l_addExp);
            uiMgr.getMe().show_ui_playOnce("goumaichenggong.json","play");
        }
    },
    /**
     * 买勋章并补充
     */
    buyDiamondBigPotion:function(){
        var callback_func = MyCallback.create(this.buyBigPotion, this, null);
        iapMgr.getMe().useDiamondsDefaultLibao(callback_func);
    },
});

/**
 * 得到pop_beforeFight的对象
 */
pop_beforeFight.getMe = function () {
    return pop_beforeFight.create();
};
pop_beforeFight.create = function () {
    if (pop_beforeFight.g_pop_beforeFight == null) {
        pop_beforeFight.g_pop_beforeFight = new pop_beforeFight();
        return pop_beforeFight.g_pop_beforeFight;
    }
    else {
        return pop_beforeFight.g_pop_beforeFight;
    }
};