/**
 * Created by Allen on 2016/5/9.
 */
//


var everyDayMgr = cc.Class.extend({
    m_loopTime: 0,
    m_serverTime:0,
    ctor: function () {
        this.m_loopTime = 200;

    },

    init: function () {
        js_GameLogicMgr.getMe().servertime();
    },

    leap: function (year) {
        if (year % 4 == 0 && year % 100 != 0 || year % 400 == 0)
            return 1;
        else
            return 0;
    },

    updateEveryJiangli: function () {
        js_GameLogicMgr.getMe().servertime();
    },


    DateDiff: function (sDate1, sDate2) { //sDate1和sDate2是2002-12-18格式
        var  oDate1, oDate2, iDays;
        oDate1 = new Date(sDate1);
        oDate2 = new Date(sDate2);
        iDays = parseInt((oDate1.getTime() - oDate2.getTime()) / 1000 / 60 / 60 / 24); //把相差的毫秒数转换为天数
        return iDays;
    },

    count_day_ret: function (s_year, s_month, s_day, e_year, e_month, e_day) {
        //console.log("s_year, s_month, s_day, e_year, e_month, e_day "+ s_year + s_month + s_day + e_year +  e_month + e_day);
        var year, day, day1, day2;
        if (s_year < e_year) {
            day = this.count_day(s_year, s_month, s_day, 0);
            for (year = s_year + 1; year < e_year; year++)//年份累加
                if (this.leap(year))//遇到闰年
                    day += 366;
                else   //平年
                    day += 365;
            day += this.count_day(e_year, e_month, e_day, 1);
        }
        //同一年的时间判断
        else if (s_year == e_year) {
            day1 = this.count_day(s_year, s_month, s_day, 1);
            day2 = this.count_day(e_year, e_month, e_day, 1);
            day = day2 - day1;//多的被减出来了
        }
        return day;
    },

    count_day: function (year, month, day, flag) {
        var day_tab = [[31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]];
        //二维数组存放天数
        var p, i, s;
        if (this.leap(year)) //闰年为1选择后面的用
            p = 1;
        else   //平年为0选择前面的用
            p = 0;
        if (flag) {
            s = day;
            for (i = 1; i < month; i++)
                s += day_tab[p][i - 1];//查询数组累加天数
        }
        else {
            s = day_tab[p][month] - day;
            for (i = month + 1; i <= 12; i++)
                s += day_tab[p][i - 1];
        }
        return s;//返回天数
    },

    loop: function (t) {
        this.m_loopTime -= t;
        if (this.m_loopTime < 0) {
            this.m_loopTime = 200;
            this.updateEveryJiangli();
        }
    },

    everyBack: function (everyjson) {
        //everyjson = '{"Description":{"Count":["1000","10","10","2000","10","5","20"],"PropID":["1","2","3","1","4","5","2"],"PropName":["金币","元气勋章","小经验药水","金币","中经验药水","大经验药水","元气勋章"]},"Result":0}';
        everyjson = everyjson.replace(/\\/g, "");
        everyjson = everyjson.replace(/"{/g, "{");
        everyjson = everyjson.replace(/}"/g, "}");

        console.log("everyjson : " + everyjson);

        var everyObj = JSON.parse(everyjson);
        console.log("every.Result : " + everyObj.Result);
        if (everyObj.Result != 0) {
            return;
        }

        if (!everyObj.hasOwnProperty("Description")) {
            return
        }

        if (!everyObj.Description.hasOwnProperty("PropID")) {
            return
        }
        if (!everyObj.Description.hasOwnProperty("PropName")) {
            return
        }

        if (!everyObj.Description.hasOwnProperty("Count")) {
            return
        }

        if (!DataMgr.getMe().getPlayDoc().isqiandao) {
            uiMgr.getMe().show_ui_qiandao(true, everyObj);
        }

    },

    servertimeBack: function (servertimejson) {

        servertimejson = servertimejson.replace(/\\/g, "");
        servertimejson = servertimejson.replace(/"{/g, "{");
        servertimejson = servertimejson.replace(/}"/g, "}");

        console.log("servertimejson : " + servertimejson);

        var servertime = JSON.parse(servertimejson);
        console.log("servertimejson.Result : " + servertime.Result);
        if (servertime.Result != 0) {
            return;
        }
        if (!servertime.hasOwnProperty("Description")) {
            return;
        }

        var svtime = servertime.Description;
        this.m_serverTime = svtime;
        //svtime = svtime.replace( /\//g, "-");
        svtime = svtime.substring(0, svtime.indexOf(' '));
        var r = new RegExp(/^(\d{4})\/(\d{1,2})\/(\d{1,2})$/);
        r.exec(svtime);
        var year = RegExp.$1;
        var month = (RegExp.$2).length == 1 ? "0" + (RegExp.$2) : (RegExp.$2);
        var day = (RegExp.$3).length == 1 ? "0" + (RegExp.$3) : (RegExp.$3);
        var server_time = year + "-" + month + "-" + day;
        //var server_time = new Date(datestr);

        var curdate = DataMgr.getMe().getcurdate();
        if (curdate != server_time) {
            everyTaskMgr.getMe().resetTaskState();
            DataMgr.getMe().getPlayDoc().isqiandao = false;
            DataMgr.getMe().setyueka_islingqu("goldyueka" ,false);
            DataMgr.getMe().setyueka_islingqu("zuanshiyueka" ,false);
            DataMgr.getMe().getPlayDoc().curdate = server_time;
            fileMgr.getMe().savePlayInfo();
        }
        this.init_every_jingjic(server_time);
        //guajiMgr.getMe().init();

    },

    //每日五次奖励
    init_every_jingjic: function (server_time) {
        var jingjichang = fileMgr.getMe().m_play_doc["jingjichang"];
        if (server_time != jingjichang["today_time"]) {
            jingjichang["today_time"] = server_time;
            jingjichang["today_fight_count"] = 0;
            jingjichang["today_fight_jiangli"] = false;
        }

    },
});

everyDayMgr.getMe = function () {
    return everyDayMgr.create();
};

everyDayMgr.create = function () {
    if (everyDayMgr.g_instarn == null) {
        everyDayMgr.g_instarn = new everyDayMgr();
        everyDayMgr.g_instarn.init();
        return everyDayMgr.g_instarn;
    }
    else {
        return everyDayMgr.g_instarn;
    }

};