/**
 * Created by cy1234 on 2016/5/3.
 */


//  魏
var BaseKeyState_ui_config_Skill = BaseKeyState_ui_config.extend({

    ui_selectSkill: null,
    left: function () {
        var ret = this._super();
        this.ui_selectSkill.setCurSkill(this.m_key.getNode());
        return ret;
    },
    right: function () {
        var ret = this._super();
        this.ui_selectSkill.setCurSkill(this.m_key.getNode());
        return ret;
    },
    up: function () {
        var ret = this._super();
        this.ui_selectSkill.setCurSkill(this.m_key.getNode());
        return ret;
    },
    down: function () {
        var ret = this._super();
        this.ui_selectSkill.setCurSkill(this.m_key.getNode());
        return ret;
    }

});


var ui_jinengtishi = UiBase.extend({

    m_root_jinengtishi: null,
    ctor: function () {
        this._super();
        this.m_des = "ui_jinengtishi";
    },

    shutdown: function () {
        this._super();
    },

    initColor: function () {
        this.setColor(cc.color(0, 0, 0));
        this.setOpacity(255 * 0.0);
        return true;
    },
    oninit: function (data) {
        //技能提示
        this.m_root_jinengtishi = this._parseUIFile("jinengtishi.json", 0);
        this.addChild(this.m_root_jinengtishi);
        this.playAnimation("play", true);
        this.shipeiCenter(this.m_root_jinengtishi);
    },

    generateBuffInfo: function (buffinfo, generateBuffObj, num, level) {
        if (buffinfo == null) {
            return;
        }
        var enemyCount = roleMgr.getMe().getcurRole().getskill_enemyCount();
        var typeState = "";
        if (enemyCount <= 1) {
            typeState = "single";
        } else {
            typeState = "attAll";
        }

        var huihe = buffinfo[typeState]["level"][level]["val1"]; //回合
        var per = buffinfo[typeState]["level"][level]["val2"];  //百分比

        if (num == 1) {
            generateBuffObj["buffchuxuhuihe1"] = huihe;
        }
        else if (num == 2) {
            generateBuffObj["buffchuxuhuihe2"] = huihe;
        }
        else if (num == 3) {
            generateBuffObj["buffchuxuhuihe3"] = huihe;
        }
        if ( buffinfo.buffType == g_buffType.buffType_addSpeedBuff )
        {
            generateBuffObj["buffcd"] = per*100;
        }
       else if ( buffinfo.buffType == g_buffType.buffType_removeSpeedBuff )
        {
            generateBuffObj["buffcd"] = per*100;
        }
        else if ( buffinfo.buffType == g_buffType.buffType_xuanyunBuff2 )
        {
            generateBuffObj["buffodds"] = per;
        }
        else  if ( buffinfo.buffType == g_buffType.buffType_addMissBuff )
        {
            generateBuffObj["buffmiss"] = per*100;
        }
        else  if ( buffinfo.buffType == g_buffType.buffType_addDefenseBuff )
        {
            generateBuffObj["bufffangyu"] = per*100;
        }
        else  if ( buffinfo.buffType == g_buffType.buffType_removeDefenseBuff )
        {
            generateBuffObj["bufffangyu"] = per*100;
        }
        else  if ( buffinfo.buffType == g_buffType.buffType_addAttBuff )
        {
            generateBuffObj["buffatt"] =  per*100;
        }
        else  if ( buffinfo.buffType == g_buffType.buffType_addhpBuff )
        {
            generateBuffObj["buffhuixue"] = Math.round(roleMgr.getMe().getcurRole().getBaseAtt() * per);
        }
        else  if ( buffinfo.buffType == g_buffType.buffType_addhpBuff_time )
        {
            generateBuffObj["buffhuixue"] = Math.round(roleMgr.getMe().getcurRole().getBaseAtt() * per);
        }

    },

    oninitSkillTip: function (uidesskilldata, skillname) {

        var Text_1 = ccui.helper.seekWidgetByName(this.m_root_jinengtishi, "Text_1");
        var Text_2 = ccui.helper.seekWidgetByName(this.m_root_jinengtishi, "Text_2");
        var Text_3 = ccui.helper.seekWidgetByName(this.m_root_jinengtishi, "Text_3");
        var Text_4 = ccui.helper.seekWidgetByName(this.m_root_jinengtishi, "Text_4");
        var Text_5 = ccui.helper.seekWidgetByName(this.m_root_jinengtishi, "Text_5");
        var Text_6 = ccui.helper.seekWidgetByName(this.m_root_jinengtishi, "Text_6");


        if (uidesskilldata == null) {
            Text_1.setText("");
            Text_2.setText("");
            Text_3.setText("");
            Text_4.setText("");
            Text_5.setText("");
        }
        else {
            if (uidesskilldata["skill_name"]) {
                Text_1.setText(uidesskilldata["skill_name"]);
            }

            if( !DataMgr.getMe().getSkillIsLocked(roleMgr.getMe().getcurRole().getRoleName(),skillname)){
                Text_6.setVisible(false);
                Text_2.setVisible(false);
            }else{
                if (uidesskilldata["Text_2"])
                {
                    Text_2.setText(uidesskilldata["Text_2"]);
                }else{
                    Text_2.setText("");
                }

                var herolevel = DataMgr.getMe().getLevel(roleMgr.getMe().getcurRole().getRoleName());
                var requirelevel = DataMgr.getMe().getunLockSkillRequireLevel(roleMgr.getMe().getcurRole().getRoleName(),skillname);
                if(herolevel >= requirelevel ){
                    Text_6.setVisible(true);
                    Text_2.setVisible(false);
                }else{
                    Text_6.setVisible(false);
                    Text_2.setVisible(true);
                }
            }

            if (uidesskilldata["skill_des"]) {
                Text_3.setText(uidesskilldata["skill_des"]);
            }

            //获得技能信息
            var skill = roleMgr.getMe().getcurRole().getCurSkill();
            var buffinfo1 = roleMgr.getMe().getcurRole().getBuffInfo1();
            var buffinfo2 = roleMgr.getMe().getcurRole().getBuffInfo2();
            var buffinfo3 = roleMgr.getMe().getcurRole().getBuffInfo3();

            var generateBuffObj = new Object();
            var generateSkillObj = new Object();

            generateSkillObj["skillShanghai"] = Math.round(roleMgr.getMe().getcurRole().getOutAttNoBuff());
            generateSkillObj["killMonsterNum"] = roleMgr.getMe().getcurRole().getskill_enemyCount();
            generateSkillObj["xiaohao_mp"] = Math.round(skill.xiaohao_mp);

            this.generateBuffInfo(buffinfo1, generateBuffObj, 1, skill["level"]);
            this.generateBuffInfo(buffinfo2, generateBuffObj, 2, skill["level"]);
            this.generateBuffInfo(buffinfo3, generateBuffObj, 3, skill["level"]);


            if (uidesskilldata.Text_4 != null) {
                Text_4.setText(uidesskilldata.Text_4(generateSkillObj, generateBuffObj));//
            }

            if (uidesskilldata.Text_5 != null) {
                Text_5.setText(uidesskilldata.Text_5(generateSkillObj, generateBuffObj));//
            }


        }

    }
});


ui_jinengtishi.getMe = function () {
    return ui_jinengtishi.g_instarn;
}

ui_jinengtishi.ShowOrHide = function (flag) {
    if (flag == true) {
        if (ui_jinengtishi.g_instarn == null) {
            ui_jinengtishi.g_instarn = new ui_jinengtishi();
            uiMgr.getMe().addChild(ui_jinengtishi.g_instarn, 600);
            ui_jinengtishi.g_instarn.oninit('');
            return ui_jinengtishi.g_instarn;
        }
        else {
            return ui_jinengtishi.g_instarn;
        }
    }
    else {
        if (ui_jinengtishi.g_instarn != null) {
            ui_jinengtishi.g_instarn.shutdown();
            uiMgr.getMe().removeChild(ui_jinengtishi.g_instarn);
            ui_jinengtishi.g_instarn = null;
        }
    }
    return null;
};

var ui_selectSkill = UiBase.extend({
    m_CBaseKeyState: null,
    m_CheckBox_att_func: null,
    m_CheckBox_att_jueji1_func: null,
    m_CheckBox_att_jueji2_func: null,
    m_CheckBox_att_jueji3_func: null,
    m_CheckBox_att_jueji4_func: null,
    ctor: function () {
        this.m_CBaseKeyState = new BaseKeyState_ui_config_Skill();
        this.m_CBaseKeyState.ui_selectSkill = this;
        this._super();
        this.m_des = "ui_selectSkill类";
    },

    shutdown: function () {
        this._super();
        rootScene.getMe().zanting(false);
        ui_jinengtishi.ShowOrHide(false);
    },

    startMask: function ()
    {
     var scenelay =   sceneMgr.getMe().getCurScene();
     var scenenode = scenelay.m_scenenode;
    },

    endMask: function ()
    {
    },

    initColor: function () {
        this.setColor(cc.color(0, 0, 0));
        this.setOpacity(255 * 0);
        return true;
    },

    oninitSkillTip: function () {
        var uidesskilldata = null;
        var skillname = null;
        if (this.m_CBaseKeyState.m_key.getChexButton().getName() == this.m_CheckBox_att_func.getName()) {
            if (g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()] != null) {
                uidesskilldata = g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()]["skillnormal"]["uides"];
                skillname = "skillnormal";
            }

        }
        else if (this.m_CBaseKeyState.m_key.getChexButton().getName() == this.m_CheckBox_att_jueji1_func.getName()) {
            if (g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()] != null) {
                uidesskilldata = g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()]["skilljueji1"]["uides"];
                skillname = "skilljueji1";
            }

        }
        else if (this.m_CBaseKeyState.m_key.getChexButton().getName() == this.m_CheckBox_att_jueji2_func.getName()) {
            if (g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()] != null) {
                uidesskilldata = g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()]["skilljueji2"]["uides"];
                skillname = "skilljueji2";
            }
        }
        else if (this.m_CBaseKeyState.m_key.getChexButton().getName() == this.m_CheckBox_att_jueji3_func.getName()) {
            if (g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()] != null) {
                uidesskilldata = g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()]["skilljueji3"]["uides"];
                skillname = "skilljueji3";
            }
        }
        else if (this.m_CBaseKeyState.m_key.getChexButton().getName() == this.m_CheckBox_att_jueji4_func.getName()) {
            if (g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()] != null) {
                uidesskilldata = g_player_skill_uides[roleMgr.getMe().getcurRole().getRoleName()]["skilljuezhao"]["uides"];
                skillname = "skilljuezhao";
            }
        }

        //roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskillnormal());
        ui_jinengtishi.getMe().oninitSkillTip(uidesskilldata, skillname);
    },

    oninit: function (data) {
        rootScene.getMe().zanting(true);
        //技能提示

        ui_jinengtishi.ShowOrHide(true);
        var root = this._parseUIFile("xuanjineng.json", 0);
        this.playAnimation( "play", true );
        root.setScale( uiMgr.getMe().getUiScale() );
        root.setAnchorPoint(cc.p(0.5, 0.5));
        root.setPosition(cc.p(0, 0));

        this.m_CheckBox_att_func = ccui.helper.seekWidgetByName(root, "CheckBox_1");
        this.m_CheckBox_att_func.addTouchEventListener( this.att_func , this );

        this.m_CheckBox_att_jueji1_func = ccui.helper.seekWidgetByName(root, "CheckBox_2");
        this.m_CheckBox_att_jueji1_func.addTouchEventListener(this.att_jueji1_func, this);

        this.m_CheckBox_att_jueji2_func = ccui.helper.seekWidgetByName(root, "CheckBox_3");
        this.m_CheckBox_att_jueji2_func.addTouchEventListener(this.att_jueji2_func, this);

        this.m_CheckBox_att_jueji3_func = ccui.helper.seekWidgetByName(root, "CheckBox_4");
        this.m_CheckBox_att_jueji3_func.addTouchEventListener(this.att_jueji3_func, this);

        this.m_CheckBox_att_jueji4_func = ccui.helper.seekWidgetByName(root, "CheckBox_4_0");
        this.m_CheckBox_att_jueji4_func.addTouchEventListener(this.att_jueji4_func, this);


        this.addChild(root);

        this.m_CBaseKeyState.setUIName("xuanjineng");

        this.m_CBaseKeyState.regNodeEx(this.m_CheckBox_att_func, 1);
        this.m_CBaseKeyState.regNodeEx(this.m_CheckBox_att_jueji1_func, 2);
        this.m_CBaseKeyState.regNodeEx(this.m_CheckBox_att_jueji2_func, 3);
        this.m_CBaseKeyState.regNodeEx(this.m_CheckBox_att_jueji3_func, 4);
        this.m_CBaseKeyState.regNodeEx(this.m_CheckBox_att_jueji4_func, 5);

        this.m_CBaseKeyState.init(this);


        roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskillnormal());

        this.oninitSkillTip();

        this.updateUI();


    },
    
    updateUI: function () {
        var Text_2 = ccui.helper.seekWidgetByName(this.m_CheckBox_att_jueji1_func, "Text_2");
        Text_2.setString( DataMgr.getMe().getSkillName(roleMgr.getMe().getcurRole().getRoleName(),"skilljueji1"));

        Text_2 = ccui.helper.seekWidgetByName(this.m_CheckBox_att_jueji2_func, "Text_2");
        Text_2.setString( DataMgr.getMe().getSkillName(roleMgr.getMe().getcurRole().getRoleName(),"skilljueji2"));

        Text_2 = ccui.helper.seekWidgetByName(this.m_CheckBox_att_jueji3_func, "Text_2");
        Text_2.setString( DataMgr.getMe().getSkillName(roleMgr.getMe().getcurRole().getRoleName(),"skilljueji3"));

        Text_2 = ccui.helper.seekWidgetByName(this.m_CheckBox_att_jueji4_func, "Text_2");
        Text_2.setString(DataMgr.getMe().getSkillName(roleMgr.getMe().getcurRole().getRoleName(),"skilljuezhao"));


        this.update_skill_suo();
        


        if( pop_beforeNoPower.getMe()._oneChance > 0)
        {
            if (!roleMgr.getMe().getcurRole().mpIsZugou_BySkill("skillnormal")) {
                this.m_CheckBox_att_func.setBright(false);
            }
            if (!roleMgr.getMe().getcurRole().mpIsZugou_BySkill("skilljueji1")) {
                this.m_CheckBox_att_jueji1_func.setBright(false);
            }
            if (!roleMgr.getMe().getcurRole().mpIsZugou_BySkill("skilljueji2")) {
                this.m_CheckBox_att_jueji2_func.setBright(false);
            }
            if (!roleMgr.getMe().getcurRole().mpIsZugou_BySkill("skilljueji3")) {
                this.m_CheckBox_att_jueji3_func.setBright(false);
            }
            if (!roleMgr.getMe().getcurRole().mpIsZugou_BySkill("skilljuezhao")) {
                this.m_CheckBox_att_jueji4_func.setBright(false);
            }
        }


    },


    update_skill_suo: function () {

        var jueji2sou = ccui.helper.seekWidgetByName(this.m_CheckBox_att_jueji2_func, "suo");
        if(DataMgr.getMe().getSkillIsLocked(roleMgr.getMe().getcurRole().getRoleName(),"skilljueji2")){
            jueji2sou.setVisible(true);
        }else{
            jueji2sou.setVisible(false);
        }

        var jueji3sou = ccui.helper.seekWidgetByName(this.m_CheckBox_att_jueji3_func, "Sprite_30");
        if(DataMgr.getMe().getSkillIsLocked(roleMgr.getMe().getcurRole().getRoleName(),"skilljueji3")){
            jueji3sou.setVisible(true);
        }else{
            jueji3sou.setVisible(false);
        }

        var juezhaosou = ccui.helper.seekWidgetByName(this.m_CheckBox_att_jueji4_func, "Sprite_31");
        if(DataMgr.getMe().getSkillIsLocked(roleMgr.getMe().getcurRole().getRoleName(),"skilljuezhao")){
            juezhaosou.setVisible(true);
        }else{
            juezhaosou.setVisible(false);
        }

        if(sceneMgr.getMe().getCurSceneType() == g_SceneType.SceneType_xiangdao)
        {
            jueji2sou.setVisible(false);
            jueji3sou.setVisible(false);
            juezhaosou.setVisible(false);
        }

    },
    att_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskillnormal());


                //
                if (roleMgr.getMe().getcurRole().mpIsZugou()) {
                    var curskill = roleMgr.getMe().getcurRole().getCurSkill();
                    if (curskill.typeState == "none") //直接释放技能
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "attall")
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "selfSingle")
                    {
                        uiMgr.getMe().show_ui_select_player(true);
                    }
                    else
                    {
                        if( "double" == curskill.typeState)
                        {
                            uiMgr.getMe().show_ui_select_monster_two(true);
                        }
                        else {
                            uiMgr.getMe().show_ui_select_monster(true);
                        }

                    }
                    uiMgr.getMe().show_ui_selectSkill(false);
                }
                else {
                    pop_beforeNoPower.getMe().buyPowerTip();
                }
            }
                break;
        }
    },
    att_jueji1_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskilljueji1());
                if (roleMgr.getMe().getcurRole().mpIsZugou()) {
                    var curskill = roleMgr.getMe().getcurRole().getCurSkill();
                    if (curskill.typeState == "none") //直接释放技能
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "attall")
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "selfSingle")
                    {
                        uiMgr.getMe().show_ui_select_player(true);
                    }
                    else
                    {
                        if( "double" == curskill.typeState)
                        {
                            uiMgr.getMe().show_ui_select_monster_two(true);
                        }
                        else {
                            uiMgr.getMe().show_ui_select_monster(true);
                        }
                    }
                    uiMgr.getMe().show_ui_selectSkill(false);
                }
                else {
                    pop_beforeNoPower.getMe().buyPowerTip();
                }
            }
                break;
        }
    },
    att_jueji2_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                if (sceneMgr.getMe().getCurSceneType() != g_SceneType.SceneType_xiangdao )
                {
                    if(DataMgr.getMe().getSkillIsLocked(roleMgr.getMe().getcurRole().getRoleName(),  "skilljueji2"))
                    {
                        this.jinengjiesuo(roleMgr.getMe().getcurRole().getRoleName(), "skilljueji2");
                        return;
                    }
                }

                roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskilljueji2());
                if (roleMgr.getMe().getcurRole().mpIsZugou()) {
                    var curskill = roleMgr.getMe().getcurRole().getCurSkill();
                    if (curskill.typeState == "none") //直接释放技能
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "attall")
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "selfSingle")
                    {
                        uiMgr.getMe().show_ui_select_player(true);
                    }
                    else
                    {
                        if( "double" == curskill.typeState)
                        {
                            uiMgr.getMe().show_ui_select_monster_two(true);
                        }
                        else {
                            uiMgr.getMe().show_ui_select_monster(true);
                        }
                    }
                    uiMgr.getMe().show_ui_selectSkill(false);
                }
                else {
                    pop_beforeNoPower.getMe().buyPowerTip();
                }
            }
                break;
        }
    },
    att_jueji3_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {
                if (sceneMgr.getMe().getCurSceneType() != g_SceneType.SceneType_xiangdao ) {
                    if (DataMgr.getMe().getSkillIsLocked(roleMgr.getMe().getcurRole().getRoleName(), "skilljueji3")) {
                        this.jinengjiesuo(roleMgr.getMe().getcurRole().getRoleName(), "skilljueji3");
                        return;
                    }
                }
                roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskilljueji3());
                if (roleMgr.getMe().getcurRole().mpIsZugou()) {
                    var curskill = roleMgr.getMe().getcurRole().getCurSkill();

                    if (curskill.typeState == "none") //直接释放技能
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "attall")
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }

                    else if (curskill.typeState == "selfSingle")
                    {
                        uiMgr.getMe().show_ui_select_player(true);
                    }
                    else
                    {
                        if( "double" == curskill.typeState)
                        {
                            uiMgr.getMe().show_ui_select_monster_two(true);
                        }
                        else {
                            uiMgr.getMe().show_ui_select_monster(true);
                        }
                    }

                    uiMgr.getMe().show_ui_selectSkill(false);
                }
                else
                {
                    pop_beforeNoPower.getMe().buyPowerTip();
                }
            }
                break;
        }
    },
    att_jueji4_func: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
            {

                if (sceneMgr.getMe().getCurSceneType() != g_SceneType.SceneType_xiangdao ) {
                    if (DataMgr.getMe().getSkillIsLocked(roleMgr.getMe().getcurRole().getRoleName(), "skilljuezhao")) {
                        this.jinengjiesuo(roleMgr.getMe().getcurRole().getRoleName(), "skilljuezhao");
                        return;
                    }
                }

                roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskilljuezhao());

                if (roleMgr.getMe().getcurRole().mpIsZugou())
                {
                    var curskill = roleMgr.getMe().getcurRole().getCurSkill();

                    if (curskill.typeState == "none") //直接释放技能
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "attall")
                    {
                        roleMgr.getMe().getcurRole().dealskill();
                    }
                    else if (curskill.typeState == "selfSingle")
                    {
                        uiMgr.getMe().show_ui_select_player(true);
                    }
                    else if (curskill.typeState == "bishaji")
                    {
                        if( 2 == curskill.killMonsterNum)
                        {
                            uiMgr.getMe().show_ui_select_monster_two( true );
                        }
                        else  if( 1 == curskill.killMonsterNum)
                        {
                            uiMgr.getMe().show_ui_select_monster( true );
                        }
                        else  if ( 3 == curskill.killMonsterNum)
                        {
                            roleMgr.getMe().getcurRole().dealskill();
                        }
                    }
                    else
                    {
                        if( "double" == curskill.typeState)
                        {
                            uiMgr.getMe().show_ui_select_monster_two(true);
                        }
                        else {
                            uiMgr.getMe().show_ui_select_monster(true);
                        }
                    }

                    uiMgr.getMe().show_ui_selectSkill(false);
                }
                else
                {
                    pop_beforeNoPower.getMe().buyPowerTip();
                }
            }
                break;
        }
    },

    setCurSkill: function (checkbox) {
        if (checkbox.getName() == "CheckBox_1") {
            roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskillnormal());
        }
        else if (checkbox.getName() == "CheckBox_2") {
            roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskilljueji1());
        }
        else if (checkbox.getName() == "CheckBox_3") {
            roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskilljueji2());
        }
        else if (checkbox.getName() == "CheckBox_4") {
            roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskilljueji3());
        }
        else if (checkbox.getName() == "CheckBox_4_0") {
            roleMgr.getMe().getcurRole().setCurSkill(roleMgr.getMe().getcurRole().getskilljuezhao());
        }
    },


    //技能解锁
    jinengjiesuo: function (heroname, skillname) {
        var  callback_func = MyCallback.create(this.jiesou_success, this, null);
        unLockSkillMgr.getMe().unLockSkill(heroname, skillname, callback_func);
    },

    jiesou_success: function () {
        this.updateUI();
    },

    onBack: function () //弹出退出box
    {
        // uiMgr.getMe().show_ui_selectSkill(false);
        //rootScene.getMe().zanting(false);
        if(sceneMgr.getMe().getCurSceneType() == g_SceneType.SceneType_xiangdao)
        {
            return;
        }

        uiMgr.getMe().show_ui_zanting(true);
    },

    onUpdate: function (t) {
        this._super(t);
        rootScene.getMe().zanting(true);
    },

    left: function () {
        this._super();
        this.oninitSkillTip();
    },

    right: function () {
        this._super();
        this.oninitSkillTip();
    },

    up: function () {
        this._super();
        this.oninitSkillTip();
    },

    down: function () {
        this._super();
        this.oninitSkillTip();
    },


});

ui_selectSkill.getMe = function () {
        return ui_selectSkill.g_instarn;
}
ui_selectSkill.ShowOrHide = function (flag) {
    if (flag == true) {
        if (ui_selectSkill.g_instarn == null) {
            ui_selectSkill.g_instarn = new ui_selectSkill();
            uiMgr.getMe().addChild(ui_selectSkill.g_instarn, 601);

            // ui_selectSkill.g_instarn.setPosition(cc.p(0,200));

            var pos = roleMgr.getMe().getcurRole().getShoujidianBoneWroldPosition();
            pos.x = pos.x * uiMgr.getMe().getUiScale();
            pos.y = pos.y * uiMgr.getMe().getUiScale();
            ui_selectSkill.g_instarn.setPosition(pos);
            ui_selectSkill.g_instarn.oninit('');
            return ui_selectSkill.g_instarn;
        }
        else {
            return ui_selectSkill.g_instarn;
        }
    }
    else {
        if (ui_selectSkill.g_instarn != null) {
            ui_selectSkill.g_instarn.shutdown();
            uiMgr.getMe().removeChild(ui_selectSkill.g_instarn);
            ui_selectSkill.g_instarn = null;
        }
    }

};
