/**
 * Created by cy1234 on 2016/6/5.
 */

//  维护者 ： 魏  选择玩家状态


var BaseKeyState_player = BaseKeyState_config.extend(
 {
    m_ui_select_player: null,
    ctor: function ()
    {
        this._super();
    },
    init: function (father)
    {
        this.m_ui_select_player = father;
        this._super(father);
    },
    shutdown: function ()
    {
        this._super();
    },
    loop: function ()
    {
        if (this.m_key == null)
        {
            return;
        }
        //更新位置
        this.m_ui_select_player.m_rootui.setPosition(this.m_key.getNode().getHeadBoneWroldPosition());

        if ( this.m_key.node.isVisible() )
        {
            for (var i = 0; i < this.m_buttonlist.getSize(); i++)
            {
                var nodeinfo = this.m_buttonlist.getData(i);
                if (nodeinfo.getNode() == this.m_key.getNode())
                {
                    this.m_key.getNode().setSelected(true);
                }
                else
                {
                    nodeinfo.getNode().setSelected(false);
                }
            }
        }
        else
        {
            var retkey = this.m_buttonlist.getnext(this.m_key);
            if (retkey != null)
            {
                this.m_key = retkey;
                //this.m_key = this.m_buttonlist.begin();
            }
        }
    },
    DoEnterCurButton: function ()
    {
        if (this.m_buttonlist.size() == 0) {
            return false;
        }
        if (this.m_key != this.m_buttonlist.end())
        {
            var player = this.m_key.node;

            var retcount = roleMgr.getMe().getcurRole().addDuiyouSkillMap( player );

            var skillCount = roleMgr.getMe().getcurRole().getskill_enemyCount();

            if (retcount >= skillCount)
            {
                roleMgr.getMe().getcurRole().dealskill();
                uiMgr.getMe().show_ui_select_player(false);
            }

            return true;
        }
        return false;
    },

    left: function ()
    {
        var ret = this.m_buttonlist.getDataByKey(this.m_key.left_pos);
        if (ret)
        {
            this.m_key = ret;
            if (this.m_key.getNode().isdead())
            {
                return this.left();
            }
            return true;
        }
        return false;
    },
    right: function ()
    {
        var ret = this.m_buttonlist.getDataByKey(this.m_key.right_pos);
        if (ret)
        {
            this.m_key = ret;
            if ( this.m_key.getNode().isdead() )
            {
                return this.right();
            }
            return true;
        }
        return false;
    },
    up: function () {
        var ret = this.m_buttonlist.getDataByKey(this.m_key.up_pos);
        if (ret) {
            this.m_key = ret;
            if (this.m_key.getNode().isdead()) {
                return this.up();
            }
            return true;
        }
        return false;
    },
    down: function () {
        var ret = this.m_buttonlist.getDataByKey(this.m_key.down_pos);
        if (ret) {
            this.m_key = ret;
            if (this.m_key.getNode().isdead()) {
                return this.down();
            }
            return true;
        }
        return false;
    },
});


var ui_select_player = UiBase.extend({

    m_CBaseKeyState: null,
    m_rootui: null,
    ctor: function ()
    {
        this._super();
        this.m_CBaseKeyState = new BaseKeyState_player();
        this.m_des = "ui_select_player类";
        roleMgr.getMe().getcurRole().clearDuiyouSkillMap(  );
    },
    shutdown: function ()
    {
        rootScene.getMe().zanting(false);
        roleMgr.getMe().removeChild(this.m_rootui);
        this._super();
    },
    initColor: function ()
    {
        this.setColor(cc.color(0, 0, 0));
        this.setOpacity(255 * 0);
        return true;
    },
    oninit: function (data)
    {

        this.m_rootui = this._parseUIFile( "jiantou2.json", 0 );

        this.m_rootui.setAnchorPoint(cc.p(0.5,0.0));

        this.playAnimation( "play" , true );

        var Image_1 = ccui.helper.seekWidgetByName(this.m_rootui, "Image_1");
        Image_1.addTouchEventListener(this.enterEx, this);


        roleMgr.getMe().addChild( this.m_rootui , 100000 );

        var playerlist = roleMgr.getMe().getPlayerAlive();

        if ( playerlist.getSize() == 3  )
        {
            this.m_CBaseKeyState.regNode_config( playerlist.getData(0), 1, null, null, null, 2);
            this.m_CBaseKeyState.regNode_config( playerlist.getData(1), 2, null, null, 1, 3);
            this.m_CBaseKeyState.regNode_config( playerlist.getData(2), 3, null, null, 2, null);
        }
        else if ( playerlist.getSize() == 2 )
        {
            this.m_CBaseKeyState.regNode_config(playerlist.getData(0), 1, null, null, 2, 2);
            this.m_CBaseKeyState.regNode_config(playerlist.getData(1), 2, null, null, 1, 1);
        }
        else if ( playerlist.getSize() == 1 )
        {
            this.m_CBaseKeyState.regNode_config(playerlist.getData(0), 1, null, null, null, null);
        }
        this.m_CBaseKeyState.init(this);
        rootScene.getMe().zanting(true);
    },

    onKeyPressed: function (keyCode) {
        this._super(keyCode);
    },

    enterEx: function ( sender, type )
    {
        switch ( type )
        {
            case ccui.Widget.TOUCH_ENDED:
            {
                this.m_CBaseKeyState.DoEnterCurButton();
            }
            break;
        }
    },

    onBack: function () //弹出退出box
    {
        this._super();
        //uiMgr.getMe().show_ui_zanting(true);
        uiMgr.getMe().show_ui_select_player(false);
        uiMgr.getMe().show_ui_selectSkill(true);
    },

    //退出這个状态
    DoEnterCurButton: function () {
        this._super();
    },

    onUpdate: function (t)
    {
        this._super(t);
        rootScene.getMe().zanting(true);
    }

});


ui_select_player.ShowOrHide = function (flag) {
    if (flag == true) {
        if (ui_select_player.g_instarn == null) {
            ui_select_player.g_instarn = new ui_select_player();
            uiMgr.getMe().addChild(ui_select_player.g_instarn, 3000);

            ui_select_player.g_instarn.oninit('');
            return ui_select_player.g_instarn;
        }
        else {
            return ui_select_player.g_instarn;
        }
    }
    else {
        if (ui_select_player.g_instarn != null) {
            ui_select_player.g_instarn.shutdown();
            uiMgr.getMe().removeChild(ui_select_player.g_instarn);
            ui_select_player.g_instarn = null;
        }

    }


};
