/**
 * Created by cy1234 on 2016/5/4.
 */
//技能升级


var ui_jinengshengji = UiBase.extend({
    m_CBaseKeyState: null,
    jineng_ImageView: null,
    _heroname: "",
    _skillname: "",
    m_jiesuo1:null,

    ctor: function () {
        this._super();
        this.m_des = "ui_jinengshengji类";
        this.m_CBaseKeyState = new BaseKeyState();
        this.jineng_ImageView = new Array();
    },

    oninit: function (heroname) {
        this._heroname = heroname;
        var root = this._parseUIFile("jinengjiemian1.json", 0);
        this.EnterUI();
        this.addChild(root);
        this.shipeiCenter(root);

        //引导使用
        var jineng1_image = ccui.helper.seekWidgetByName(root, "jineng1");
        this.m_jiesuo1 = ccui.helper.seekWidgetByName(jineng1_image, "jiesuo");

        for (var i = 1; i <= 4; i++) {
            var jineng_image = ccui.helper.seekWidgetByName(root, "jineng" + i);
            this.jineng_ImageView.push(jineng_image);
            var jiesuo = ccui.helper.seekWidgetByName(jineng_image, "jiesuo");
            jiesuo.setUserData("jineng" + i);
            jiesuo.addTouchEventListener(this.jinengchuli, this);
            this.m_CBaseKeyState.regNodeEx(jiesuo, i);
        }

        this.m_CBaseKeyState.init(this);

        this.updateUI();
    },

    onKeyPressed: function (keyCode) {
        this._super(keyCode);
    },

    onBack: function () {
        this.endLayout(function () {
            uiMgr.getMe().show_ui_jinengshengji(false);
        });

    },


    updateUI: function () {
        this.updateJinengList();
        this.updateTopUI();
    },

    updateTopUI: function () {
        var  heroNameImage  = ccui.helper.seekWidgetByName(this.m_root, "Image_3");
        heroNameImage.loadTexture(DataMgr.getMe().getHeroNameImage(this._heroname));

        var  herolv  = ccui.helper.seekWidgetByName(this.m_root, "Text_22");
        herolv.setString("LV：" + DataMgr.getMe().getLevel(this._heroname));
    },

    updateJinengCheckBoxState: function (checkbox, isLocked) {
        var jineng_shengji = ccui.helper.seekWidgetByName(checkbox, "Image_4_0");
        var jineng_jiesuo = ccui.helper.seekWidgetByName(checkbox, "Image_4");
        if (isLocked) {
            jineng_jiesuo.setVisible(true);
            jineng_shengji.setVisible(false);
        } else {
            jineng_jiesuo.setVisible(false);
            jineng_shengji.setVisible(true);
        }
    },

    generateBuffInfo: function (buffinfo, generateBuffObj, num, level, skillatt) {
        if (buffinfo == null) {
            return;
        }
        var typeState = "";
        if (skillatt.killMonsterNum <= 1) {
            typeState = "single";
        } else {
            typeState = "attAll";
        }

        var huihe = buffinfo[typeState]["level"][level]["val1"]; //回合
        var per = buffinfo[typeState]["level"][level]["val2"];  //百分比

        if (num == 1) {
            generateBuffObj["buffchuxuhuihe1"] = huihe;
        }
        else if (num == 2) {
            generateBuffObj["buffchuxuhuihe2"] = huihe;
        }
        else if (num == 3) {
            generateBuffObj["buffchuxuhuihe3"] = huihe;
        }
        if (buffinfo.buffType == g_buffType.buffType_addSpeedBuff) {
            generateBuffObj["buffcd"] = per * 100;
        }
        else if (buffinfo.buffType == g_buffType.buffType_removeSpeedBuff) {
            generateBuffObj["buffcd"] = per * 100;
        }
        else if (buffinfo.buffType == g_buffType.buffType_xuanyunBuff2) {
            generateBuffObj["buffodds"] = per;
        }
        else if (buffinfo.buffType == g_buffType.buffType_addMissBuff) {
            generateBuffObj["buffmiss"] = per * 100;
        }
        else if (buffinfo.buffType == g_buffType.buffType_addDefenseBuff) {
            generateBuffObj["bufffangyu"] = per * 100;
        }
        else if (buffinfo.buffType == g_buffType.buffType_removeDefenseBuff) {
            generateBuffObj["bufffangyu"] = per * 100;
        }
        else if (buffinfo.buffType == g_buffType.buffType_addAttBuff) {
            generateBuffObj["buffatt"] = per * 100;
        }
        else if (buffinfo.buffType == g_buffType.buffType_addhpBuff) {
            generateBuffObj["buffhuixue"] = Math.round((DataMgr.getMe().getBaseAtt(this._heroname))  * per);
        }
        else if (buffinfo.buffType == g_buffType.buffType_addhpBuff_time) {
            generateBuffObj["buffhuixue"] = Math.round((DataMgr.getMe().getBaseAtt(this._heroname)) * per);
        }

    },

    getBuffInfo1: function (skillinfo) {
        if (skillinfo.buff1 != null) {
            if (skillinfo.buff1["type"] != null) {
                if (skillinfo.buff1["type"] != "") {
                    var type = skillinfo.buff1["type"];
                    return g_player_buff.getBuffInfoType(type);
                }
            }
        }
        return null;

    },
    getBuffInfo2: function (skillinfo) {
        if (skillinfo.buff2 != null) {
            if (skillinfo.buff2["type"] != null) {
                if (skillinfo.buff2["type"] != "") {
                    var type = skillinfo.buff2["type"];
                    return g_player_buff.getBuffInfoType(type);
                }
            }
        }
    },
    getBuffInfo3: function (skillinfo) {
        if (skillinfo.buff3 != null) {
            if (skillinfo.buff3["type"] != null) {
                if (skillinfo.buff3["type"] != "") {
                    var type = skillinfo.buff3["type"];
                    return g_player_buff.getBuffInfoType(type);
                }
            }
        }
    },

    updateJinengList: function () {
        for (var i = 0; i < this.jineng_ImageView.length; i++) {
            var jineng_image = this.jineng_ImageView[i];
            var name = jineng_image.getName();
            var skillname = this.checkBoxNameToskillName(name);
            var isLocked = DataMgr.getMe().getSkillIsLocked(this._heroname, skillname);
            var locklevel = DataMgr.getMe().getunLockSkillRequireLevel(this._heroname,skillname);

            var skillImage = ccui.helper.seekWidgetByName(jineng_image, "Image_5");
            skillImage.loadTexture(DataMgr.getMe().getSkillIcon(this._heroname, skillname));

            var name = ccui.helper.seekWidgetByName(jineng_image, "Text_1");
            name.setString(DataMgr.getMe().getSkillName(this._heroname, skillname));

            var huobishu = ccui.helper.seekWidgetByName(jineng_image, "Text_3");
            var huobitubiao = ccui.helper.seekWidgetByName(jineng_image, "Image_13");

            var isLocked = DataMgr.getMe().getSkillIsLocked(this._heroname, skillname);
            if (isLocked) {
                var money = DataMgr.getMe().getunLockSkillMoney(this._heroname, skillname);
            } else {
                var money = DataMgr.getMe().getSkillLevelMoney(this._heroname, skillname);
            }
            var needgold = money[0];
            var needdiamond = money[1];
            if (needgold) {
                huobitubiao.loadTexture("xingjieyuanqiyongzhe/big/ui/image/UI_0017.png");
                huobishu.setString(needgold);
            } else if (needdiamond) {
                huobitubiao.loadTexture("xingjieyuanqiyongzhe/big/ui/image/UI_0018.png");
                huobishu.setString(needdiamond);
            } else {
                huobishu.setString(0);
            }

            var curlevel = DataMgr.getMe().getSkillLevel(this._heroname, skillname);
            var nextlevel = DataMgr.getMe().getSkillNextLevel(this._heroname, skillname)
            var dengji1 = ccui.helper.seekWidgetByName(jineng_image, "Text_2");
            dengji1.setString(curlevel);
            var dengji2 = ccui.helper.seekWidgetByName(jineng_image, "Text_5");
            dengji2.setString(curlevel);
            var xiayiji = ccui.helper.seekWidgetByName(jineng_image, "Text_6");
            xiayiji.setString(nextlevel);


            var curLevelAtt = DataMgr.getMe().getSkillLevelAtt(this._heroname, skillname);
            var nextLevelAtt = DataMgr.getMe().getSkillNextLevelAtt(this._heroname, skillname);

            var shanghaiqian = ccui.helper.seekWidgetByName(jineng_image, "Text_8");
            var shanghai_qian = (DataMgr.getMe().getBaseAtt(this._heroname) + DataMgr.getMe().getEquipmentAtt(this._heroname)) * curLevelAtt.shanghai_per
            shanghaiqian.setString(Math.round(shanghai_qian));


            var xiaohaoqian = ccui.helper.seekWidgetByName(jineng_image, "Text_12");
            xiaohaoqian.setString(Math.round(curLevelAtt.xiaohao_mp));


            var shanghaihou = ccui.helper.seekWidgetByName(jineng_image, "Text_10");
            var xiaohaohou = ccui.helper.seekWidgetByName(jineng_image, "Text_14");
            xiaohaohou.setString(Math.round(nextLevelAtt.xiaohao_mp));
            var shanghai_hou = (DataMgr.getMe().getBaseAtt(this._heroname) + DataMgr.getMe().getEquipmentAtt(this._heroname)) * nextLevelAtt.shanghai_per
            shanghaihou.setString(Math.round(shanghai_hou));

            var shengjitishi = ccui.helper.seekWidgetByName(jineng_image, "Text_1_1_1223");
            if (isLocked) {
                shengjitishi.setString("英雄达到"+ locklevel + "级时可解锁");
            } else {
                shengjitishi.setString("英雄达到"+ curlevel*5 + "级时可升级");
            }

            var buff_qian = ccui.helper.seekWidgetByName(jineng_image, "Text_15");
            var generateBuffObj = new Object();
            var generateSkillObj = new Object();
            generateSkillObj["killMonsterNum"] = curLevelAtt.killMonsterNum;
            this.generateBuffInfo(this.getBuffInfo1(curLevelAtt), generateBuffObj, 1, curlevel, curLevelAtt);
            this.generateBuffInfo(this.getBuffInfo2(curLevelAtt), generateBuffObj, 2, curlevel, curLevelAtt);
            this.generateBuffInfo(this.getBuffInfo3(curLevelAtt), generateBuffObj, 3, curlevel, curLevelAtt);
            var uidesskilldata = g_player_skill_uides[this._heroname][skillname]["uides"];
            if (uidesskilldata.Text_3 != null) {
                var buff = uidesskilldata.Text_3(generateSkillObj, generateBuffObj)
                if (buff != null) {
                    buff_qian.setString(buff);//
                } else {
                    buff_qian.setString("");
                }

            } else {
                buff_qian.setString("");
            }


            var buff_hou = ccui.helper.seekWidgetByName(jineng_image, "Text_16");
            var generateBuffObj = new Object();
            var generateSkillObj = new Object();
            generateSkillObj["killMonsterNum"] = nextLevelAtt.killMonsterNum;
            this.generateBuffInfo(this.getBuffInfo1(nextLevelAtt), generateBuffObj, 1, nextlevel, nextLevelAtt);
            this.generateBuffInfo(this.getBuffInfo2(nextLevelAtt), generateBuffObj, 2, nextlevel, nextLevelAtt);
            this.generateBuffInfo(this.getBuffInfo3(nextLevelAtt), generateBuffObj, 3, nextlevel, nextLevelAtt);
            var uidesskilldata = g_player_skill_uides[this._heroname][skillname]["uides"];
            if (uidesskilldata.Text_3 != null) {
                var buff = uidesskilldata.Text_3(generateSkillObj, generateBuffObj)
                if (buff != null) {
                    buff_hou.setString(buff);//
                } else {
                    buff_hou.setString("");
                }

            } else {
                buff_hou.setString("");
            }

            var suo_image = ccui.helper.seekWidgetByName(jineng_image, "suo");
            if (isLocked) {
                suo_image.setVisible(true);
            } else {
                suo_image.setVisible(false);
            }

            var jiesuo_che = ccui.helper.seekWidgetByName(jineng_image, "jiesuo");
            var manji_image = ccui.helper.seekWidgetByName(jineng_image, "Image_6");
            var jineng_shengji = ccui.helper.seekWidgetByName(jiesuo_che, "Image_4_0");
            var jineng_jiesuo = ccui.helper.seekWidgetByName(jiesuo_che, "Image_4");

            if (DataMgr.getMe().isSkillMaxLevel(this._heroname, skillname)) {
                if(manji_image){
                    manji_image.setVisible(true);
                }
                jineng_shengji.setVisible(false);
                jineng_jiesuo.setVisible(false);
            } else {
                if (isLocked) {
                    jineng_jiesuo.setVisible(true);
                    jineng_shengji.setVisible(false);
                } else {
                    jineng_jiesuo.setVisible(false);
                    jineng_shengji.setVisible(true);
                }
                if(manji_image){
                    manji_image.setVisible(false);
                }
            }
        }
    },


    jinengchuli: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_ENDED:
                //musicMgr.getMe().playEffect();
            {
                if (DataMgr.getMe().getHeroIsLocked(this._heroname)) {
                    uiMgr.getMe().show_ui_MessageBox2(true, "英雄未解锁！");
                    return;
                }

                var name = sender.getUserData();
                var skillname = this.checkBoxNameToskillName(name);
                this._skillname = skillname;
                var isLocked = DataMgr.getMe().getSkillIsLocked(this._heroname, skillname);
                if (isLocked) {
                    this.jinengjiesuo();
                } else {
                    this.jinengshengji();
                }
            }
                break;

            default:
                break;
        }
    },

    //技能升级
    jinengshengji: function () {
        var callback_func = MyCallback.create(this.shengji_success, this, null);
        levelUpSkillMgr.getMe().levelUp(this._heroname, this._skillname, callback_func);
    },

    //技能解锁
    jinengjiesuo: function () {
        var callback_func = MyCallback.create(this.jiesou_success, this, null);
        unLockSkillMgr.getMe().unLockSkill(this._heroname, this._skillname, callback_func);
    },

    jiesou_success: function () {
        this.updateUI();
    },

    shengji_success: function () {
        this.updateUI();
    },


    checkBoxNameToskillName: function (name) {
        if (name == "jineng1") {
            return "skilljueji1";
        }
        else if (name == "jineng2") {
            return "skilljueji2";
        }
        else if (name == "jineng3") {
            return "skilljueji3";
        }
        else if (name == "jineng4") {
            return "skilljuezhao";
        }
    },
});

ui_jinengshengji.getMe = function () {
    return ui_jinengshengji.g_instarn;
}

ui_jinengshengji.ShowOrHide = function (flag, heroname) {
    if (flag == true) {
        if (ui_jinengshengji.g_instarn == null) {
            ui_jinengshengji.g_instarn = new ui_jinengshengji();
            uiMgr.getMe().addChild(ui_jinengshengji.g_instarn, 20001);

            ui_jinengshengji.g_instarn.oninit(heroname);
            return ui_jinengshengji.g_instarn;
        }
        else {
            return ui_jinengshengji.g_instarn;
        }
    }
    else {
        if (ui_jinengshengji.g_instarn != null) {
            ui_jinengshengji.g_instarn.shutdown();
            uiMgr.getMe().removeChild(ui_jinengshengji.g_instarn);
            ui_jinengshengji.g_instarn = null;
        }
    }


};
