/**
 * Created by cy1234 on 2016/4/19.
 */


//

g_buttonChangeMp3 = "anniuxuanze.mp3";

var NodeInfo = cc.Class.extend({

    id: 0,
    name: "",
    node: null,
    pianchapos: null,
    InitPos: null,
    isbasd: false,
    type: 0,
    Movetype: 0,
    left_pos: 0,
    right_pos: 0,
    up_pos: 0,
    down_pos: 0,
    ctor: function () {
    },
    getButton: function () {
        if (this.type == 0) {
            return this.node;
        }
        return null;

    },
    getName: function () {
        return this.node.getName();
    },
    getChexButton: function () {
        if (this.type == 1) {
            return this.node;
        }
        return null;
    },
    getNode: function () {
        return this.node;
    },
    isTouchEnable: function () {
        return this.node.isTouchEnabled();
    }
});


var BaseKeyState = cc.Class.extend({
    m_key: null, // 指向 node 的焦点
    m_buttonlist: null,
    m_listjiaodian: 0,
    m_curUiBase: null,
    m_shouzhi: null,
    m_move: false,

    ctor: function () {
        this.m_buttonlist = new MapGame();
    },

    init: function (father) {
        this.m_curUiBase = father;
        this.m_curUiBase.m_curstate = this;
        if (this.m_buttonlist.size() == 0) {
            return false;
        }
        this.m_key = this.m_buttonlist.begin();
    },


    // 设置当前选择节点

    setCurKey:function(node)
    {
        this.m_buttonlist.each( function( k , data ){
            if( data.node.getName() === node.getName() )
            {
                this.m_key = data;
                return ;
            }
        } , this );

    },

    setCurKey_byName:function(name)
    {
        this.m_buttonlist.each( function( k , data ){
            if( data.node.getName() == name )
            {
                this.m_key = data;
                return ;
            }
        } , this );

    },

    shutdown: function () {

    },

    loop: function ( t ) {

        if (this.m_key == null) {
            return;
        }
        if (this.m_key.node.isVisible()) {
            for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
                var nodeinfo = this.m_buttonlist.getData(i);


                if (nodeinfo.getChexButton() == this.m_key.getChexButton())
                {
                    this.m_key.getChexButton().setSelected(true);
                    var pButtonImageView = ccui.helper.seekWidgetByName(nodeinfo.getChexButton(), "uitexiao");
                    if (pButtonImageView != null)
                    {
                        pButtonImageView.setVisible(true);
                    }
                }
                else
                {
                    nodeinfo.getChexButton().setSelected(false);
                    var pButtonImageView = ccui.helper.seekWidgetByName(nodeinfo.getChexButton(), "uitexiao");
                    if (pButtonImageView != null) {
                        pButtonImageView.setVisible(false);
                    }
                }
            }

        }
        else {
            var retkey = this.m_buttonlist.getnext(this.m_key.id);
            if (retkey != null) {
                this.m_key = retkey;
            }
        }
    },

    isCurBaseKeyState: function () {
    },

    regNode: function (rootnode, pos, pianyi) {
        if (!rootnode) {
            return;
        }
        //noinspection JSUnresolvedFunction
        var info = new NodeInfo();
        info.name = rootnode.getName();
        info.node = rootnode;
        info.pianchapos = pianyi;
        info.type = 2;
        info.id = pos;
        this.m_buttonlist.put(pos, info);
    },

    regNodeEx: function (rootnode, pos, pianyi, Movetype) {

        if ( !rootnode )
        {
            console.log( "error regNodeEx" );
            return false;
        }

        if(rootnode.isVisible() == false)
        {
            console.log( "error regNodeEx  rootnode.isVisible()" );
            return false;
        }


        if (Movetype == null) {
            Movetype = 0;
        }

        if (pianyi == null) {
            pianyi = cc.p(0, 0);
        }
        var pButtonImageView = ccui.helper.seekWidgetByName(rootnode, "uitexiao");
        if (pButtonImageView != null) {
            pButtonImageView.setVisible(false);
        }

        var info = new NodeInfo();
        info.name = rootnode.getName();
        info.node = rootnode;
        info.pianchapos = pianyi;
        if (rootnode) {
            info.type = 1;
        }
        info.id = pos;
        info.Movetype = Movetype;
        this.m_buttonlist.put(pos, info);

        return true;
    },

    left: function () {
        this.m_move = true;
        var it_buffnext = null;
        var des = 1000000;
        var left = cc.p(-1, 0);

        musicMgr.getMe().playeffect(g_buttonChangeMp3);

        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);

            if (this.m_key == nodeinfo) {
                continue;
            }
            if (nodeinfo.node.isVisible() == false) {
                continue;
            }
            var f_itx = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
            var f_curx = this.m_key.node.convertToWorldSpace(cc.p(0, 0));

            //if (Math.abs(f_curx.y - f_itx.y) > 500) {
            //    continue;
            //}

            if (f_itx.x < f_curx.x) {
                if (f_curx.x - f_itx.x > 0) {
                    //var nowdis = f_curx.x - f_itx.x;
                    //var nowdis = cc.pDistance(f_itx, f_curx);
                    if (cc.pAngle(cc.pSub(f_itx, f_curx), left) < 0.3) {
                        var nowdis = cc.pDistance(f_itx, f_curx);
                        if (nowdis < des) {
                            des = nowdis;
                            it_buffnext = nodeinfo;
                        }
                    }
                }
            }
        }


        if (it_buffnext != null) {
            this.m_key = it_buffnext
            if (!this.m_key.node.isTouchEnabled()) {
                return this.left();
            }

            if (this.m_key.node.isVisible() == false || this.m_key.node.getParent().isVisible() == false) {
                return this.left();
            }
        }
        else {
            return false;
        }

    },
    right: function () {
        this.m_move = true;
        var it_buffnext = null;
        var des = 1000000;
        var right = cc.p(1, 0);
        musicMgr.getMe().playeffect(g_buttonChangeMp3);
        ///this.m_buttonlist.each( function(pos,nodeinfo,index)
        //{
        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);
            if (this.m_key == nodeinfo) {
                continue;
            }
            if (nodeinfo.node.isVisible() == false || nodeinfo.node.getParent().isVisible() == false) {
                continue;
            }
            var f_itx = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
            var f_curx = this.m_key.node.convertToWorldSpace(cc.p(0, 0));

            //if (Math.abs(f_curx.y - f_itx.y) > 500) {
            //    continue;
            //}

            if (f_itx.x > f_curx.x) {
                if (f_itx.x - f_curx.x > 0) {
                    //var nowdis = f_itx.x - f_curx.x;
                    if (cc.pAngle(cc.pSub(f_itx, f_curx), right) < 0.3) {
                        var nowdis = cc.pDistance(f_itx, f_curx);
                        if (nowdis < des) {
                            des = nowdis;
                            it_buffnext = nodeinfo;
                        }
                    }
                }
            }
        }


        if (it_buffnext != null) {
            this.m_key = it_buffnext;
            if (this.m_key.node.isVisible() == false || this.m_key.node.getParent().isVisible() == false) {
                return this.right();
            }

            if (!this.m_key.node.isTouchEnabled()) {
                return this.right();
            }
        }
        else {
            return false;
        }
        return true;
    },
    up: function () {
        this.m_move = true;
        var it_buffnext = null;
        var up = cc.p(0, 1);
        var des = 1000000;
        musicMgr.getMe().playeffect(g_buttonChangeMp3);
        // this.m_buttonlist.each( function(pos,nodeinfo,index)
        // {
        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);
            if (this.m_key == nodeinfo) {
                continue;
            }
            if (nodeinfo.node.isVisible() == false ||
                nodeinfo.node.getParent().isVisible() == false ||
                nodeinfo.isTouchEnable() == false) {
                continue;
            }

            var f_ity = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
            var f_cury = this.m_key.node.convertToWorldSpace(cc.p(0, 0));


            if (f_ity.y > f_cury.y) {
                if (cc.pAngle(cc.pSub(f_ity, f_cury), up) < 0.8) {
                    var nowdis = cc.pDistance(f_ity, f_cury);
                    if (nowdis < des) {
                        des = nowdis;
                        it_buffnext = nodeinfo;
                    }
                }
            }
        }

        if (it_buffnext != null) {
            this.m_key = it_buffnext;
            if (this.m_key.node.isVisible() == false || this.m_key.node.getParent().isVisible() == false) {
                return this.up();
            }
            if (!this.m_key.node.isTouchEnabled()) {
                return this.up();

            }

        }
        else {
            return false;
        }

        return true;
    },
    down: function () {
        this.m_move = true;
        var it_buffnext = null;
        var down = cc.p(0, -1);
        var des = 1000000;
        musicMgr.getMe().playeffect(g_buttonChangeMp3);
        //NvngItemData * ret = NULL;
        //this.m_buttonlist.each( function(pos,nodeinfo,index)
        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);

            if (this.m_key == nodeinfo) {
                continue;
            }
            if (nodeinfo.node.isVisible() == false ||
                nodeinfo.node.getParent().isVisible() == false ||
                nodeinfo.isTouchEnable() == false) {
                continue;
            }
            var f_ity = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
            var f_cury = this.m_key.node.convertToWorldSpace(cc.p(0, 0));


            if (f_ity.y < f_cury.y) {
                if (cc.pAngle(cc.pSub(f_ity, f_cury), down) < 0.9) {
                    var nowdis = cc.pDistance(f_ity, f_cury);
                    if (nowdis < des) {
                        des = nowdis;
                        it_buffnext = nodeinfo;
                    }
                }
            }
        }

        if (it_buffnext != this.m_buttonlist.end()) {
            this.m_key = it_buffnext;
            if (this.m_key.node.isVisible() == false || this.m_key.node.getParent().isVisible() == false) {
                return this.down();
            }

            if (!this.m_key.node.isTouchEnabled()) {
                return this.down();
            }
        }
        else {
            return false;
        }

        return true;
    },

    DoEnterCurButton: function () {
        if (this.m_buttonlist.size() == 0) {
            return false;
        }
        if (this.m_key != this.m_buttonlist.end()) {
            var node_ui = this.m_key.node;
            if (cc.sys.isNative) {
                var ccp = node_ui.convertToWorldSpaceAR(cc.p(0, 0));
                var ccpx = cc.director.convertToUI(ccp);
                var handleTouches = new cc.Touch(0, ccpx.x, ccpx.y);
                var touchEvent = new cc.EventTouch([handleTouches]);
                touchEvent._eventCode = cc.EventTouch.EventCode.ENDED;
                touchEvent.setEventCode(touchEvent._eventCode);
                var touchEvent_begin = new cc.EventTouch([handleTouches]);
                touchEvent_begin._eventCode = cc.EventTouch.EventCode.BEGAN;
                touchEvent_begin.setEventCode(touchEvent_begin._eventCode);
                cc.eventManager.dispatchEvent(touchEvent_begin);
                cc.eventManager.dispatchEvent(touchEvent);
            }
            else {
                var ccp = node_ui.convertToWorldSpaceAR(cc.p(0, 0));
                var handleTouches = new cc.Touch(ccp.x, ccp.y);
                handleTouches._setPrevPoint(ccp.x, ccp.y);
                var touchEvent = new cc.EventTouch([handleTouches]);
                touchEvent._eventCode = cc.EventTouch.EventCode.ENDED;
                var touchEvent_begin = new cc.EventTouch([handleTouches]);
                touchEvent_begin._eventCode = cc.EventTouch.EventCode.BEGAN;
                cc.eventManager.dispatchEvent(touchEvent_begin);
                cc.eventManager.dispatchEvent(touchEvent);
            }

            return true;
        }
        return false;
    },

    getCurBttonPos: function () {
        //return this.m_key.node.convertToWorldSpace(cc.p(0, 0));
        return this.m_key.node.getWorldPosition();
    },


});

//通过配置表来确定上下左右顺序
var BaseKeyState_ui_config = BaseKeyState.extend({

    m_ui_configname: null,
    ctor: function () {
        this._super();
    },

    setUIName: function (name) {
        this.m_ui_configname = g_uiKeyLogic[name];
    },

    left: function () {
        this.m_move = true;
        musicMgr.getMe().playeffect(g_buttonChangeMp3);
        var name = this.m_key.getName();
        var nodekeyinfo = this.m_ui_configname[name];
        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);
            if (nodekeyinfo["left"] == nodeinfo.getName()) {
                this.m_key = nodeinfo;
                return true;
            }
        }
        return false;
    },
    right: function () {
        this.m_move = true;
        musicMgr.getMe().playeffect(g_buttonChangeMp3);
        var name = this.m_key.getName();
        var nodekeyinfo = this.m_ui_configname[name];
        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);
            if (nodekeyinfo["right"] == nodeinfo.getName()) {
                this.m_key = nodeinfo;
                return true;
            }
        }
        return false;
    },
    up: function () {
        this.m_move = true;
        musicMgr.getMe().playeffect(g_buttonChangeMp3);
        var name = this.m_key.getName();
        var nodekeyinfo = this.m_ui_configname[name];
        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);
            if (nodekeyinfo["up"] == nodeinfo.getName()) {
                this.m_key = nodeinfo;
                return true;
            }
        }
        return false;
    },
    down: function () {
        this.m_move = true;
        musicMgr.getMe().playeffect(g_buttonChangeMp3);
        var name = this.m_key.getName();
        var nodekeyinfo = this.m_ui_configname[name];
        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);
            if (nodekeyinfo["down"] == nodeinfo.getName()) {
                this.m_key = nodeinfo;
                return true;
            }
        }
        return false;
    },

    loop: function (t) {
        this._super(t);
    }
});


var BaseKeyState_config = BaseKeyState.extend({

    ctor: function () {
        this._super();
    },

    regNode_config: function (rootnode, pos, left_pos, right_pos, up_pos, down_pos, Movetype, pianyi) {
        if (!rootnode) {
            return;
        }
        if (Movetype == null) {
            Movetype = 0;
        }
        if (pianyi == null) {
            pianyi = cc.p(0, 0);
        }
        var pButtonImageView = ccui.helper.seekWidgetByName(rootnode, "uitexiao");
        if (pButtonImageView != null) {
            pButtonImageView.setVisible(false);
        }

        var info = new NodeInfo();
        info.name = rootnode.getName();
        info.node = rootnode;

        info.left_pos = left_pos;
        info.right_pos = right_pos;
        info.up_pos = up_pos;
        info.down_pos = down_pos;

        info.pianchapos = pianyi;
        if (rootnode) {
            info.type = 1;
        }

        info.id = pos;
        info.Movetype = Movetype;
        this.m_buttonlist.put(pos, info);

    },

    left: function () {
        var ret = this.m_buttonlist.getDataByKey(this.m_key.left_pos);
        if (ret) {
            this.m_key = ret;
            return true;
        }
        return false;
    },
    right: function () {
        var ret = this.m_buttonlist.getDataByKey(this.m_key.right_pos);
        if (ret) {
            this.m_key = ret;
            return true;
        }
        return false;
    },
    up: function () {
        var ret = this.m_buttonlist.getDataByKey(this.m_key.up_pos);
        if (ret) {
            this.m_key = ret;
            return true;
        }
        return false;
    },
    down: function () {
        var ret = this.m_buttonlist.getDataByKey(this.m_key.down_pos);
        if (ret) {
            this.m_key = ret;
            return true;
        }
        return false;
    },


});


var CGeziKeyState_list_h = BaseKeyState.extend({
    m_ScrollView: null,
    m_disVal: 300,
    ctor: function () {
        this._super();
    },

    loop: function (t) {
        this._super(t);


        return;
    },
    getPercentHorizontal: function () {
        var offsetX = this.m_ScrollView.getInnerContainer().getPositionX();
        var w = this.m_ScrollView.getInnerContainerSize().width - this.m_ScrollView.getContentSize().width;
        return -(offsetX / w * 100);
    }
});

var CGeziKeyState_list_v = BaseKeyState.extend({
    m_ScrollView: null,
    m_disVal: 30,
    ctor: function ()
    {
        this._super();
    },


    init: function (father) {
        this._super( father );
    },

    getCurBttonPos: function ()
    {
        return this.m_key.node.getWorldPosition();
    },

    loop: function (t)
    {
        this._super(t);


        var shouzhipos = this.getCurBttonPos();


        var visibleSize = this.m_ScrollView.getContentSize() ;

        //var  ScrollView_centerPos = this.m_ScrollView.getWorldPosition();

        var rHeight = visibleSize.height / 2 * uiMgr.getMe().getUiScale();



        if ( this.m_ScrollView.getDirection() == cc.SCROLLVIEW_DIRECTION_VERTICAL )
        {

            var dis = Math.abs( shouzhipos.y - rHeight );

            dis  = dis +  this.m_disVal  *  uiMgr.getMe().getUiScale() ;

            if ( dis > rHeight  )
            {
                if ( shouzhipos.y < rHeight )
                {
                    var w = this.m_ScrollView.getInnerContainerSize().height - this.m_ScrollView.getContentSize().height;
                    var h = -w;
                    var speed = w / 80;
                    speed = Math.max(speed, 150);
                    speed = speed / 2;
                    var per = this.getPercentVertical();
                    per = per - t * speed;
                    per = 100 - per;
                    if(per > 100){
                        per = 100;
                    }
                    this.m_ScrollView.jumpToPercentVertical(per);
                }
                else
                {
                    var w = this.m_ScrollView.getInnerContainerSize().height - this.m_ScrollView.getContentSize().height;
                    var h = -w;
                    var speed = w / 80;
                    speed = Math.max(speed, 150);
                    speed = speed / 2;
                    var per = this.getPercentVertical();
                    per = per + t * speed;
                    per = 100 - per;
                    if(per < 0){
                        per = 0;
                    }
                    this.m_ScrollView.jumpToPercentVertical(per);
                }
            }
        }

        return;
    },
    getPercentVertical: function () {
        var w = this.m_ScrollView.getInnerContainerSize().height - this.m_ScrollView.getContentSize().height;
        w = -w;
        var offsetY = this.m_ScrollView.getInnerContainer().getPositionY();
        return (offsetY / w * 100);
    },

    initSort: function () {
        this.m_key = this.m_buttonlist.begin();

        for (var i = 0; i < this.m_buttonlist.getSize(); i++) {
            var nodeinfo = this.m_buttonlist.getData(i);

            var f_ity = nodeinfo.node.convertToWorldSpace(cc.p(0, 0));
            var f_cury = this.m_key.node.convertToWorldSpace(cc.p(0, 0));


            if (f_ity.y > f_cury.y) {
                this.m_key = nodeinfo;
            }
        }

    }
});