/**
 * Created by cy1234 on 2015/12/28.
 */



//   ui


var uiMgr = cc.Layer.extend({

    m_UiMap: null,
    _topUiBase: null,
    ctor: function () {
        this.m_UiMap = new ArrayEx();
        this._super();
        // var winSize = cc.director.getWinSize();
    },

    getUiScale_720: function () {
        var winSize = cc.director.getWinSize();

        var widthper = winSize.width / 1280.0;
        var heightper = winSize.height / 720.0;

        if ( widthper > heightper ) {
            return heightper;
        }
        else {
            return widthper;
        }
    },
    getUiScale: function () {
        var winSize = cc.director.getWinSize();

        var widthper = winSize.width / 1280.0;
        var heightper = winSize.height / 768.0;

        if ( widthper > heightper ) {
            return heightper;
        }
        else {
            return widthper;
        }

        //
        //if (winSize.width < 1280) {
        //    var widthper = winSize.width / 1280.0;
        //    var heightper = winSize.height / 768.0;
        //
        //    if (widthper > heightper) {
        //        return heightper;
        //    }
        //    else {
        //        return widthper;
        //    }
        //
        //}
        //else if (winSize.width > 1280) {
        //    var widthper = winSize.width / 1280.0;
        //    var heightper = winSize.height / 768.0;
        //
        //    if (widthper > heightper) {
        //        return heightper;
        //    }
        //    else {
        //        return widthper;
        //    }
        //}
        //return 1;

    },
    shutdownAllUi: function () {
        this.show_ui_jingjichang(false);
        this.show_ui_fight(false);
        this.show_ui_map(false);
        this.show_ui_MessageBox(false);
        this.show_ui_qiandao(false);
        this.show_ui_root(false);
        this.show_ui_zanting(false);
        this.show_ui_selectSkill(false);
        this.show_ui_shibai_shengli(false);
        this.show_ui_select_monster(false);
        this.show_ui_select_monster_two(false);
        this.show_ui_select_player(false);
        this.show_ui_xuanzechuzhan(false);
        this.show_ui_renwujiemian(false);
        this.show_ui_renwushengji(false);
        this.show_ui_jinengshengji(false);
        this.show_ui_zhuangbeishengji(false);
        this.show_ui_chengjiu(false);
        this.show_ui_guaji(false);
        this.show_ui_shop(false);
    },

    adduibase: function (data) {
        this.m_UiMap.put(data);
    },

    deleteuibase: function (data) {
        this.m_UiMap.remove(data);
    },

    removeChild: function (child, cleanup) {
        if (cleanup == null) {
            cleanup = true;
        }
        this._super(child, cleanup);
        this.updateBaseUi_OTT_key();
    }
    ,

    addChild: function (child, localZOrder, tag) {
        //  console.log(" uimgr addChild: localZOrder:" + localZOrder + "tag:" + tag  );
        if (localZOrder == null) {
            localZOrder = 0;
        }

        if (tag == null) {
            tag = "";
        }
        this._super(child, localZOrder, tag);
        this.updateBaseUi_OTT_key();
    },

    updateBaseUi_OTT_key: function () {
        //console.log(" uimgr updateBaseUi_OTT_key:");
        var toplay = -1000;
        this._topUiBase = null;

        if (this.m_UiMap.size() == 0) {
            return;
        }
        if (this.m_UiMap.size() == 1) {
            var it = this.m_UiMap.begin();
            if (it != null) {
                this._topUiBase = it;
                //this._topUiBase.setTouchEnabled(true);
                console.log(" init _topUiBase:");
            }
            return;
        }
        for (var i = 0; i < this.m_UiMap.size(); ++i) {
            var l_uibase = this.m_UiMap.getData(i);
            //l_uibase.setTouchEnabled(false);
            if (!l_uibase.m_key_not_close) {
                continue;
            }

            if (l_uibase.getLocalZOrder() > toplay) {
                toplay = l_uibase.getLocalZOrder();
                this._topUiBase = l_uibase;
                //  this._topUiBase.setTouchEnabled(true);
            }
        }


    },

    onKeyPressed: function (keycode) //键盘按下
    {

        if (this._topUiBase == null) {
            this.updateBaseUi_OTT_key();
        }

        if (this._topUiBase == null) {
            //ui_fight.
            //
            //console.log("error uimgr onKeyPressed:  _topUiBase is null");
        }
        else {
            this._topUiBase.onKeyPressed(keycode);
        }


    },
    onKeyReleased: function (keycode)//键盘弹起
    {
        try {
            if (this._topUiBase == null) {
                //ui_fight.
            }
            else {
                this._topUiBase.onKeyReleased(keycode);
            }

        }
        catch (err) {
        }
    },
    showRootUI: function (flag) {
        return testui.create(flag);
    },


    show_ui_fangshouxuanze: function (flag, scenename) {
        return ui_fangshouxuanze.ShowOrHide(flag, scenename);
    },

    show_ui_login: function (flag) {
        return ui_login.ShowOrHide(flag);
    },

    show_ui_setting: function (flag) {
        return ui_setting.ShowOrHide(flag);
    },

    show_ui_selectPlayFight_jjc: function (flag) {
        return ui_selectPlayFight_jjc.ShowOrHide(flag);
    },


    show_ui_map: function (flag) {
        if (flag == true) {
            monsterAttMgr.getMe().initMap(false);
        }

        return ui_map.ShowOrHide(flag);
    },
    show_ui_MessageBoxExit: function (flag, text) {
        return ui_MessageBoxExit.ShowOrHide(flag, text);
    },
    show_ui_cdkey: function (flag) {
        return ui_cdkey.ShowOrHide(flag);
    },

    show_ui_cdkey_success: function (flag, data) {
        return ui_cdkey_success.ShowOrHide(flag, data);
    },

    //
    show_ui_zhanlingjiangli: function (flag) {
        return ui_zhanlingjiangli.ShowOrHide(flag);
    },

    show_ui_jingjichang_every_jiangli: function (flag) {
        return ui_jingjichang_every_jiangli.ShowOrHide(flag);
    },


    //
    show_ui_root: function (flag) {
        //return ui_rootApk.ShowOrHide(flag);
        if ((cc.sys.isNative && cc.sys.OS_WINDOWS == cc.sys.os) && fileMgr.getMe().m_xiangsu_info["root"]["winiap"]) {
            return ui_root.ShowOrHide(flag);
        } else {
            return ui_rootApk.ShowOrHide(flag);
        }
    },

    show_ui_shop: function (flag) {
        //return ui_shopApk.ShowOrHide(flag);
        if ((cc.sys.isNative && cc.sys.OS_WINDOWS == cc.sys.os) && fileMgr.getMe().m_xiangsu_info["root"]["winiap"]) {
            return ui_shop.ShowOrHide(flag);
        } else {
            return ui_shopApk.ShowOrHide(flag);
        }
    },

    show_ui_selectScene: function (flag) {
        return ui_selectScene.ShowOrHide(flag);
    },

    show_ui_renwujiemian: function (flag) {
        return ui_renwujiemian.ShowOrHide(flag);
    },
    show_ui_fight: function (flag) {
        return ui_fight.ShowOrHide(flag);
    },

    show_ui_fight_tips: function (flag) {
        return ui_fight_tips.ShowOrHide(flag);
    },

    show_ui_MessageBox: function (flag, text, func_ok, cansel_func, ponit) {
        return ui_MessageBox.ShowOrHide(flag, text, func_ok, cansel_func, ponit);
    },

    show_ui_MessageBox_exit: function (flag, text, func_ok, cansel_func, ponit) {
        return ui_MessageBox_exit.ShowOrHide(flag, text, func_ok, cansel_func, ponit);
    },

    show_ui_pay_queren: function (flag, id, shangpingid) {
        return ui_pay_queren.ShowOrHide(flag, id, shangpingid);
    },
    show_ui_MessageBox2: function (flag, text, func_ok, ponit) {
        return ui_MessageBox2.ShowOrHide(flag, text, func_ok, ponit);
    },
    show_ui_chuzhantankuang: function (flag, text, name) {
        return ui_chuzhantankuang.ShowOrHide(flag, text, name);
    },
    show_ui_chuzhanwuqitankuang: function (flag, name, text) {
        return ui_chuzhanwuqitankuang.ShowOrHide(flag, name, text);
    },
    show_ui_juqing: function (flag, name, text, headpic, func_ok, ponit) {
        return ui_juqing.ShowOrHide(flag, name, text, headpic, func_ok, ponit);
    },
    show_ui_wofanghuihetexiao: function (flag) {
        return ui_wofanghuihetexiao.ShowOrHide(flag);
    },

    show_ui_difanghuihetexiao: function (flag) {

        return ui_difanghuihetexiao.ShowOrHide(flag);
    },

    // 竞技场暂停
    show_ui_zanting_jingjichang: function (flag) {
        return ui_zanting_jingjichang.ShowOrHide(flag);
    },

    show_ui_zanting: function (flag) {

        if (sceneMgr.getMe().getCurSceneType() == g_SceneType.SceneType_arena) {
            return this.show_ui_zanting_jingjichang(flag);
        }
        return ui_zanting.ShowOrHide(flag);
    },
    show_ui_qiandao: function (flag, data) {
        return ui_qiandao.ShowOrHide(flag, data);
    },
    show_ui_selectSkill: function (flag) {
        return ui_selectSkill.ShowOrHide(flag);
    },
    show_ui_renwushengji: function (flag, heroname) {
        return ui_renwushengji.ShowOrHide(flag, heroname);
    },
    show_ui_jinengshengji: function (flag, heroname) {
        return ui_jinengshengji.ShowOrHide(flag, heroname);
    },
    show_ui_zhuangbeishengji: function (flag, heroname) {
        return ui_zhuangbeishengji.ShowOrHide(flag, heroname);
    },
    show_ui_shibai_shengli: function (flag, win) {
        return ui_shibai_shengli.ShowOrHide(flag, win);
    },
    show_ui_shibai_shengli_fangshou: function (flag, win) {
        return ui_shibai_shengli_fangshou.ShowOrHide(flag, win);
    },

    show_ui_shibai_shengli_jingjichang: function (flag, win) {
        return ui_shibai_shengli_jingjichang.ShowOrHide(flag, win);
    },


    show_ui_select_player: function (flag) {
        return ui_select_player.ShowOrHide(flag);
    },
    show_ui_select_monster: function (flag) {
        return ui_select_monster.ShowOrHide(flag);
    },
    show_ui_select_monster_two: function (flag) {
        return ui_select_monster_two.ShowOrHide(flag);
    },
    show_ui_playOnce: function (layout, animation, callFunc, father, pos) {
        return ui_PlayAinamationOnce.create(layout, animation, callFunc, father, pos);
    },
    show_ui_xuanzechuzhan: function (flag, _scenename_zhuxian, _scenename_zhixian, ismonster) {
        if (ismonster == null) {
            ismonster = false;
        }
        return ui_xuanzechuzhan.ShowOrHide(flag, _scenename_zhuxian, _scenename_zhixian, ismonster);
    },
    show_ui_selectRoad: function (flag, _scenename) {
        return ui_selectRoad.ShowOrHide(flag, _scenename);
    },

    show_ui_show_zuanshi_gold: function (flag) {

        return ui_show_zuanshi_gold.ShowOrHide(flag);

    },

    updateGoldandDiamonds: function () {

        if (ui_show_zuanshi_gold.getMe()) {
            ui_show_zuanshi_gold.getMe().updateDiamondsAndGold();
        }
    },

    show_ui_chengjiu: function (flag) {
        return ui_chengjiu.ShowOrHide(flag);
    },
    show_zuixinhuodong: function (flag) {
        return zuixinhuodong.ShowOrHide(flag);
    },
    show_ui_everytask: function (flag) {
        return ui_everytask.ShowOrHide(flag);
    },

    show_ui_xuanzerenwuchengjiu: function (flag) {
        return ui_xuanzerenwuchengjiu.ShowOrHide(flag);
    },

    show_ui_jingjichang: function (flag) {
        return ui_jingjichang.ShowOrHide(flag);
    },

    show_ui_xinshoulibao: function (flag) {
        return ui_xinshoulibao.ShowOrHide(flag);
    },


    show_ui_yueka: function (flag) {
        return ui_yueka.ShowOrHide(flag);
    },

    show_ui_autoDownload: function (flag) {
        return ui_autoDownload.ShowOrHide(flag);
    },

    show_ui_jingjichangjiangli: function (flag) {
        return ui_jingjichangjiangli.ShowOrHide(flag);
    },
    show_ui_vipshuoming: function (flag) {
        return ui_vipshuoming.ShowOrHide(flag);
    },
    show_ui_guaji: function (flag) {
        return ui_guaji.ShowOrHide(flag);
    },

    //游戏启动的时候播放启动视频
    show_ui_MoviePlayer_startGame: function (flag, mp4, func, point) {
        return ui_MoviePlayer_startGame.ShowOrHide(flag, mp4, func, point);
    },

    show_MoviePlayerMgr: function (flag, mp4, func, point) {
        return MoviePlayerMgr.ShowOrHide(flag, mp4, func, point);
    },

    loop: function (t) {
        this.m_UiMap.each(function (it) {
            it.loop(t);
        });
    },

});

uiMgr.getMe = function () {
    return uiMgr.create();
};

uiMgr.create = function () {
    if (uiMgr.g_uiMgr == null) {
        uiMgr.g_uiMgr = new uiMgr();

        return uiMgr.g_uiMgr;
    }
    else {
        return uiMgr.g_uiMgr;
    }

};







