/**
 * Created by Allen on 2016/7/11.
 */

//升级装备和技能时英雄等级不足提示购买大瓶药水升级
//直接喝掉药水
var levelUpHeroMgr = cc.Class.extend({
    _heroname: null,
    m_funcCallback: null,

    confirmLevelUp: function (heroname, funcCallback) {

        if (heroname == null) {
            return;
        }

        this._heroname = heroname;
        this.m_funcCallback = null;
        if (funcCallback) {
            this.m_funcCallback = funcCallback;
        }

        var bigPotionInfo = DataMgr.getMe().getItemInfo("bigPotion");
        var needgold = bigPotionInfo.needgold * 10;
        var needdiamond = bigPotionInfo.needdiamond * 10;
        if (needgold) {
            if (needgold <= DataMgr.getMe().getgold()) {
                var tishi = "等级不足！是否消耗" + needgold + "金币购买10瓶" + bigPotionInfo.name +"补充等级？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.buyBigPotion_callback, null, this);
            } else {
                var tishi = "等级不足！是否花费" + iapMgr.getMe().getDefaultGoldPrice() + "购买" +
                    iapMgr.getMe().getUseGoldDefaultLibao() + "金币？购买10瓶" + bigPotionInfo.name +"需要" + needgold +"金币。";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_jinbi_and_shengji, null, this);
            }
        } else if (needdiamond) {
            if (needdiamond <= DataMgr.getMe().getzuanshi()) {
                var tishi = "等级不足！是否消耗" + needdiamond + "勋章购买10瓶" + bigPotionInfo.name +"补充等级？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.buyBigPotion_callback, null, this);
            } else {
                var tishi = "等级不足！是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() + "购买" +
                    iapMgr.getMe().getUseDiamondsDefaultLibao() + "勋章？购买10瓶" + bigPotionInfo.name +"需要" + needdiamond +"勋章。";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_zuanshi_and_shengji, null, this);
            }
        }
    },


    buyBigPotion_callback: function () {
        var bigPotionInfo = DataMgr.getMe().getItemInfo("bigPotion");
        var needgold = bigPotionInfo.needgold * 10;
        var needdiamond = bigPotionInfo.needdiamond * 10;
        var addExp = bigPotionInfo.addexp * 10;

        if(needgold){
            if( needgold <= DataMgr.getMe().getgold()){
                if(DataMgr.getMe().removeGold(needgold)){
                    this.addHeroExp(addExp);
                }
            }
        }else if(needdiamond){
            if( needdiamond <= DataMgr.getMe().getzuanshi()){
                if(DataMgr.getMe().removeZuanshi(needdiamond)){
                    this.addHeroExp(addExp);
                }
            }
        }
        everyTaskMgr.getMe().yaoshui_task("bigPotion", 10);
        uiMgr.getMe().show_ui_playOnce("goumaichenggong.json","play");

    },


    addHeroExp: function (addExp) {
        if(DataMgr.getMe().addcurexp(this._heroname, addExp)){
            if (this.m_funcCallback) {
                this.m_funcCallback.execute();
            }

            this.m_funcCallback = null;

        }
    },

    goumai_jinbi_and_shengji: function () {
        var callback_func = MyCallback.create(this.buyBigPotion_callback, this, null);
        iapMgr.getMe().useGoldDefaultLibao(callback_func);
    },


    goumai_zuanshi_and_shengji: function () {
        var callback_func = MyCallback.create(this.buyBigPotion_callback, this, null);
        iapMgr.getMe().useDiamondsDefaultLibao(callback_func);
    },

});

levelUpHeroMgr.getMe = function () {
    return levelUpHeroMgr.create();
};

levelUpHeroMgr.create = function () {
    if (levelUpHeroMgr.g_ins == null) {
        levelUpHeroMgr.g_ins = new levelUpHeroMgr();
        return levelUpHeroMgr.g_ins;
    }
    else {
        return levelUpHeroMgr.g_ins;
    }

};