/**
 * Created by Allen on 2016/7/11.
 */

//升级技能
var levelUpSkillMgr = cc.Class.extend({
    _heroname: null,
    _skillname: null,
    m_funcCallback: null,

    levelUp: function (heroname, skillname, funcCallback) {
        if (heroname == null || skillname == null) {
            return;
        }

        this._heroname = heroname;
        this._skillname = skillname;
        this.m_funcCallback = null;
        if (funcCallback) {
            this.m_funcCallback = funcCallback;
        }

        if (DataMgr.getMe().getHeroIsLocked(this._heroname)) {
            uiMgr.getMe().show_ui_MessageBox(true, "英雄未解锁！");
            return;
        }

        if (DataMgr.getMe().isSkillMaxLevel(this._heroname, this._skillname)) {
            uiMgr.getMe().show_ui_MessageBox(true, "该技能已经满级！");
            return;
        }

        var herolevel = DataMgr.getMe().getLevel(this._heroname);
        var skilllevel = DataMgr.getMe().getSkillLevel(this._heroname, this._skillname);
        if (skilllevel * 5 > herolevel) {
            levelUpHeroMgr.getMe().confirmLevelUp(heroname, funcCallback);
            return;

        }

        var money = DataMgr.getMe().getSkillLevelMoney(this._heroname, this._skillname);
        var needgold = money[0];
        var needdiamond = money[1];
        if (needgold) {
            if (needgold <= DataMgr.getMe().getgold()) {
                //var tishi = "是否消耗" + needgold + "金币升级技能？";
                //uiMgr.getMe().show_ui_MessageBox(true, tishi, this.shengji_callback, null, this);
                this.shengji_callback();
            } else {
                var tishi = "金币不足，是否花费" + iapMgr.getMe().getDefaultGoldPrice() + "购买" + iapMgr.getMe().getUseGoldDefaultLibao() + "金币？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_jinbi_and_shengji, null, this);
            }
        } else if (needdiamond) {
            if (needdiamond <= DataMgr.getMe().getzuanshi()) {
                //var tishi = "是否消耗"+ needdiamond + "勋章升级技能？";
                //uiMgr.getMe().show_ui_MessageBox(true, tishi, this.shengji_callback, null, this);
                this.shengji_callback();
            } else {
                var tishi = "勋章不足，是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() + "购买" + iapMgr.getMe().getUseDiamondsDefaultLibao() + "勋章？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_zuanshi_and_shengji, null, this);
            }
        }
    },

    goumai_jinbi_and_shengji: function () {
        var callback_func = MyCallback.create(this.shengji_callback, this, null);
        iapMgr.getMe().useGoldDefaultLibao(callback_func);
    },

    goumai_zuanshi_and_shengji: function () {
        var callback_func = MyCallback.create(this.shengji_callback, this, null);
        iapMgr.getMe().useDiamondsDefaultLibao(callback_func);
    },

    shengji_callback: function () {
        var money = DataMgr.getMe().getSkillLevelMoney(this._heroname, this._skillname);
        var needgold = money[0];
        var needdiamond = money[1];
        if (needgold && needgold <= DataMgr.getMe().getgold()) {
            if (DataMgr.getMe().removeGold(needgold)) {
                this.shengjichenggong();
            }
        } else if (needdiamond && needdiamond <= DataMgr.getMe().getzuanshi()) {
            if (DataMgr.getMe().removeZuanshi(needdiamond)) {
                this.shengjichenggong();
            }
        }
    },

    shengjichenggong: function () {
        if (DataMgr.getMe().addSkillLevel(this._heroname, this._skillname)) {
            if (this.m_funcCallback) {
                this.m_funcCallback.execute();
            }

            this.m_funcCallback = null;

            uiMgr.getMe().show_ui_playOnce("shengjichenggong.json", "play");
            chengjiuMgr.getMe().jinengshengji();
        }
    },

});

levelUpSkillMgr.getMe = function () {
    return levelUpSkillMgr.create();
};

levelUpSkillMgr.create = function () {
    if (levelUpSkillMgr.g_ins == null) {
        levelUpSkillMgr.g_ins = new levelUpSkillMgr();
        return levelUpSkillMgr.g_ins;
    }
    else {
        return levelUpSkillMgr.g_ins;
    }

};