/**
 * Created by Allen on 2016/5/25.
 */

var unLockSkillMgr = cc.Class.extend({
    _heroname: "",
    _skillname: "",
    m_funcCallback: null,
    ctor: function () {

    },

    unLockSkill: function (heroname, skillname, funcCallback) {

        if(heroname == null || skillname == null){
            return;
        }

        this._heroname = heroname;
        this._skillname = skillname;
        this.m_funcCallback = null;
        if (funcCallback) {
            this.m_funcCallback = funcCallback;
        }

        var herolevel = DataMgr.getMe().getLevel(heroname);
        var requirelevel = DataMgr.getMe().getunLockSkillRequireLevel(heroname,skillname);
        if(herolevel  < requirelevel){
            uiMgr.getMe().show_ui_MessageBox(true, "英雄等级未达到"+ requirelevel + "级,不能解锁该技能！");
            return;
        }
        var money = DataMgr.getMe().getunLockSkillMoney(heroname,skillname);
        var needgold = money[0];
        var needdiamond = money[1];
        if(needgold){
            if (needgold <= DataMgr.getMe().getgold()) {
                var tishi = "是否消耗" + needgold + "金币解锁技能？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.jiesuo_callback, null, this);
            } else {
                var tishi = "金币不足，是否花费" + iapMgr.getMe().getDefaultGoldPrice() + "购买" + iapMgr.getMe().getUseGoldDefaultLibao() +  "金币？解锁此英雄需要" + needgold + "金币。";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_jinbi_and_jiesuo, null, this);
            }
        }else if(needdiamond){
            if (needdiamond <= DataMgr.getMe().getzuanshi()) {
                var tishi = "是否消耗" + needdiamond + "勋章解锁技能？";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.jiesuo_callback, null, this);
            } else {
                var tishi = "勋章不足，是否花费" + iapMgr.getMe().getDefaultDiamondsPrice() + "购买" + iapMgr.getMe().getUseDiamondsDefaultLibao() +  "勋章？解锁此英雄需要" + needdiamond + "勋章。";
                uiMgr.getMe().show_ui_MessageBox(true, tishi, this.goumai_zuanshi_and_jiesuo, null, this);
            }
        }else{
            this.jiesuo_success();
        }

    },


    goumai_jinbi_and_jiesuo: function () {
        var  callback_func = MyCallback.create(this.jiesuo_callback, this, null);
        iapMgr.getMe().useGoldDefaultLibao(callback_func);
    },


    goumai_zuanshi_and_jiesuo: function () {
        var callback_func = MyCallback.create(this.jiesuo_callback, this, null);
        iapMgr.getMe().useDiamondsDefaultLibao(callback_func);
    },

    jiesuo_callback: function () {
        var money = DataMgr.getMe().getunLockSkillMoney(this._heroname, this._skillname);
        var needgold = money[0];
        var needdiamond = money[1];
        if(needgold && needgold <= DataMgr.getMe().getgold()){
            if (DataMgr.getMe().removeGold(needgold)) {
                this.jiesuo_success();
            }
        }else if(needdiamond && needdiamond <= DataMgr.getMe().getzuanshi()){
            if (DataMgr.getMe().removeZuanshi(needdiamond)) {
                this.jiesuo_success();
            }
        }
    },
    
    jiesuo_success: function () {
        if(DataMgr.getMe().unLockHeroSkill(this._heroname, this._skillname)){

            if (this.m_funcCallback) {
                this.m_funcCallback.execute();
            }
            this.m_funcCallback = null;

            uiMgr.getMe().show_ui_playOnce("jiesuochenggong.json", "play");
        }

    }
});

unLockSkillMgr.getMe = function () {
    return unLockSkillMgr.create();
};

unLockSkillMgr.create = function () {
    if (unLockSkillMgr.g_ins == null) {
        unLockSkillMgr.g_ins = new unLockSkillMgr();
        return unLockSkillMgr.g_ins;
    }
    else {
        return unLockSkillMgr.g_ins;
    }

};